#Not a class yet

init_history_C = function(x_i,
                          c_i,
                          Cf_mat,
                          Cfl_mat,
                          Cfr_mat,
                          precs = 100,
                          version_simp = TRUE,
                          precomputing_mdl = FALSE) {
  C_hist = create_h()
  E_cf = Cf_mat[c_i, ]
  
  N = length(E_cf)
  lconf = Cfl_mat[c_i, ]
  rconf = Cfr_mat[c_i, ]
  E_lcf = lconf
  E_rcf = rconf
  
  #Add delta to small values
  eq_cf = sort(E_cf)
  disturb = FALSE
  for (i in 2:length(eq_cf)) {
    if (eq_cf[i - 1] == eq_cf[i])
      disturb = TRUE
  }
  if (disturb) {
    for (i in 1:length(E_cf))
      E_cf[i] = E_cf[i] + i * 0.01
  }
  
  #Scale coefficients ----
  cf_orig = E_cf
  cf_c = E_cf
  
  N = length(cf_c)
  mn = min(lconf)  
  offset = ifelse(mn < 0, abs(mn),-mn)
  offset = offset
  cf_c = cf_c + offset
  lconf = lconf + offset
  rconf = rconf + offset  # [1,precs+1]
  
  shft = ifelse(precs > 1, 1, 0.1)
  if (abs(min(cf_c) - max(cf_c)) == 0)
    scale = 1 #special case all zero/zero diff.
  else
    scale = #(1/abs(min(cf_c) - max(cf_c)))*precs #
    (1 / abs(min(lconf) - max(rconf))) * precs
  
  cf_c = (cf_c * scale) + shft
  lconf = (lconf * scale) + shft
  rconf = (rconf * scale) + shft
  
  cf_ord = sort(cf_c)
  IDs = c(1:length(cf_c))
  order_by = order(cf_c, cf_ord)
  order_back = order(order_by, IDs[order_by])
  
  
  C_lcf = sort(lconf)
  C_rcf = sort(rconf)
  
  cf_null = cf_null_equi(c(1, 101), times = N)
  if (min(cf_ord) == 0 && max(cf_ord) == 0)
    cf_ord = cf_null
  
  n_groups = 1:N
  
  means_null = lapply(n_groups, function(g)
    means_null_equi(cf_null, g))#cf_null, g))
  
  one_group_part = rep(1, N)
  
  
  # Adapt precision ----
  sample = c()
  BINS = 8
  binned_interval = sapply(1:BINS, function(i)
    return((100 * i) / BINS))
  j = 0
  for (cf in cf_ord) {
    j  = j + 1
    df = abs(binned_interval - cf)
    i = which(df == min(df))
    if (length(i) > 1)
      i = i[1]
    sample[j] = binned_interval[i]
  }
  sample = sapply(sample, function(i)
    return(i / 10))
  
  # Coefficient Mean Errors ----
  sample = cf_ord
  k1_mean = min(sample) + abs(max(sample) - min(sample)) / 2
  
  k1_mse_mat = dispersion(1, k1_mean, sample)
  k1_mse = logg(sum_assignment_mat(1, k1_mse_mat, ceil = FALSE))
  # so far: k1_mse = logg(sum_assignment_mat(1, k1_mse_mat))
  ### k1_mse = logg(mses_part(cf_ord, one_group_part))
  
  k1_mse_lcf = logg(sum_assignment_mat(1, dispersion(1, k1_mean, C_lcf)))
  k1_mse_rcf = logg(sum_assignment_mat(1, dispersion(1, k1_mean, C_rcf)))
  
  
  #  Coefficient Mean Errors (not scaled) 
  sample_E =  sort(E_cf)
  k1_mean_E = min(sample_E) + abs(max(sample_E) - min(sample_E)) / 2
  k1_mse_mat_E = dispersion(1, k1_mean_E, sample_E)
  k1_mse_E = logg(sum_assignment_mat(1, k1_mse_mat_E) + 1) #here can be <1
  
  
  sample_E =  sort(E_lcf)
  k1_mean_E = min(sample_E) + abs(max(sample_E) - min(sample_E)) / 2
  k1_mse_mat_E = dispersion(1, k1_mean_E, sample_E)
  k1_mse_E_lcf = logg(sum_assignment_mat(1, k1_mse_mat_E) + 1) #here can be <1
  sample_E =  sort(E_rcf)
  k1_mean_E = min(sample_E) + abs(max(sample_E) - min(sample_E)) / 2
  k1_mse_mat_E = dispersion(1, k1_mean_E, sample_E)
  k1_mse_E_rcf = logg(sum_assignment_mat(1, k1_mse_mat_E) + 1) #here can be <1
  ###k1_mse_E = logg(mses_part(sort(E_cf), one_group_part))
  
  #---checks
  C_order = order_by
  E_order = order_back
  C_order_check = order(E_cf, cf_c)
  E_n = length(cf_c)
  E_ids = c(1:E_n)
  E_order_check = order(C_order, E_ids[C_order])
  sapply (1:E_n, function(i)
    assert(C_order[i] == C_order_check[i]))
  sapply (1:E_n, function(i)
    assert(E_order[i] == E_order_check[i]))
  #--
  
  #One-group partition k=1 ----
  # (only an MDL score needed, Elbow score only for k>1)
  #  cat(k1_mse,"\t")
  sig = 1
  L_loglik = -(-(E_n / 2) * logg(2 * pi * sig ^ 2) - 1 / (2 * sig ^ 2) * k1_mse)
  L_const = 0  
  
  #Option: no scaling at all
  #if(version_mdl_nscaled)
  #L_loglik = -(-(E_n/2)*logg(2*pi*sig^2) - 1/(2*sig^2) * k1_mse_E)
  #-----------
  #p = 9
  # L_alpha = logg(p) * 1#max(1-1,1)
  # L_pi = logg(choose(E_n-1,E_n-2)) + logg(E_n)
  #p = 2 
  #L_alpha = logg(p) * 0
  #L_pi = E_n * logg(E_n) + logg(E_n) 
 # L_model = L_alpha + L_pi + L_loglik + L_const
  #-----------
   
  #L_alpha =  logN(1)
  #L_pi = 0#E_n * logg(E_n) + logg(E_n)
  ##tried L_pi = logg(choose(E_n-1,E_n-2)) + logN(1) # + logg(E_n) # = E_n * logg(E_n) + logg(E_n)#
  ##tired L_pi =  E_n * logg(1) + logN(1) #logg(E_n)
  #L_const = 0 #TODO maybe incl
  #L_model = L_alpha + L_pi + L_loglik + L_const
  
   
  #  L_alpha = logN(3) + Inf#max(1-1,1)
  #   L_pi = log2nChoosek(E_n,1) + logN(1)
  ###max: base = 1.780921
  ##noise = 0.1 for 5:
  #base = 0.9713032
  
  
  #noise = 0.05
  #if(E_n > 7)  noise =0# 0.015 # noise = 0.035 works for k = 7, K=8 but not f k=2, K=8 # so far 0.02, works unless pi= 7, C =5, noise = 0.03 works unless sometimes pi = 8
  # if(!precomputing_mdl & !version_simp){
  #   noise =MXNOISE#maxnoise(E_n)
  #   precis = gen_pi_k_n(E_n = E_n, noise = noise)
  #   precis =mean(precis$pp, precis$p)
  #
  #   precis = 1.4#gen_pi_k_n_old(E_n = E_n, noise = 0)
  # }
  # else precis = 1 #irrelevant if precomputing
  #
  #Simp:
  if (version_simp)
    precis = logg(E_n) / 2
  else
    precis = 1
  #BINS:
  # precs <<- 2^(-logg(E_n/BINS)/2)
  
  #  precs <<- 2^(-logg(1/BINS))
  #BINS:
  ###precis =2^(-logg(E_n/25) / 2) #
  
  
  L_alpha = precis * 1 #max(1-1,1)
  L_pi =  E_n * logg(E_n) + logg(E_n)
  L_model = L_alpha + L_pi + L_loglik + L_const
  
  
  #Entries ----
  C_hist$mdl_one = L_model #accessed at the end of tree_search in pi_search
  
  C_hist$E_cf = E_cf
  C_hist$C_cf = cf_ord
  
  C_hist$E_lcf = E_lcf
  C_hist$E_rcf = E_rcf
  C_hist$C_lcf = C_lcf
  C_hist$C_rcf = C_rcf
  
  C_hist$C_cf_nscaled = sort(E_cf)
  C_hist$C_lcf_nscaled = sort(E_lcf)
  C_hist$C_rcf_nscaled = sort(E_rcf)
  C_hist$C_ord = order_by
  C_hist$E_ord = order_back
  
  C_hist$ci = c_i
  C_hist$xi = x_i
  C_hist$E_n = N
  C_hist$search_level = 1
  C_hist$seen_C_part = create_h()  #debug
  C_hist$seen_C_part[[paste(2)]] = list()  #debug, TODO entry for k=1?
  
  C_hist$K_best = create_h()
  C_hist$K_histories = create_h()
  
  C_hist$mse_1 = c(k1_mse)
  C_hist$mse_1_E = c(k1_mse_E)
  
  
  C_hist$lmse_1 = c(k1_mse_lcf)
  C_hist$rmse_1 = c(k1_mse_rcf)
  C_hist$lmse_1_E = c(k1_mse_E_lcf)
  C_hist$rmse_1_E = c(k1_mse_E_rcf)
  C_hist$scale = scale
  
  return(C_hist)
}



up_history_C = function(C_history, C_part, K_history) {
  E_part = K_history$E_part
  
  k = C_history$search_level
  k_up = length(unique(E_part))
  assert(k + 1 == k_up)
  
  E_part_nm = paste(E_part, collapse = "")
  C_part_nm = paste(C_part, collapse = "")
  C_history$K_histories[[E_part_nm]] = K_history
  C_history$seen_C_part[[paste(k_up)]][[C_part_nm]] = K_history  #debug to see search order.
  #C_history$search_level = k+1 not here, many k-partitions can be added.
  
  return(C_history)
  
}

next_lvl_history_C = function(C_history) {
  k = C_history$search_level
  if (k > 1)
    assert(length(C_history$K_best[[paste(k)]]$C_part) &
             length(C_history$K_best[[paste(k)]]$score))
  C_history$search_level = k + 1
  C_history$seen_C_part[[paste(k + 2)]] = list()  #debug
  return(C_history)
}

finalize_history_C = function(C_history) {
  xi = C_history$xi
  ci = C_history$ci
  k = C_history$search_level
  E_n = C_history$E_n
  assert(E_n == k)
  
  K_best  = C_history$K_best
  sapply(2:k, function(K)
    assert(paste(K) %in% ls(K_best)))
  C_history$K_best = list.sort(as.list(K_best) , score)
  
  s_kbest = sapply(2:k, function(k)
    return(C_history$K_best[[paste(k)]]$Pi_history$scores_X_C[[xi]][ci]))
  sdf_kbest = abs(max(s_kbest) - min(s_kbest))
  
  C_history$s_kbest = s_kbest
  C_history$sdf_kbest = sdf_kbest
  
  return(C_history)
}


up_history_Kbest = function(C_history, C_part, score, Pi_history) {
  k = Pi_history$K
  E_part = Pi_history$E_part
  
  assert(k > 1 & k <= length(C_part))
  K_best = C_history$K_best
  
  K = paste(k)
  if (!(K %in% ls(K_best))
      || score < K_best[[K]]$score) {
    K_best[[K]] = list(score = score,
                       #list entry f search
                       C_part = C_part,
                       #for assert
                       Pi_history = Pi_history)
  }
  C_history$K_best = K_best
  
  return(C_history)
  
}
