
# RUN -------
target_Vario_Reged = function(regeds, #data loaded
                         adj, # to extract blanket
                         targets, 
                         X_max_n=4,
                         it_pre=50,
                         split=FALSE,
                         confints = NULL,
                         vb=TRUE,
                         skip_no_parent_nodes = TRUE
                         ){
  ##regeds = load_Reged_data()
  G_id = graph_id 
 if(!length(confints)) confints = list(conf_pione=sample_conf_pi_one(3, it_pre, FALSE, TRUE),
                  conf_nogroups= sample_conf_nogroups(3, it_pre, FALSE,TRUE),
                  conf_best=sample_conf_pi_best(3, it_pre, FALSE,TRUE)) 
  
  cat("\nVario on a Subgraph of Reged ")
  cat("\nTargets: ")
  cat("{", (clld(targets, sep=", ", d=0)), "}")
  
  results = list()
  it = 0
  for (vi in 1:length(targets)){
    it = it+1
    target = targets[vi] 
    MB_i = get_MB(adj, target) 
    
    #Remove the one binary variable
    if(1000 %in% MB_i$mb) 
      MB_i$mb = MB_i$mb[-which(MB_i$mb==1000)]
      
    pa_i = MB_i$pa_ind 
    if(skip_no_parent_nodes)
      if(length(pa_i) == 0)
        next
    variables = MB_i$mb 
    
    #Skip empty MBs
    if(!length(variables)) next
    
    if(vb) cat("\n\n\tTarget: ", target)
    
    
    result_Vario_Reged =  
      run_reged(regeds, variables, target, sample_n=0, X_max_n, target_nm = paste(target), confints, version_mdl = TRUE)
    RES <<- result_Vario_Reged
    pi = result_Vario_Reged$Ranking[[1]]$E_part
    pa = result_Vario_Reged$Ranking[[1]]$xsid
    if(vb){
      cat("\tBlanket: ") 
      cat("{", (clld(variables, sep=", ", d=0)), "}")
      cat("\n\tTrue Pa: ",paste0(variables[MB_i$pa_ind], collapse=", "))
      cat("\n\tTrue Ch: ",paste0(variables[MB_i$ch_ind], collapse=", "))
      cat("\n\tVario Pa: ", paste0(variables[pa],  collapse=", "), "check:", paste0(result_Vario_Reged$Ranking[[1]]$xnm,collapse = ", "))
      cat("\n\tVario Pi: ", paste0(pi, collapse=""))
    }
    
 results[[paste0("target_", target)]] = list(Vario_res=result_Vario_Reged,
                                             Vario_pi=pi, 
                                             Vario_pa=pa,
                                             true_pa=pa)
  
  }
  return(results)
}



run_reged = function(Dreged,
                     variables, 
                     target,
                     sample_n = 0, #variables to be  chosen at random from rest of the graph (in addt. to variables + target)
                     X_max_n = 4,
                     target_nm = "y",
                     confints, version_mdl = TRUE){
##  Dreged = load_Reged_data()
  
  if(sample_n==0){
    x_all = colnames(Dreged$reged_data$E1[-1000]) 
    x_all = x_all[-variables]
    x_all = x_all[-target]
    variables = c(variables, sample(1:length(x_all), sample_n))
  }
  
  
  D = transform_Reged_data(Dreged$reged_data,
                           variables, target)


  RESULT = Vario_subset_search(  D$D_data, 
                                 D$X_names[which(D$X_names != "y")] ,
                                 X_max_n=X_max_n, target_nm = target_nm, 
                                 confints = confints, vb=FALSE, version_mdl = version_mdl)
  
  
  return(RESULT)
}


# LOAD ------
load_Reged_data = function(){
  
  # No target values given:
  reged0_test = read.table("data_reged/reged0_test.data")
  reged2_test = read.table("data_reged/reged2_test.data")
  reged1_test = read.table("data_reged/reged1_test.data")
  
  # PREPROCESS
  
  nms = sapply(1:999, function(i) return(paste0("x", i)))
  
  reged0_train = read.table("data_reged/reged0_train.data")
  reged1_train = read.table("data_reged/reged1_train.data")
  reged2_train = read.table("data_reged/reged2_train.data")
  
  vnms = names(reged0_train)
  
  reged0_train_targets = read.table("data_reged/reged0_train.targets")
  reged1_train_targets = read.table("data_reged/reged1_train.targets")
  reged2_train_targets = read.table("data_reged/reged2_train.targets")
  
  dummy = rep (0, nrow(reged0_test))
  reged0 = cbind(reged0_test, dummy)
  reged1 = cbind(reged1_test, dummy)
  reged2 = cbind(reged2_test, dummy)
  
  names(reged0) = nms
  names(reged1) = nms
  names(reged2) = nms
   
  
  regeds  = list(reged0,reged1,reged2) #, reged0, reged0)
  names(regeds) = c("E1", "E2", "E3") #, "E4", "E5")
  names(vnms) = vnms
   
  return(list(reged_data=regeds, x_nms=vnms))
}



