
#  True DAG -----

Reged_truth = function(){
  reged_truth = read.csv("data_reged/reged_truth.txt", sep="\t")
  
  adj  = matrix(0, nrow = 1000, ncol=1000)
  for(r in 1:nrow(reged_truth)){
    i=reged_truth[r,1]
    j=reged_truth[r,2]
    adj[i,j] = 1
  }
  nw = graph_from_adjacency_matrix(adj)
  return(list(nw=nw,
              adj=adj))
}

isparent = function(xi,yi, adj) return(adj[xi,yi]==1)
truthful_parents = function(yi, adj) return(which(adj[,yi]==1))
truthful_children = function(yi, adj) return(which(adj[yi,]==1))

#  Interventions -----
 
Reged1_manipulated_Y = function(){
  manip1 = c(20,27,36,70,82,
             83,85,91,118,125,
             139,143,160,169,176,
             185,191,204,219,224,
             229,239,243,251,252,
             269,281,282,295,297,
             301,319,320,321,342,
             350,357,359,361,378,
             387,407,409,412,429,
             430,469,472,499,501,
             507,512,540,545,552,
             561,566,572,580,586,
             593,618,622,637,651,
             663,674,681,683,686,
             690,702,727,754,762,
             764,773,786,805,815,
             835,861,872,873,877,
             880,889,904,935,936,
             939,942,949,962,977,
             985,989,991,992,994)
  return(manip1)
}


# interventions not on Y but on X:
#Reged2

Reged2_manipulated_Y = function(){
  reged_truth = Reged_truth()
  adj_truth = reged_truth$adj
  
  binary_target = 1000
  conseq_target = adj_truth[binary_target,]
  #ingoing_target = adj_truth[,binary_target] Only one edge
  subset_of_manip2 = which(conseq_target==1)# all conseq of target but some others unknown
  
  return(subset_of_manip2)
 
}
Reged_parents_manip_1 = function(adj){
  G1 = Reged1_manipulated_Y()
  G2 = c()
  for (g in G1){
    ch =truthful_children(g, adj)
    G2 = union(G2, ch[-c(which(ch %in% G1))])
  }
  return(G2)
}
Reged_manipulatednor_Y = function(){
  others  = c(1:999)
  others  = others[-which(others %in% Reged_manipulatedor_Y())]
  return(others)
}
Reged_manipulatedor_Y = function(){
  return(union(Reged2_manipulated_Y(), 
                   Reged1_manipulated_Y()))
}
Reged_manipulatedand_Y = function(){
  return(intersect(Reged2_manipulated_Y(), 
                   Reged1_manipulated_Y()))
}
#cat("g = c(",paste(Reged_G_monly1(),collapse=","),")")
Reged_G_monly1 = function(){
  G1 = Reged1_manipulated_Y()
  G2 = Reged2_manipulated_Y()
  return(G1[-which(G1 %in% G2)])
}

part  = function(g, num, it){
  return(g[c((num*it):(num*(it+1)))])
}
 
Reged_G_1and2oronly2 = function(){
  G1 = Reged_manipulatedor_Y()
  G2 = Reged_G_monly2() 
  return(G1[-which(G1 %in% G2)])
}

Reged_G_monly2 = function(){
  G1 = Reged1_manipulated_Y()
  G2 = Reged2_manipulated_Y()
  return((G2[-which(G2 %in% G1)]))
}

#show parents+children of all vars, mark binary variable as (effect)
#blanket=T: the input vars are supposed to be a blanket already, ow. can be any vars.
Reged_show_truth = function(variables, adj){
  
  cat("\nVariables: ")
  
  cat("{", (clld(variables, sep=", ", d=0)), "}")
  cat("\nBlanket: ")
  cat("{", (clld(unique(Reged_blanket(variables)), sep=", ", d=0)), "}")
  cat("\nSize", length(union(unique(Reged_blanket(variables)), variables)), "\n")
  for(v in variables){
    cat("\nTARGET Y =",v)
    pa = truthful_parents(v, adj)
    ch = truthful_children(v, adj)
    cll = c()
    for (child in ch){
      cll = c(cll, which(adj[,child]==1))
    }
    pa = sapply(pa , function(p) if(p==1000) return("(effect)")
                else return(paste(p)))
    ch = sapply(ch , function(child) 
      if(child==1000) return("(effect)")
      else return(paste(child)))
    
    coll = sapply(cll , function(child) 
      if(child==1000) return("(effect)")
      else return(paste(child)))
    if(!length(ch)) ch=c("--")
    if(!length(pa)) pa=c("--")
    if(!length(coll)) coll=c("--")
    cat("\n\t- Parents:", pa)
    cat("\n\t- Children:", ch)
    cat("\n\t- Colliders:", coll)
  }
  
}
 
#Go1 = Reged_G_monly1()
#Go2 = Reged_G_monly2()
#Gxor = union(Go1, Go2)
#Gand = Reged_manipulated_Y()
#Gor = union(Gxor, Gand)
#x = sapply(Gand, function(i) assert(!(i %in% Gxor)))
# x = sapply(Gxor, function(i) assert(!(i %in% Gand)))
# Gor2 = union( Reged1_manipulated_Y(),  Reged2_manipulated_Y()) 


# Blankets ---------

Reged_blanket_Y = function(variable, adj){
  v_children = which(adj[variable,]==1)
  v_parents = which(adj[,variable]==1)
  v_coll = c()
  if(length(v_children)>=1) {
    for(child in v_children){
      v_coll = c(v_coll, which(adj[,child]==1))
    }
    v_coll = unique(v_coll)
  }
  blanket = union(v_children, union(v_parents, v_coll))
  # Include target
  blanket = union(blanket, variable)
  blanket = unique(sort(blanket))
  if(1000 %in% blanket) blanket = blanket[-which(blanket==1000)]
  blanket = unique(sort(blanket))
  return(list(v=variable,
              pa=v_parents,
              ch=v_children,
              coll=v_coll,
              blanket=blanket))
}


# 
# #A connected componet w 5 nodes. Problem: no interventions on some.
# Reged_G_5 = function(){
#   truth = Reged_truth()
#   truth_nw = truth$nw
#   truth_adj = truth$nw
#   # nett =  delete.vertices(network, degree(network)<1)
#   component = components(truth_nw) 
#   vars = 1:1000
#   component = vars[which(component$membership==7)] 
#   component = sort(component)
#   
#   return(component)
#   #component
#   #[1]  22  29  65 711 995
#   
#   parents = union(which(truth_adj[,22]==1),union(which(truth_adj[,29]==1),union(which(truth_adj[,65]==1),union(which(truth_adj[,711]==1),which(truth_adj[,995]==1)))))
#   # 711  22 995  65
#   children = union(which(truth_adj[ 22,]==1),union(which(truth_adj[ 29,]==1),union(which(truth_adj[ 65,]==1),union(which(truth_adj[ 711,]==1),which(truth_adj[ 995,]==1)))))
#   # > children
#   #[1]  65 995  29 711
# }
# 
# 
