
eval_sachs_adj  = function(results, xi_names, 
                           confints_8,
                           match_partitions = TRUE, 
                           consider_conf=FALSE,
                           consider_conf_afterwards = TRUE,
                           consider_3anc = FALSE,
                           consider_2anc = TRUE,
                           consider_nogroup=TRUE,
                           Vario_results,
                           pruning_step=  TRUE,
                           vb =FALSE){
  #Extract full adjacency matrix -- all conf. edges found in subset search
  adj = matrix(0, 11, 11)
  adj_bin = matrix(0, 11, 11)
  adj2 = matrix(0, 11, 11)
  adj2_bin = matrix(0, 11, 11)
  anc_adj = matrix(0, 11, 11)
  
  #  pruned_adj = matrix(0, 11, 11)
  node_to_ingoing = list()
  edges_ordered = list()
  
  for (node_i in 1:11){
    nm_i = xi_names[node_i]
    node_to_ingoing[[nm_i]] = list() #points to ingoing edges
    
    if(vb) cat("\n---------------------\nNode:", xi_names[node_i],  " ", node_i)
    result_i = as.list(results[[node_i]])
    for (edge_i in 1:length(result_i)){
      edge  = result_i[[edge_i]]
      
      pi = edge$E_part
      score=  edge$score_norm
      #  cat(score)
      
      k = length(unique(pi))
      # conf = mean(confints_8$conf_pione[,(k-1)])
      #conf = mean(confints_8$conf_nogroups[,(k-1)])
      conf = mean(confints_8$conf_pione[,(k-1)])
      if(consider_nogroup){
        if(length(unique(pi))==1) next #break 
        if(length(unique(pi))==length(pi)) next #break
      }
      else {
        if(length(unique(pi))==1)  break 
        if(length(unique(pi))==length(pi))  break
        if(length(unique(pi))>2) next
      }
      if(consider_conf & (score>conf)) next
      
      #if(match_partitions & !(length(unique(pi))==2)) next
      nm_j = edge$xnm
      node_j = which(xi_names==nm_j)
      node_to_ingoing[[nm_i]][[nm_j]] =  edge
      
      edge$nm_i = nm_i
      edge$nm_j = nm_j
      edge$node_i = node_i
      edge$node_j = node_j
      edge$pruned = FALSE
      nm = paste0(names(result_i)[edge_i], "_", nm_i)
      
      edges_ordered[[nm]] = edge
      
      score = edge$score_norm 
      
      xi_nm = edge$xnm
      xi = which(xi_names==xi_nm)  
      if(vb)  cat("\n\tEdge: ", xi_names[xi]," ", xi, paste0(pi, collapse=""))
      if(adj[xi, node_i]==0) #do not overwrite edges with lower scores 
        adj[xi, node_i]= score
      adj_bin[xi, node_i] = 1 
    }
  }
  edges_ordered = list.sort(edges_ordered, score_norm)
  
  for(i in 1:length(edges_ordered)){
    #TODO full_results needed for this
    #gain = edgeanalysis_MDL_gain(xi_names, edges_ordered, full_results, 
                       #  edges_ordered[[i]], edges_ordered[[i]]$node_j, edges_ordered[[i]]$node_i)$gain
    gain = 0
    # cat("\n",xi_names[edges_ordered[[i]]$node_i],"->",xi_names[edges_ordered[[i]]$node_i], "gain", gain)
    edges_ordered[[i]]$gain = gain
  }
  
  if(!pruning_step) return(edges_ordered)
  res = rmv_anc_sachs2 (edges_ordered, # adj_bin, 
                        xi_names, 
                        confints_8,
                        match_partitions , 
                        consider_conf,
                        consider_conf_afterwards ,
                        consider_3anc,
                        consider_2anc,
                        Vario_results=Vario_results,
                        vb )
  return(res)
}


# NEW --------------



rmv_anc_sachs2 =  function(edges_ordered, #adj_bin, 
                           xi_names, 
                           confints_8,
                           match_partitions = TRUE, 
                           consider_conf=FALSE,
                           consider_conf_afterwards = TRUE,
                           consider_3anc = TRUE,
                           consider_2anc = TRUE,
                         #  Vario_results,
                           #TRUE,
                           vb =FALSE){
  
  adj_small =consensus_small_graph_Sachs(xi_names)  #
  adj_big = consensus_augmented_graph_Sachs(xi_names) 
  keepers = list()
  discard = list()
  
  
  pruned_adj = matrix(0, 11, 11)
  
  anc_adj = matrix(0, 11, 11)
  
  #Analyse edges
  adj_aug = consensus_augmented_graph_Sachs(xi_names)
  adj_small = consensus_small_graph_Sachs(xi_names)
  cat("\n")
  i=0
  if (FALSE){
  for(adj_true in list(adj_small, adj_aug)){
    i=i+1
    cat("\t")
    
    diff = adj_bin - adj_true
    sm = adj_bin + adj_true 
    FP_per_Y = apply(diff, 2, function(i) return(which(i==1)))
    FN_per_Y = apply(diff, 2, function(i) return(which(i==-1)))
    TP_per_Y = apply(sm, 2, function(i) return(which(i==2)))
    
    FP_named = apply(diff, 2, function(i) return(xi_names[which(i==1)]))
    FN_named = apply(diff, 2, function(i) return(xi_names[which(i==-1)]))
    TP_named = apply(sm, 2, function(i) return(xi_names[which(i==2)]))
    if(length(TP_named)) tp = sum(sapply(TP_named, function(x) return(length(x))))
    else tp = 0
    if(length(FP_named)) fp = sum(sapply(FP_named, function(x) return(length(x))))#- sum(apply(adj_ancestral_noncausal,1:2, sum))
    else fp = 0
    if(length(FN_named)) fn = sum(sapply(FN_named, function(x) return(length(x))))
    else fn = 0
    #a = sum(apply(adj_ancestral_noncausal,1:2, sum))
    f1 = tp/(tp + (1/2)* (fp + fn))
    #f1 = tp/(tp + (1/2)* ((fp+a) + fn))
    if(i==1) sm = "sm"
    else sm = "aug"
    cat("\n\tPre",sm,":", tp, fp, paste0("(", fp, "+ ",")"), paste0("(",fn,")"),  paste0( "= --", ", *", fmtd(f1,d=2)))
    
  }  
  cat("\n")
  }
  #dont look up edges here while pruning, unless for the node itself
  #adj_pruned = adj 
  
  #Find pruned adjacency columns -- for each Yi, consider adj[,-Yi] as given, and for each adj[xj,yi]>0, prune if exists z, adj[xj,z]+adj[z,yi]/2 >adj[xj,yi] 
  # As z cannot be among
  if(vb)  cat("\n---------------------\nAncestral edges\n---------------------")
  FP_but_ANC = 0
  for (e in 1:length(edges_ordered)){
    edge_ji = edges_ordered[[e]]
    node_i = edge_ji$node_i
    node_j = edge_ji$node_j
    #exists_ancestral = FALSE 
    #exists_only_ancestral =FALSE
    true_ancestors = ""
    if(vb)  cat("\nChecking ", xi_names[node_j], "->", xi_names[node_i])
    edge_ji$exists_ancestral_small= FALSE 
    edge_ji$exists_ancestral_aug= FALSE
    
    edge_ji$exists_only_ancestral_small= FALSE 
    edge_ji$exists_only_ancestral_aug= FALSE
    edge_ji$exists_only_3ancestral_small= FALSE 
    edge_ji$exists_only_3ancestral_aug= FALSE
    
    for (nk in 1:11){
      if(nk==node_j | nk==node_i) next
      if( (adj_small[node_j,nk]==1 & adj_small[nk,node_i]==1)) {
        if(adj_small[node_j,node_i]==0 & adj_small[node_i,node_j]==0 ){
          edge_ji$exists_only_ancestral_small =TRUE
          anc_adj[node_i,node_j]= 1
        }
        true_ancestors = paste0(true_ancestors, xi_names[nk], ",")
        edge_ji$exists_ancestral_small= TRUE
        
        
      }
      if( (adj_aug[node_j,nk]==1 & adj_aug[nk,node_i]==1)) {
        if(adj_aug[node_j,node_i]==0 & adj_aug[node_i,node_j]==0){
          edge_ji$exists_only_ancestral_aug =TRUE
          anc_adj[node_i,node_j]= 1
        } 
        edge_ji$exists_ancestral_aug= TRUE
        
      }
      for (nr in 1:11){
        if(nr==node_j | nr==nk | nr==node_i) next
        if( (adj_big[node_j,nr]==1 &adj_big[nr,nk]==1 & adj_big[nk,node_i]==1) &
            adj_big[node_j,node_i]==0 & adj_big[node_i,node_j]==0 ) 
          edge_ji$exists_only_3ancestral_aug= TRUE
        if( (adj_small[node_j,nr]==1 &adj_small[nr,nk]==1 & adj_small[nk,node_i]==1) & 
            adj_small[node_j,node_i]==0 & adj_small[node_i,node_j]==0 ) 
          edge_ji$exists_only_3ancestral_small= TRUE
      }
      
      
    }
    edge_ji$causal_small = (adj_small[node_j,node_i]==1)
    edge_ji$causal_aug = (adj_big[node_j,node_i]==1)
    
    #exists_ancestral = exists_ancestral | (adj_true[node_j,node_k]==1 & adj_true[node_k,node_i]==1)
    edge_ji$noncausal_small = (adj_small[node_j,node_i]==0)
    edge_ji$exists_anti_small = (adj_small[node_i,node_j]==1)
    edge_ji$exists_anti_big = (adj_big[node_i,node_j]==1)
    
    for (e2 in 1:length(edges_ordered)){ 
      edge_jk = edges_ordered[[e2]]
      node_jj = edge_jk$node_j
      node_k = edge_jk$node_i
      
      if(node_jj != node_j | node_k == node_i  | node_k == node_j ) next
      
      if(edge_jk$pruned | edge_ji$pruned) next
      
      
      for (e3 in 1:length(edges_ordered)){ 
        edge_ki = edges_ordered[[e3]]
        node_kk = edge_ki$node_j
        node_ii = edge_ki$node_i
        
        if(!(node_kk == node_k & node_ii == node_i)) next
        
        if(edge_jk$pruned | edge_ji$pruned | edge_ki$pruned) next
        
        
        if(vb)  cat("\n\tPath ", xi_names[node_j], "->", xi_names[node_k], "->", xi_names[node_i], 
                    ", Pis", paste0(edge_jk$E_part, collapse=""),"->" ,paste0(edge_ki$E_part, collapse=""),"->" , paste0(edge_ji$E_part, collapse=""))
        
        
        #TODO
        # if (consider_conf_afterwards){
        #   pi = edge_j_i$E_part
        #   k = length(unique(pi))
        #   conf = mean(confints_8$conf_pione[,(k-1)])
        #   score= edge_j_i$score_norm
        #   if(score>conf){
        #     if(noncausal) fp = "++ noncausal\t"
        #     if(causal) fp = "-- causal\t" 
        #     if(vb)  cat("\n\t Removed:", fp, xi_names[node_j],  "->",xi_names[node_i], "by conf")
        #     pruned =TRUE
        #   }
        # }
        if(consider_2anc){
          # Look for n_j -> n_k -> n_i where Vario found: jk, ki, and ji.
          # Discard the edge nj, ni if there is at least one such path with better score (suggesting that ki is the true causal edge)
          # Discarding only works if the partitions at edge ki and ji agree (up to more-finegrained, i.e. are consistent) that is, they find the same "interventions" for node ni.
          ###   for (e_k in edges_k){    
          
          # n_j to n_k
          #may be multiple edges btw the same node pair!!!  looking for a smaller ancestral scre to reject-> can use the first entry
          
          
          #rji = MDL_cost_edge(xi_names, edges_ordered, results, 
          #                   edge_ji, node_j,  node_i)
          #rjk = MDL_cost_edge(xi_names, edges_ordered, results, 
          #                   edge_jk, node_j,  node_k)
          # rki = MDL_cost_edge(xi_names, edges_ordered, results, 
          #                    edge_ki, node_k,  node_i)
          #anc = rjk$diff + rki$diff
          anc = (edge_jk$score_norm + edge_ki$score_norm)
          anc = anc/2
          dir = edge_ji$score_norm
          
          pi1 = edge_jk$E_part
          pi2 = edge_ki$E_part
          pi3 = edge_ji$E_part 
          
          consistent  = (check_finegrained(pi2,pi3)$finegrained | check_finegrained(pi3,pi2)$finegrained) 
          ##(check_combined(pi1,pi2, pi3))
          
          
          
          
          if( (anc < dir)   #At least one ancestral path (via z) is found that is better (cheaper by score) than the direct one
              #if(((anc-dir) < -1.25) 
              & (consistent | (!match_partitions)))  { 
            
            edge_ji$pruned = TRUE
            #if(edge_ji$noncausal) fp = "++ noncausal\t"
            #if(edge_ji$causal) fp = "-- causal\t" 
            if(vb)  cat("\n\t Removed:",    xi_names[node_j],  "->",xi_names[node_k] , "->", xi_names[node_i], "\t\t", anc,"<", dir, "\t CONS:", consistent)
            
            pruned_adj[node_j,node_i] = anc-dir
            #twoancestral = TRUE
          }
          #TODO
          # #jrki 
          if(consider_3anc)  
            for (e4 in 1:length(edges_ordered))
              for (e5 in 1:length(edges_ordered)){
                edge_jr = edges_ordered[[e4]]
                edge_rk = edges_ordered[[e5]]
                
                node_jj = edge_jr$node_j
                node_r= edge_jr$node_i
                node_rr= edge_rk$node_j
                node_kk= edge_rk$node_i
                if(node_r == node_k | node_r == node_j | node_r==node_i | 
                   node_r != node_rr | node_k != node_kk | node_j != node_jj) next
                
                
                if(vb) cat(" \n\t | Path: ", xi_names[node_j], "->",  xi_names[node_r], "->", xi_names[node_k], "->", xi_names[node_i])
                
                
                
                anc = (edge_jr$score_norm + edge_rk$score_norm + edge_ki$score_norm)/3
                dir = edge_ji$score_norm
                
                if(anc < dir)  {  
                  consistent = "TODO"
                  edge_ji$pruned = TRUE
                  #if(edge_ji$noncausal) fp = "++ noncausal\t"
                  #if(edge_ji$causal) fp = "-- causal\t" 
                  if(vb)  cat("\n\t Removed:",    xi_names[node_j],  "->",xi_names[node_k] , "->", xi_names[node_i], "\t\t", anc,"<", dir, "\t CONS:", consistent)
                  
                  
                  pruned_adj[node_j,node_i] = anc-dir
                }
              }
          
          
        } 
      }
    } 
    
    #All edges k processed at this point
    edge_ji$node_pa = node_j
    edge_ji$node_child = node_i
    #edge_ji$ancestral= exists_ancestral
    #edge_ji$true_ancestors= true_ancestors
    #edge_ji$causal= causal 
    
    #if(exists_only_ancestral) anc_adj[node_j,node_i]= 1
    if(!edge_ji$pruned){ 
      if(vb) cat("\n\t Keeping:",xi_names[node_j], "-> {",true_ancestors,
                 " } ->", xi_names[node_i])#, "\t\t", anc, "<",adj_to_i[x]) 
      
    }
    
    if(vb) cat("\n---------------------\n")
    
    if(consider_conf_afterwards) {
      pi = edge_ji$E_part
      k = length(unique(pi))
      conf =  42.85396#mean(confints_8$conf_pione[,(k-1)])
      score= edge_ji$score_norm
      if(score>conf) edge_ji$pruned=  TRUE
      #     if(noncausal) fp = "++ noncausal\t"
      #     if(causal) fp = "-- causal\t" 
      #     if(vb)  cat("\n\t Removed:", fp, xi_names[node_j],  "->",xi_names[node_i], "by conf")
      #     pruned =TRUE
      #   }
      # }
    } 
    
    
    edges_ordered[[e]] = edge_ji
    
    
  }
  for(e in edges_ordered){
    ### if (length(unique(e$E_part))==1) e$pruned=TRUE       
    #xnm = xi_names[e$node_j]
    if(e$causal_aug | e$causal_small) nm = "-c."
    else {
      if(e$exists_only_ancestral_small | e$exists_only_ancestral_aug) nm  = "+a."
      else{
        if(e$exists_only_3ancestral_small | e$exists_only_3ancestral_aug) nm  = "+ä."
        else nm = "+n"
      }
    } 
    nm = paste0(nm, xi_names[node_j], "->",xi_names[node_i])
    if(!e$pruned)  keepers[[nm]] = e
    else discard[[nm]] = e
  }
  
  
  
  
  
  #EO_all <<- edges_ordered
  #KEEP  <<- keepers
  
  
  found = matrix(0,11,11)
  #remove dups
  EO = list()
  for(e in edges_ordered){
    if(!e$pruned & found[e$node_j, e$node_i] == 0){
      found[e$node_j, e$node_i] = 1
      
      i1 = "-n"
      if(e$causal_small) i1 = "+c"
      else{
        if(e$exists_only_ancestral_small) i1 = "+a"
        else if(e$exists_anti_small) i1 = "-x"
      }
      i2 = "-n"
      if(e$causal_aug) i2 = "+c"
      else{
        if(e$exists_only_ancestral_aug) i2 = "+a"
        else if(e$exists_anti_big) i2 = "-x"
      }
      nm = paste0(i1, i2, "_",
                  xi_names[e$node_j], "_" , paste0(e$E_part,collapse = ""), "_",
                  xi_names[e$node_i] )
      EO[[nm]] = e
    }
  }
  
  adj_small_inv = -(adj_small-1)
  adj_aug_inv = -(adj_aug-1)
  #cat("\n\tSID sm: ", (suppressMessages(structIntervDist(adj_small, found)$sid/110)), #"/110", #structIntervDist(adj_small, adj_small_inv)$sid,
  #    "\n\tSID aug:", (suppressMessages(structIntervDist(adj_aug, found)$sid/110)), #"/110", #structIntervDist(adj_aug, adj_aug_inv)$sid,
  #    "\n")
  EO_small <<- EO
  adj_bin_pruned = matrix(0,11,11)
  tp = matrix(0,11,11)
  fp = matrix(0,11,11)
  nc = matrix(0,11,11)
  fp_anc = matrix(0,11,11)
  
  
  for(e in EO) if(!e$pruned) adj_bin_pruned[e$node_j, e$node_i]=1
  
  for(e in EO) if((!e$pruned )& adj_small[e$node_j, e$node_i]==1) tp[e$node_j, e$node_i]=1
  for(e in EO) if((!e$pruned )& adj_small[e$node_i, e$node_j]==1 & adj_small[e$node_j, e$node_i]==0) nc[e$node_j, e$node_i]=1
  for(e in EO) if((!e$pruned)  &  adj_small[e$node_j, e$node_i]==0) fp[e$node_j, e$node_i]=1
  for(e in EO) if((!e$pruned)  &  adj_small[e$node_j, e$node_i]==0 &  adj_small[e$node_i, e$node_j]==0 & (e$exists_only_ancestral_small | e$exists_only_3ancestral_small)) fp_anc[e$node_j, e$node_i]=1
  
  tp = sum(tp)
  fp = sum(fp)
  fn = sum(adj_small) -tp
  nc = sum (nc)
  f1 = tp/(tp + (1/2)* (fp + fn))
  f1good = tp/(tp + (1/2)* ((fp-sum(fp_anc)) + fn))
  cat("\n\tF1 sm:",tp, fp,"(", sum(fp_anc), nc, ")", fn, "=",f1,"*" , f1good, "\n")
  
  tp = matrix(0,11,11)
  fp = matrix(0,11,11) 
  nc = matrix(0,11,11)
  fp_anc = matrix(0,11,11)
  
  for(e in EO) if(!e$pruned) adj_bin_pruned[e$node_j, e$node_i]=1
  
  for(e in EO) if((!e$pruned) & adj_big[e$node_i, e$node_j]==1 & adj_big[e$node_j, e$node_i]==0) nc[e$node_j, e$node_i]=1
  for(e in EO) if((!e$pruned) & adj_big[e$node_j, e$node_i]==1) tp[e$node_j, e$node_i]=1
  for(e in EO) if((!e$pruned)  &  adj_big[e$node_j, e$node_i]==0) fp[e$node_j, e$node_i]=1
  for(e in EO) if((!e$pruned)  &  adj_big[e$node_j, e$node_i]==0 & (e$exists_only_ancestral_aug | e$exists_only_3ancestral_aug)) 
    fp_anc[e$node_j, e$node_i]=1 
  tp_mat = tp
  fp_mat = fp
  nc_mat = nc
  fp_anc_mat = fp_anc
  
  tp = sum(tp)
  fp = sum(fp)
  nc = sum (nc)
  fn = sum(adj_big) -tp
  f1 = tp/(tp + (1/2)* (fp + fn))
  f1good = tp/(tp + (1/2)* ((fp-sum(fp_anc)) + fn))
  cat("\tF1 aug:",tp, fp, "(", sum(fp_anc),nc,  ")", fn, "=", f1,"*" , f1good, "\n")
  return(list(anc_adj=anc_adj,
              tp=tp_mat, fp = fp_mat, nc = nc_mat, fp_anc = fp_anc_mat))
  # 
  # #keep and discard contain EDGES that are kept/discarded, now build adj containing all NODES that are not discarded
  # #Do so after processing all edges i->j (as there may be double edges one of which is kept and one discarded)
  # 
  # adj_bin_pruned = matrix(0,11,11)
  # adj_ancestral = matrix(0,11,11)
  # adj_ancestral_causal = matrix(0,11,11)
  # adj_ancestral_noncausal = matrix(0,11,11)
  # #Sanity:
  # adj_causal = matrix(0,11,11)
  # adj_noncausal = matrix(0,11,11)
  # 
  # 
  # 
  # for (node_i in keepers){ 
  #   for(edge_j_i in node_i){
  #     adj_bin_pruned[edge_j_i$node_pa,edge_j_i$node_child] = 1
  #     if(edge_j_i$causal) assert(adj_true[edge_j_i$node_pa,edge_j_i$node_child]==1)
  #     else assert(adj_true[edge_j_i$node_pa,edge_j_i$node_child]==0)
  #     
  #     if(edge_j_i$causal) adj_causal[edge_j_i$node_pa,edge_j_i$node_child] = 1
  #     else {
  #       if(edge_j_i$ancestral) adj_ancestral[edge_j_i$node_pa,edge_j_i$node_child] = 1
  #       else adj_noncausal[edge_j_i$node_pa,edge_j_i$node_child] = 1
  #     }
  #     if(edge_j_i$causal & edge_j_i$ancestral) adj_ancestral_causal[edge_j_i$node_pa,edge_j_i$node_child] = 1
  #     if(!edge_j_i$causal & edge_j_i$ancestral) adj_ancestral_noncausal[edge_j_i$node_pa,edge_j_i$node_child] = 1
  #   }
  # }
  # 
  # ANCADJ <<- anc_adj
  # ANCADJ2 <<- adj_ancestral
  # adj_small =consensus_small_graph_Sachs(xi_names)  #
  # adj_big = consensus_augmented_graph_Sachs(xi_names) 
  # 
  # # cat("\nBefore pruning, big:")
  # #  cat("\nTP:" ,sum(sapply(TP_named, function(x) return(length(x)))))
  # #  cat("\nFP:", sum(sapply(FP_named, function(x) return(length(x)))))
  # i = 0
  # for(adj_true in list(adj_small, adj_big)){
  #   i = i+1
  #   diff = adj_bin_pruned - adj_true
  #   sm = adj_bin_pruned + adj_true
  #   
  #   FP_named_up = apply(diff, 2, function(i) return(xi_names[which(i==1)]))
  #   FN_named_up = apply(diff, 2, function(i) return(xi_names[which(i==-1)]))
  #   TP_named_up = apply(sm, 2, function(i) return(xi_names[which(i==2)]))
  #   
  #   if(length(FP_named_up)) names(FP_named_up) = xi_names
  #   if(length(TP_named_up)) names(TP_named_up) = xi_names
  #   if(length(FN_named_up)) names(FN_named_up) = xi_names
  #   
  #   for (adj_i in list(adj_true,adj, adj_bin_pruned)){
  #     row.names(adj_i) = xi_names
  #     colnames(adj_i) = xi_names
  #   }
  #   # cat("Adj. with ancestral edges:" ) 
  #   # show(adj_bin )
  #   # cat("Adj. pruned:" ) 
  #   # show(adj_bin_pruned )
  #   
  #   if(i==1) cat("\t")
  #   else cat("\t")
  #   if(length(TP_named_up)) tp = sum(sapply(TP_named_up, function(x) return(length(x))))
  #   else tp = 0
  #   if(length(FP_named_up)) fp = sum(sapply(FP_named_up, function(x) return(length(x))))#- sum(apply(adj_ancestral_noncausal,1:2, sum))
  #   else fp = 0
  #   if(length(FN_named_up)) fn = sum(sapply(FN_named_up, function(x) return(length(x))))
  #   else fn = 0
  #   a = sum(apply(adj_ancestral_noncausal,1:2, sum))
  #   f1good = tp/(tp + (1/2)* (fp + fn))
  #   f1 = tp/(tp + (1/2)* ((fp+a) + fn))
  #   cat(tp, fp, paste0("(", (fp-a), "+", a,")"), paste0("(",fn,")"),  paste0( "(", fmtd(f1good,d=2), ", ", fmtd(f1,d=2), ")"))
  # }
  # 
  # pruned_sorted = list()
  # for(ch_i in c(1:11)) {
  #   for(pa_i in c(1:11)){
  #     if(pruned_adj[pa_i, ch_i]<0){
  #       if(adj_true[pa_i, ch_i]) c = 1
  #       else c=0
  #       pruned_sorted[[paste0(c,"_",pa_i,"_",ch_i)]] = list(i=ch_i, j = pa_i, delta = pruned_adj[pa_i, ch_i] , causal =c)
  #     }
  #     # if( adj_true[pa_i, ch_i]) cat("\ncausal",  pruned_adj[pa_i, ch_i])
  #     #  else cat("\nnoncausal", eval$pruned_adj[pa_i, ch_i])
  #   }
  # }
  # pruned_sorted = list.sort(pruned_sorted, delta)
  # return(list(#adj_bin,adj_bin_pruned,FP_per_Y,TP_per_Y,
  #   node_to_ingoing=node_to_ingoing,
  #   keepers = keepers,
  #   discard=discard,
  #   FP=FP_named,TP_named,
  #   FP_up=FP_named_up,TP_up=TP_named_up,
  #   adj_ancestral_all = anc_adj,
  #   adj_ancestral=adj_ancestral,#adj_ancestral_causal=adj_ancestral_causal,
  #   adj_ancestral_noncausal=adj_ancestral_noncausal,
  #   pruned_adj=pruned_adj, true_adj = adj_true, pruned_sorted=pruned_sorted))
}

# RMV ANC ADJ OLD ----------------

rmv_anc_sachs =  function(node_to_ingoing, adj_bin, 
                          xi_names, 
                          confints_8,
                          match_partitions = TRUE,  
                          consider_conf=FALSE,
                          consider_conf_afterwards = TRUE,
                          consider_3anc = FALSE,
                          consider_2anc = TRUE,
                          #TRUE,
                          vb =FALSE){
  
  keepers = list()
  discard = list()
  
  
  pruned_adj = matrix(0, 11, 11)
  
  anc_adj = matrix(0, 11, 11)
  
  #Analyse edges
  adj_aug = consensus_augmented_graph_Sachs(xi_names)
  adj_small = consensus_small_graph_Sachs(xi_names)
  cat("\n")
  for(adj_true in list(adj_small, adj_aug)){
    cat("\t")
    
    diff = adj_bin - adj_true
    sm = adj_bin + adj_true 
    FP_per_Y = apply(diff, 2, function(i) return(which(i==1)))
    FN_per_Y = apply(diff, 2, function(i) return(which(i==-1)))
    TP_per_Y = apply(sm, 2, function(i) return(which(i==2)))
    
    FP_named = apply(diff, 2, function(i) return(xi_names[which(i==1)]))
    FN_named = apply(diff, 2, function(i) return(xi_names[which(i==-1)]))
    TP_named = apply(sm, 2, function(i) return(xi_names[which(i==2)]))
    if(length(TP_named)) tp = sum(sapply(TP_named, function(x) return(length(x))))
    else tp = 0
    if(length(FP_named)) fp = sum(sapply(FP_named, function(x) return(length(x))))#- sum(apply(adj_ancestral_noncausal,1:2, sum))
    else fp = 0
    if(length(FN_named)) fn = sum(sapply(FN_named, function(x) return(length(x))))
    else fn = 0
    #a = sum(apply(adj_ancestral_noncausal,1:2, sum))
    f1 = tp/(tp + (1/2)* (fp + fn))
    #f1 = tp/(tp + (1/2)* ((fp+a) + fn))
    cat(tp, fp, paste0("(", fp, "+ ",")"), paste0("(",fn,")"),  paste0( "( --", ", ", fmtd(f1,d=2), ")"))
    
  }  
  cat("\n")
  #dont look up edges here while pruning, unless for the node itself
  #adj_pruned = adj 
  
  #Find pruned adjacency columns -- for each Yi, consider adj[,-Yi] as given, and for each adj[xj,yi]>0, prune if exists z, adj[xj,z]+adj[z,yi]/2 >adj[xj,yi] 
  # As z cannot be among
  if(vb)  cat("\n---------------------\nAncestral edges\n---------------------")
  FP_but_ANC = 0
  for (node_i in 1:11){
    #adj_pruned_i = adj[,node_i]
    
    #Go through ingoing NODES, best first 
    #order_parents = adj[,node_i]
    #ord = order(order_parents, decreasing = FALSE)
    #xis = c(1:11)[ord]
    #xis = xis[-which(order_parents[ord]==0)]
    
    
    #Go through ingoing EDGES (mult edges per node possible) 
    edges_to_i = node_to_ingoing[[node_i]]
    edges_to_i = list.sort(edges_to_i, (score_norm))
    # edges_to_i = list.order(edges_to_i, score_sum)   
    edges_j = 1:length(edges_to_i)
    
    #adj_to_i = adj[,node_i]
    #adjb_to_i = adj_bin[,node_i] #cont. update this, keeping adj fixed
    
    # Look for n_j -> n_k -> n_i
    if(length(edges_to_i)){
      
      for (e_j in edges_j){ 
        edge_j_i = edges_to_i[[e_j]]
        node_j = which(xi_names == edge_j_i$xnm)
        if(vb)  cat("\nChecking ", xi_names[node_j], "->", xi_names[node_i])
        #edges_to_j = node_to_ingoing[[node_j]]
        
        ##zs = c(1:11)#[-which (adj[x,]==0)]#zs = zs[-node_i]
        edges_k = 1:length(edges_to_i) 
        
        pruned = FALSE
        twoancestral = FALSE
        true_ancestors = ""
        exists_ancestral = FALSE
        exists_only_ancestral = FALSE
        causal = (adj_true[node_j,node_i]==1)
        #exists_ancestral = exists_ancestral | (adj_true[node_j,node_k]==1 & adj_true[node_k,node_i]==1)
        noncausal = (adj_true[node_j,node_i]==0)
        
        # Look for truly ancestral edges
        for (nk in 1:11){
          if(nk==node_j | nk==node_i) next
          if( (adj_true[node_j,nk]==1 & adj_true[nk,node_i]==1)) {
            if(adj_true[node_j,node_i]==0){
              exists_only_ancestral =TRUE
            }
            true_ancestors = paste0(true_ancestors, xi_names[nk], ",")
            exists_ancestral= TRUE
            
          }
          for (nr in 1:11){
            if(nr==node_j | nr==nk | nr==node_i) next
            if( (adj_true[node_j,nr]==1 &adj_true[nr,nk]==1 & adj_true[nk,node_i]==1)) {
              
              true_ancestors = paste0(true_ancestors, "(",xi_names[nk],")", ",")
              exists_ancestral= TRUE
            }
            
            
          }
          
        }
        if (consider_conf_afterwards){
          pi = edge_j_i$E_part
          k = length(unique(pi))
          conf = mean(confints_8$conf_pione[,(k-1)])
          score= edge_j_i$score_norm
          if(score>conf){
            if(noncausal) fp = "++ noncausal\t"
            if(causal) fp = "-- causal\t" 
            if(vb)  cat("\n\t Removed:", fp, xi_names[node_j],  "->",xi_names[node_i], "by conf")
            pruned =TRUE
          }
        }
        if(consider_2anc){
          # Look for n_j -> n_k -> n_i where Vario found: jk, ki, and ji.
          # Discard the edge nj, ni if there is at least one such path with better score (suggesting that ki is the true causal edge)
          # Discarding only works if the partitions at edge ki and ji agree (up to more-finegrained, i.e. are consistent) that is, they find the same "interventions" for node ni.
          for (e_k in edges_k){
            edge_k_i = edges_to_i[[e_k]]
            node_k = which(xi_names == edge_k_i$xnm)
            if(node_j == node_k | node_i == node_k)
              # | pruned_adj[node_j,node_k] | pruned_adj[node_k,node_i])
              next
            
            # n_j to n_k
            edges_to_k = node_to_ingoing[[node_k]]
            nodes_to_k = sapply(edges_to_k, function(edge) return(which(xi_names == edge$xnm)))
            if(!(node_j %in% nodes_to_k)) next
            #may be multiple edges btw the same node pair!!!  looking for a smaller ancestral scre to reject-> can use the first entry
            e_j_k = which(nodes_to_k==node_j)
            if(length(e_j_k)>1)
              e_j_k = which(nodes_to_k==node_j)[1]
            edge_j_k = edges_to_k[[e_j_k]]
            if(vb) cat(" \n\t | Path: ", xi_names[node_j], "->", xi_names[node_k], "->", xi_names[node_i])
            
            anc = (edge_j_k$score_norm + edge_k_i$score_norm)/2
            dir = edge_j_i$score_norm
            
            pi1 = edge_j_k$E_part
            pi2 = edge_k_i$E_part
            pi3 = edge_j_i$E_part 
            
            consistent  = check_combined(pi1,pi2,pi3)#check_finegrained(pi2,pi3)$finegrained | check_finegrained(pi3,pi2)$finegrained
            
            
            if(pruned) next #j->i alr pruned but keep looking f adddt ancestors
            
            if( (anc < dir)   #At least one ancestral path (via z) is found that is better (cheaper by score) than the direct one
                #if(((anc-dir) < -1.25) 
                & (consistent | (!match_partitions)))  { 
              if(noncausal) fp = "++ noncausal\t"
              if(causal) fp = "-- causal\t" 
              if(vb)  cat("\n\t Removed:", fp,   xi_names[node_j],  "->",xi_names[node_k] , "->", xi_names[node_i], "\t\t", anc,"<", dir, "\t CONS:", consistent)
              pruned =TRUE
              pruned_adj[node_j,node_i] = anc-dir
              twoancestral = TRUE
            }
            
            #jrki
            edges_r = 1:length(edges_to_k) 
            if(consider_3anc)  for (e_r in edges_r){
              edge_r_k = edges_to_k[[e_r]]
              
              node_r = which(xi_names == edge_r_k$xnm)
              if(node_r == node_k | node_r == node_j | node_r==node_i) next
              
              # n_j to n_r
              edges_to_r = node_to_ingoing[[node_r]]
              nodes_to_r = sapply(edges_to_r, function(edge) return(which(xi_names == edge$xnm)))
              if(!(node_j %in% nodes_to_r)) next
              
              #may be multiple edges btw the same node pair!!!  looking for a smaller ancestral scre to reject-> can use the first entry
              e_j_r = which(nodes_to_r==node_j)
              if(length(e_j_r)>1)
                e_j_r = which(nodes_to_r==node_j)[1]
              edge_j_r = edges_to_r[[e_j_r]]
              if(vb) cat(" \n\t | Path: ", xi_names[node_j], "->",  xi_names[node_r], "->", xi_names[node_k], "->", xi_names[node_i])
              
              
              
              anc = (edge_j_r$score_norm + edge_r_k$score_norm + edge_k_i$score_norm)/3
              dir = edge_j_i$score_norm
              
              if(anc < dir)  { 
                consistent = "TODO"
                if(noncausal) fp = "++ noncausal\t"
                if(causal) fp = "-- causal\t" 
                #   if(!twoancestral) cat("\n Removing 3ancestral path", fp)
                if(vb)  cat("\n\t Removed:", fp,   xi_names[node_j], "->",  xi_names[node_r],  "->",xi_names[node_k] , "->", xi_names[node_i], "\t\t", anc,"<", dir, "\t CONS:", consistent)
                pruned =TRUE
                pruned_adj[node_j,node_i] = anc-dir
              }
            }
            
            
          } 
        }
        
        
        #All edges k processed at this point
        edge_j_i$node_pa = node_j
        edge_j_i$node_child = node_i
        edge_j_i$ancestral= exists_ancestral
        edge_j_i$true_ancestors= true_ancestors
        edge_j_i$causal= causal 
        
        if(exists_only_ancestral) anc_adj[node_j,node_i]= 1
        if(!pruned){
          if(exists_ancestral) nm  = "-a."
          else if(noncausal) nm  = "-n."
          if(causal) nm = "+c."
          
          if(vb) cat("\n\t Keeping:",  nm,   xi_names[node_j], "-> {",true_ancestors,
                     " } ->", xi_names[node_i], "\t CONS:", consistent)#, "\t\t", anc, "<",adj_to_i[x])
          
          xnm = xi_names[node_j]
          nm = paste0(nm, xi_names[node_j], "->",xi_names[node_i], ".")#, results[[node_i]][e_j]$E_part)
          
          keepers[[xnm]][[nm]] = edge_j_i
        }
        else{
          if(exists_ancestral) nm  = "+a."
          else if(noncausal) nm  = "+n."
          if(causal) nm = "-c."
          
          xnm = xi_names[node_j]
          nm = paste0(nm, xi_names[node_j], "->",xi_names[node_i], ".")#, results[[node_i]][e_j]$E_part)
          discard[[xnm]][[nm]] = edge_j_i
        }
        if(vb) cat("\n---------------------\n")
      }
    }
  }
  
  #keep and discard contain EDGES that are kept/discarded, now build adj containing all NODES that are not discarded
  #Do so after processing all edges i->j (as there may be double edges one of which is kept and one discarded)
  
  adj_bin_pruned = matrix(0,11,11)
  adj_ancestral = matrix(0,11,11)
  adj_ancestral_causal = matrix(0,11,11)
  adj_ancestral_noncausal = matrix(0,11,11)
  #Sanity:
  adj_causal = matrix(0,11,11)
  adj_noncausal = matrix(0,11,11)
  
  
  
  for (node_i in keepers){ 
    for(edge_j_i in node_i){
      adj_bin_pruned[edge_j_i$node_pa,edge_j_i$node_child] = 1
      if(edge_j_i$causal) assert(adj_true[edge_j_i$node_pa,edge_j_i$node_child]==1)
      else assert(adj_true[edge_j_i$node_pa,edge_j_i$node_child]==0)
      
      if(edge_j_i$causal) adj_causal[edge_j_i$node_pa,edge_j_i$node_child] = 1
      else {
        if(edge_j_i$ancestral) adj_ancestral[edge_j_i$node_pa,edge_j_i$node_child] = 1
        else adj_noncausal[edge_j_i$node_pa,edge_j_i$node_child] = 1
      }
      if(edge_j_i$causal & edge_j_i$ancestral) adj_ancestral_causal[edge_j_i$node_pa,edge_j_i$node_child] = 1
      if(!edge_j_i$causal & edge_j_i$ancestral) adj_ancestral_noncausal[edge_j_i$node_pa,edge_j_i$node_child] = 1
    }
  }
  
  ANCADJ <<- anc_adj
  ANCADJ2 <<- adj_ancestral
  adj_small =consensus_small_graph_Sachs(xi_names)  #
  adj_big = consensus_augmented_graph_Sachs(xi_names) 
  
  # cat("\nBefore pruning, big:")
  #  cat("\nTP:" ,sum(sapply(TP_named, function(x) return(length(x)))))
  #  cat("\nFP:", sum(sapply(FP_named, function(x) return(length(x)))))
  i = 0
  for(adj_true in list(adj_small, adj_big)){
    i = i+1
    diff = adj_bin_pruned - adj_true
    sm = adj_bin_pruned + adj_true
    
    FP_named_up = apply(diff, 2, function(i) return(xi_names[which(i==1)]))
    FN_named_up = apply(diff, 2, function(i) return(xi_names[which(i==-1)]))
    TP_named_up = apply(sm, 2, function(i) return(xi_names[which(i==2)]))
    
    if(length(FP_named_up)) names(FP_named_up) = xi_names
    if(length(TP_named_up)) names(TP_named_up) = xi_names
    if(length(FN_named_up)) names(FN_named_up) = xi_names
    
    for (adj_i in list(adj_true,adj, adj_bin_pruned)){
      row.names(adj_i) = xi_names
      colnames(adj_i) = xi_names
    }
    # cat("Adj. with ancestral edges:" ) 
    # show(adj_bin )
    # cat("Adj. pruned:" ) 
    # show(adj_bin_pruned )
    
    if(i==1) cat("\t")
    else cat("\t")
    if(length(TP_named_up)) tp = sum(sapply(TP_named_up, function(x) return(length(x))))
    else tp = 0
    if(length(FP_named_up)) fp = sum(sapply(FP_named_up, function(x) return(length(x))))#- sum(apply(adj_ancestral_noncausal,1:2, sum))
    else fp = 0
    if(length(FN_named_up)) fn = sum(sapply(FN_named_up, function(x) return(length(x))))
    else fn = 0
    a = sum(apply(adj_ancestral_noncausal,1:2, sum))
    f1good = tp/(tp + (1/2)* (fp + fn))
    f1 = tp/(tp + (1/2)* ((fp+a) + fn))
    cat(tp, fp, paste0("(", (fp-a), "+", a,")"), paste0("(",fn,")"),  paste0( "(", fmtd(f1good,d=2), ", ", fmtd(f1,d=2), ")"))
  }
  
  pruned_sorted = list()
  for(ch_i in c(1:11)) {
    for(pa_i in c(1:11)){
      if(pruned_adj[pa_i, ch_i]<0){
        if(adj_true[pa_i, ch_i]) c = 1
        else c=0
        pruned_sorted[[paste0(c,"_",pa_i,"_",ch_i)]] = list(i=ch_i, j = pa_i, delta = pruned_adj[pa_i, ch_i] , causal =c)
      }
      # if( adj_true[pa_i, ch_i]) cat("\ncausal",  pruned_adj[pa_i, ch_i])
      #  else cat("\nnoncausal", eval$pruned_adj[pa_i, ch_i])
    }
  }
  pruned_sorted = list.sort(pruned_sorted, delta)
  return(list(#adj_bin,adj_bin_pruned,FP_per_Y,TP_per_Y,
    node_to_ingoing=node_to_ingoing,
    keepers = keepers,
    discard=discard,
    FP=FP_named,TP_named,
    FP_up=FP_named_up,TP_up=TP_named_up,
    adj_ancestral_all = anc_adj,
    adj_ancestral=adj_ancestral,#adj_ancestral_causal=adj_ancestral_causal,
    adj_ancestral_noncausal=adj_ancestral_noncausal,
    pruned_adj=pruned_adj, true_adj = adj_true, pruned_sorted=pruned_sorted))
}

eval_edges_competitors = function(xi_names,mpi=TRUE,anc3=FALSE){
  G1 = icp_graph_Sachs(xi_names)
  G2 = hicp_graph_Sachs(xi_names)
  G3 = jci_graph_Sachs(xi_names)
  
  adj_small =consensus_small_graph_Sachs(xi_names)  
  adj_big = consensus_augmented_graph_Sachs(xi_names)
  
  #G4 = jci_graph_Sachs(xi_names)
  j=0
  eval = eval_sachs_adj(edges_sachs_simp, xi_names, confints_8 = confints_8, match_partitions = mpi, consider_conf = FALSE,consider_3anc = anc3)
  adj_anc = eval$anc_adj
  
  for(adj_bin in list(G1,G2,G3)){
    j=j+1
    i=0
    if(j==1) cat("\n-----------------\n ICP\t ","SIDs:" , (98/110),",", (109/110), "\n") #structIntervDist(adj_small, G1)$sid, 
    # ",", #structIntervDist(adj_aug, G1)$sid,"/110", 
    #"\n")
    if(j==2) cat("\n-----------------\n hICP\t ", "SIDs:", (84/110),",", (108/110),"\n")# structIntervDist(adj_small, G2)$sid, "/110", 
    #  ",", structIntervDist(adj_aug, G2)$sid,"/110", 
    #"\n")
    if(j==3) cat("\n-----------------\n JCI \t ","SIDs:", (83/110),",", (109/110),"\n") #structIntervDist(adj_small, G3)$sid, "/110", 
    #  ",", structIntervDist(adj_aug, G3)$sid,"/110", 
    #   "\n")
    
    for(adj_true in list(adj_small, adj_big)){
      i = i+1
      diff = adj_bin  - adj_true
      sm = adj_bin + adj_true
      
      FP_named_up = apply(diff, 2, function(i) return(xi_names[which(i==1)]))
      FN_named_up = apply(diff, 2, function(i) return(xi_names[which(i==-1)]))
      TP_named_up = apply(sm, 2, function(i) return(xi_names[which(i==2)]))
      
      
      diff = adj_bin  - adj_anc
      sm = adj_bin + adj_anc
      ANC = apply(sm, 2, function(i) return(xi_names[which(i==2)]))
      
      if(length(TP_named_up))tp = sum(sapply(TP_named_up, function(x) return(length(x))))
      else tp=0
      if(length(FP_named_up)) fp = sum(sapply(FP_named_up, function(x) return(length(x))))
      else fp = 0   
      if(length(ANC)) a = sum(sapply(ANC, function(x) return(length(x))))
      else a = 0
      fn = sum(sapply(FN_named_up, function(x) return(length(x))))
      #TODO a
      f1good = tp/(tp + (1/2)* (fp-a + fn)) 
      f1 = tp/(tp + (1/2)* (fp + fn)) 
      
      
      if(i==1) cat("\t")
      else cat("\t") 
      cat(tp,"", paste0("(", fp, "-", a, ")"),  paste0("(",fn,")")," ",    paste0( "(", fmtd(f1good,d=2),",",fmtd(f1,d=2), ")"))
      
      # cat("" ,sum(sapply(TP_named_up, function(x) return(length(x)))))
      # if(length(FP_named_up)) cat("", sum(sapply(FP_named_up, function(x) return(length(x)))))
      #cat("\nANC:",sum(apply(adj_ancestral,1:2, sum)))
      
      
    }
  }
  cat("\n-----------------\n Elbow \t")
  eval = eval_sachs_adj(edges_vario_elbow, xi_names, confints_8 = confints_8, consider_nogroup= FALSE, match_partitions = mpi, consider_conf = FALSE,consider_3anc = anc3)
  
  cat("\n-----------------\n Simp \t")
  eval = eval_sachs_adj(edges_sachs_simp, xi_names, confints_8 = confints_8, consider_nogroup= TRUE, match_partitions = mpi, consider_conf = FALSE, consider_conf_afterwards = FALSE, consider_3anc = anc3)
  
  return()
  cat("\n-----------------\n Simp cb ")
  eval = eval_sachs_adj(edges_sachs_simp, xi_names, confints_8 = confints_8, match_partitions = mpi, consider_conf = TRUE, consider_conf_afterwards = FALSE, consider_3anc = anc3)
  cat("\n-----------------\n Simp ca ")
  eval = eval_sachs_adj(edges_sachs_simp, xi_names, confints_8 = confints_8, match_partitions = mpi, consider_conf = FALSE, consider_conf_afterwards = TRUE, consider_3anc = anc3)
  cat("\n-----------------\n Simp cba ")
  eval = eval_sachs_adj(edges_sachs_simp, xi_names, confints_8 = confints_8, match_partitions = mpi, consider_conf = TRUE, consider_conf_afterwards = TRUE, consider_3anc = anc3)
  
  cat("\n-----------------\n Tuned  ")
  eval = eval_sachs_adj(edges_sachs_tuned_n0, xi_names, confints_8 = confints_8, match_partitions = mpi, consider_conf = FALSE, consider_conf_afterwards = FALSE,consider_3anc = anc3)
  cat("\n-----------------\n Tuned cb")
  eval = eval_sachs_adj(edges_sachs_tuned_n0, xi_names, confints_8 = confints_8, match_partitions = mpi,consider_conf = TRUE, consider_conf_afterwards = FALSE, consider_3anc = anc3)
  cat("\n-----------------\n Tuned ca")
  eval = eval_sachs_adj(edges_sachs_tuned_n0, xi_names, confints_8 = confints_8, match_partitions = mpi, consider_conf = FALSE, consider_conf_afterwards = TRUE, consider_3anc = anc3)
  cat("\n-----------------\n Tuned cba")
  eval = eval_sachs_adj(edges_sachs_tuned_n0, xi_names, confints_8 = confints_8, match_partitions = mpi, consider_conf = TRUE, consider_conf_afterwards = TRUE,consider_3anc = anc3)
}
finish2 = function(res, covariate_names){
  new_list = list()
  for(xi in 1:length(res$pi_Xi_intersect)){
    for(pi in (res$pi_Xi_intersect[[xi]])){
      score_xi = 0
      ct = 0
      for (i in 1:length(res$pi_seen[[pi]]$xsids)){
        subset = res$pi_seen[[pi]]$xsids[[i]]
        if(xi %in% subset) {
          score_xi = score_xi + res$pi_seen[[pi]]$scores[[i]]
          ct = ct + 1
        }
      }
      nm = paste(covariate_names[xi],
                 paste0(pi, collapse=""), sep="_")
      new_list[[nm]] = list(pi=pi, score_xi = score_xi, score_sum=score_xi/ct,
                            nm=covariate_names[xi], xi=xi)
    } 
  }
  new_list = list.sort(new_list,score_sum)
  return(new_list)
}