

#READS dir_nm = ~/Vario/put/synthetic_graphs_vario/subdir_nm

#CALL AFTER  generate_DAG_linear.R -> simul_linear_stochastic(...)

#WRITES outdir_nm = ~/Vario/out/synthetic_check_causal/

#AFTERWARDS CALL decision_rate_pi_causal(...) on files: outdir_nm/pi_NContexts_NGroups.txt 

# TODO library(tidyverse)
Vario_on_DAG_linear =  function(E_n, confints=NULL, 
                         dir_nm="~/Vario/out/synthetic_graphs_vario/",
                         outdir_nm="~/Vario/out/synthetic_out_vario/",
                         subdir_nm="",
                         blanket_only=FALSE,version_mdl = TRUE, version_simp=TRUE){
  R_n = E_n -1 
  if(!length(confints))
    
    confints = list(conf_pione=sample_conf_pi_one(E_n, 50, FALSE,version_mdl = version_mdl),
                    conf_nogroups= sample_conf_nogroups(E_n, 50, FALSE,version_mdl = version_mdl ),
                    conf_best=sample_conf_pi_best(E_n, 50, FALSE,version_mdl = version_mdl))
    
  
  files = list.files(path=paste0(dir_nm, subdir_nm), 
                     pattern="*-data.csv", 
                     full.names=FALSE, 
                   recursive=FALSE)
  
  
#  files = list.files(path=paste0("~/Vario/out_relatedwork/" , subdir_nm),
 #                    pattern="*.Rdata", full.names=FALSE, recursive=FALSE)
  strs=c()
  strsIntv = c()
  for(file in files ){
    mat = read_csv(paste0(dir_nm,subdir_nm, file),col_types = cols())
    ##
    
    
    seed = strsplit(file, "-")[[1]][1]
    
   # nm= paste0( subdir_nm, seed, "-data.csv")
    #nm_files =  list.files(path=paste0("~/Vario/data_jci/" , subdir_nm),
    #                       pattern="*-data.csv", full.names=FALSE, recursive=FALSE)
    #if(!(nm %in% nm_files)){
    #  cat("\nSkip seed", seed, "\n")
    #  next
    #}
    #mat = read_csv(paste0("~/Vario/data_jci/",subdir_nm, seed, "-data.csv"),col_types = cols())
    
    cat("\nReading:", file, "w/", E_n, "contexts,", R_n, "regimes\n" )
    
    #adj = read_csv(paste0("~/Vario/data_jci/",seed, "-edge.csv"))
    adj = read_csv(paste0(dir_nm,subdir_nm, seed, "-graphaug.csv"),col_types = cols())
    arel = read_csv(paste0(dir_nm,subdir_nm, seed, "-arel.csv"),col_types = cols())
    
    #mat[,1:(ncol(mat)-R_n)]
    system_vars = 1:(ncol(mat)-R_n)
    context_vars = (length(system_vars)+1):(ncol(mat))
    
   # cat(paste(context_vars, collapse=""))
    system_adj = adj[system_vars, system_vars]
    context_parents = adj[context_vars, system_vars]
    A <<- adj
    SA <<-system_adj
    CA <<- context_parents
    
    for(i in system_vars){  
      blanket_i = get_MB(system_adj, i)
      
      covariates_i = system_vars[-i]
      
      if(!blanket_only) {
        blanket_i$mb = c(blanket_i$mb, setdiff(covariates_i, blanket_i$mb))
      }
      if(!length(blanket_i$mb)) next
        #blanket_i = system_vars
      
      
      # Mind the variable order convention:
      data_i = mat[,c(c(i,blanket_i$mb),context_vars)]
      # x3 x5 means: at index 3 and 4 in adj we find the first two Markov Blanket members
      #xnms =  c(sapply(blanket_i$mb, function(xi) return(paste0("x",xi))))#,
                #sapply(context_vars,function(xi) return(paste0("c",xi))))
      x_lookup =  c(blanket_i$mb)
      # add remaining vars
      x_lookup =  c(blanket_i$mb,setdiff(system_vars,blanket_i$mb)) #should include y as well

      xnms = c(paste0("x", x_lookup),sapply(context_vars,function(xi) return(paste0("c",xi))))
      # mind that y is missing. If we look up variable i in xall names, this is ith covariate for vario and xallnames[i] at adj.
   #   cat("Xall:", paste(xnms, collapse=","))
  
      
    #??  names(data_i) = c("y",xnms)
      
      MTSUB <<- data_i
      #TODO Extract goal partition (an equi class -- only care abt contexts being different from obs. one)
      goal_pi = rep(1, E_n)
      grp_index = 1
      for(j in 1:(E_n-1)){
        if(context_parents[j,i]==1){
          grp_index = grp_index + 1
          goal_pi[j+1] = grp_index
        }
      }
      pa_i = which(adj[,i]==1)
      ch_i = which(adj[i,]==1)
      #cat("goal:",goal_pi)
      if(length(pa_i)) pa_nms = paste(xnms[pa_i], sep=",")
      else pa_nms = "--"
     #  cat("\nParents (xj->yi):",  pa_nms, "/", paste("V", pa_i, sep=""), "\n")
     # stop()
    #   cat("Children (yi->xj):", paste(xnms[ch_i], sep=","), "/", paste("V", ch_i, sep=""), "\n")
    #   cat("All (Blanket or any) :", paste(xnms[1:length(blanket_i$mb)], sep=","), "/", paste("V", blanket_i, sep=""), "\n")
      #cat("Intv. (cj->yi):", paste(xnms[length(system_vars)+1:length(xnms)][which(goal_pi[-1]!=1)], sep=",") , "\n\n")
      
      vario_data_i = transform_JCI_data(data_i, 1, E_n, R_n) #1 because y was prepended  by name convention
      DTA <<-vario_data_i
      #Run Vario, this checks the result against the blanket 
      if(version_mdl)out_nm=paste0(outdir_nm,subdir_nm,"MDL/") 
      else out_nm=paste0(outdir_nm,subdir_nm,"Emp/") 
      res = synth_check_subset_search(vario_data_i$D_data, 5,
                                goal_pi, blanket_i, 
                                confints, out_nm=out_nm ,
                                version_mdl = version_mdl,
                                seed=seed, node_i=i, vb=TRUE)
      Vario_res = res$Vario_res
      
      res <<- Vario_res
 
      xi_names = Vario_res$covariates_nm

      adj_vario = Vario_res_to_adj(res)
      
      ####save(Vario_res, file= paste0(outdir_nm,subdir_nm, seed, "-y",i,"-result.RData"))
      ####write.csv(adj_vario, paste0(outdir_nm ,subdir_nm, seed, "-y",i,"-graphvario.csv"))
      #Print results in addition
      pa = Vario_res$Ranking_final[[1]]$xsid
      if(length(pa)) pa_nms = xi_names[pa] 
      else pa_nms = c()
        
      pi = Vario_res$Ranking_final[[1]]$E_part
      
      if(length(unique(pi))!=length(pi)
         & length(unique(pi)) >1){
        interv = context_vars[setdiff(1:(length(pi)), which(pi==pi[1])) - 1]
        
        strnew = paste0("pa: ", paste(pa_nms,collapse=","), "  \tvs. true: ", paste(intersect(which(adj[,i]==1), system_vars),collapse=","),
                        " [", paste(intersect(which(arel[,i]==1), system_vars),collapse=","), "] [[", paste(intersect(which(adj[i,]==1), system_vars),collapse=","), "]]\n")
        strInew =  paste0("interv: ", paste(interv,collapse=","), " \tvs. true: ", paste(intersect(which(adj[,i]==1), context_vars),collapse=","),  "\n")
        strs =  c(strs, strnew)
       #cat("\t",strnew, "")
        #cat("\t",strInew, "\n")
        strsIntv = c(strsIntv, strInew)
      }
    #  else cat("\tINCONF.\n")
    }
   # cat(strs, "\n")
   # cat(strsIntv)
  }}




