synth_check_pi = function(data, goal_shape,
                          num_pa, subset_if_no_pa, config, out_nm, seed){

  #By construction, the first #num_pa variables are parents. 
  # Run Vario only on those to check the partition or, if there arent any parents, run it on all variables and expect no-groups or insignificance.
  E_n = length(data)
  no_pa = (num_pa==0)
  if(no_pa) kstar = 0
  else kstar = length(goal_shape)
  
  out_nm1 =  paste0(out_nm,"k",kstar,".txt")
  out_nm2 =  paste0(out_nm,"all.txt")
  
  if(!no_pa) 
    data = subset_collection(data, 1:num_pa) 
  else 
    data = subset_collection(data, subset_if_no_pa) 
  
  X_n = ncol(data[[1]])-1 
  assert_Data_E1_En(data,X_n)
  X_deg = lapply( 1:X_n, function(i) return(1))
   
  Vario_res = Vario_Pi_search(data, X_deg, config=config) 
  best = Vario_res$Pi_ranking[[1]] 
  ##Pi_ranking=list.sort(as.list(Vario_res$pi_seen),score_sum)
  pi = best$E_part
  pi_score = as.numeric(best$score_sum)
  pi_conf = cmp_Vario_conf(pi, Vario_res$confints, pi_score)
  
  if(config$version_mdl){
    pi_conf = 1
    for (i in 2:length(Vario_res$Pi_ranking)){
      pi2 = Vario_res$Pi_ranking[[i]]$E_part
      cat(pi2)
      if(length(unique(pi2))==length(pi2)) pi_conf = Vario_res$Pi_ranking[[i]]$score_sum - pi_score
      break
    }
    if(length(unique(pi))==length(pi)) pi_conf = 1 
  }

ress<<-Vario_res
cat("\n", pi_conf)

  
  goal_pi = shape_to_part(goal_shape)
  
  if(no_pa){
    goal_pi=rep(1,E_n)
    goal_shape=c(E_n)
    if((length(unique(pi))==1 & pi[1]==1) | (length(unique(pi))==E_n)) rating= c(1,0,0,0,0)
    else           
      rating = c(0,1,0,0,0)
  }
  else{
    pi_correct= !(FALSE %in% sapply(1:E_n, function(i) return(goal_pi[i]==pi[i])))
    # Equate no group and one group partition: 
    if (length(unique(goal_pi)) == length(goal_pi)) #no groups
      pi_correct= pi_correct | !(FALSE %in% sapply(1:E_n, function(i) return(pi[i]==1)))
    if(pi_correct)
      rating=  c(1,0,0,0,0)
    else{           
      rating = c(0,1,0,0,0)
      pi_consistent = check_consistent_shape_pi(goal_shape, pi)
      #if F, check whether groups are less specific but correct: for each group in pi*, contexts in that group are also in pi. though pi* could break up groups further.
      if(pi_consistent) 
        rating = rating + c(0,0,1,0,0)      
      else    {
        contig = !(FALSE %in% sapply(1:length(pi), function(i) sort(pi)[i]==pi[i]))
        pi_shape = rep(0,max(pi)) 
        for(id in pi) pi_shape[id]=pi_shape[id]+1
        pi_shape=pi_shape[-which(pi_shape==0)] 
        
        if(contig) pi_finegrained = check_consistent_shape_pi(pi_shape, goal_pi)
        else pi_finegrained = FALSE
        if(pi_finegrained) rating = rating + c(0,0,0,1,0)
        else rating = rating + c(0,0,0,0,1)
      }
    }
  }
   
  if(length(Vario_res$Pi_ranking )>=2) {
    pi2 = paste0( paste(Vario_res$Pi_ranking[[2]]$E_part,collapse=""), 
                  "\t s=",fmtd(Vario_res$Pi_ranking[[2]]$score_sum, d=2))
    pin = paste0( paste(Vario_res$Pi_ranking[[length(Vario_res$Pi_ranking)]]$E_part,collapse=""), 
                  "\t s=",fmtd(Vario_res$Pi_ranking[[length(Vario_res$Pi_ranking)]]$score_sum, d=2))
    }
     else {
       pi2 = "--"
       pin = "--"
     }
  #i5 = 0
  #igoal = 0
  #for(i in 1:length(Vario_res$Pi_ranking)){
  #  if( Vario_res$Pi_ranking$E_part)
  #}
  cat(paste(goal_pi,collapse=""), " > ",  rating[1], sep="") 
  if(rating[1]==0 & rating[3]==1) cat(", consistent")
  if(rating[1]==0 & rating[4]==1) cat(", refined" )
  if (length(unique(pi))==1) reject = 1
  else reject=0
  if (length(unique(pi))==length(pi)) nogrp = 1
  else nogrp=0
  if(rating[1]==0 & reject==1) cat(", reject" )
  if(rating[1]==0 & nogrp==1) cat(", no group" )
  
    cat( "\n     | 1." , paste(pi,collapse=""), "\t s=", fmtd(Vario_res$Pi_ranking[[1]]$score_sum, d=2),
      "\n     | 2.", pi2,  "\n     | n.", pin, "\n", sep="")
   
  cat(paste0(rating[1], "\t", 
             pi_conf, "\t", pi_score,"\t", paste(goal_pi , collapse=""), 
             "\t", paste(pi , collapse=""), "\t", 
             length(unique(goal_pi)), "\t", no_pa,"\t", paste(rating , collapse=""),  
             "\t", seed,"\t", rating[3],"\t", rating[4], "\t", reject, "\t", nogrp, "\n"), file=out_nm1, 
      append=TRUE)
  cat(paste0(rating[1], "\t", 
             pi_conf, "\t", pi_score,"\t", paste(goal_pi , collapse=""), 
             "\t", paste(pi , collapse=""), "\t", 
             length(unique(goal_pi)), "\t", no_pa,"\t", paste(rating , collapse=""),  
             "\t", seed,"\t", rating[3],"\t", rating[4], "\t", reject, "\t", nogrp, 
             "\n"), file=out_nm2, 
      append=TRUE)
  
  return((list(goal_shape=goal_shape,
               goal_pi=goal_pi,
               pi=pi, pi_score=pi_score,
               #Vario_res=Vario_res,
               pi_conf=pi_conf,
               rating=rating
               )))
}

check_combined  = function(pi1, pi2, pi12) {
  #pi1 j->k, pi2 k->i, pi12 j->i: want to know whether j->i only came about bc of the indirect path.
  #If so, a necessary condition is that interventions on k (pi1) are also reflected in  pi12, same for interv on i
  combined = TRUE 
  for (i in 1:length(pi12)){
    if(pi1[i]!=1 | pi2[i]!=1) combined= combined & (pi12[i] != 1)
    #TODO is this too strict?:
   # if(pi1[i]==1 | pi2[i]==1) combined= combined & (pi12[i]==1)
  }
  return(combined)
}



check_finegrained = function(test_pi, goal_pi){ #tests whether test-pi is more finegrained than goal-pi
  E_n = length(test_pi)
  assert(E_n==length(goal_pi))
  pi_correct= !(FALSE %in% sapply(1:E_n, function(i) return(goal_pi[i]==test_pi[i])))
  
  # Equate no group and one group partition: 
  if (length(unique(goal_pi)) == length(goal_pi)
      | length(unique(goal_pi)) == 1) #no groups
    pi_correct= !(FALSE %in% sapply(1:E_n, function(i) return(test_pi[i]==i))) | !(FALSE %in% sapply(1:E_n, function(i) return(test_pi[i]==1)))
  if(pi_correct) 
      pi_finegrained = TRUE
  else{
    ##pi_consistent = check_consistent_shape_pi(goal_shape, pi)
    
    #if F, check whether groups are less specific but correct: for each group in pi*, contexts in that group are also in pi. though pi* could break up groups further.
   # if(!pi_consistent)  {
      contig = !(FALSE %in% sapply(1:length(test_pi), function(i) sort(test_pi)[i]==test_pi[i]))
      pi_shape = rep(0,max(test_pi)) 
      for(id in test_pi) pi_shape[id]=pi_shape[id]+1
     if(0 %in% pi_shape) pi_shape=pi_shape[-which(pi_shape==0)] 
 
      if(contig) pi_finegrained = check_consistent_shape_pi(pi_shape, goal_pi)
      else pi_finegrained = FALSE
      
    #}
  }

  return(list(eq=pi_correct, finegrained=pi_finegrained))
}

