synth_check_subset_search = function(data, X_max_n,
                                     goal_pi,#goal_shape, 
                                     markov_blanket, 
                                     confints, #appropriate ones dep on version_mdl
                                     #for file names:
                                     out_nm,  seed, node_i, vb,
                                     #MDL or no:
                                     version_mdl=TRUE,
                                     version_simp=TRUE){
  

  
  assert_Data_E1_En(data,ncol(data[[1]])-1)
  E_n = length(data)
  X_nms = lapply( 1:(ncol(data[[1]])-1), function(i) return(paste0("x",i)))
  true_pa_i = markov_blanket$pa_ind
  no_parent= (length(true_pa_i)==0) # Guess should be no groups
   
  # File for result
  if(no_parent) kstar = 0
  else kstar = length(unique(goal_pi))#length(goal_shape)
  out_nm_full =  paste0(out_nm, "pi_", E_n,"_",kstar,".txt")
  
  # Run subset search on MB(Y)
  Vario_res = Vario_subset_search(data, X_nms, X_max_n,vb=FALSE, confints=confints, version_mdl=version_mdl,version_simp=version_simp)
  
  xi_names = Vario_res$covariates_nm
  RES <<- Vario_res
  #stop()
 # PREV: pi=Vario_res$Ranking_Pi[[1]]$pi
  pi = Vario_res$Ranking_final[[1]]$E_part
  
  # PREV: pi_score = as.numeric(Vario_res$Ranking_Pi[[1]]$score_sum)
  pi_score = as.numeric(Vario_res$Ranking_final[[1]]$score_norm) 
  

  if(!version_mdl) 
    pi_conf = cmp_Vario_conf(pi, Vario_res$config$conf_precomputed, pi_score) #TODO: should store the confs also in varios result
 
  else 
    #TODO what gain for multiple edges {X1,..Xn}->Y?? avg gain of all?
    pi_conf = Vario_res$Ranking_final[[1]]$score_norm #L_loglik
  
  #PREV: pa = Vario_res$Ranking_Pi[[1]]$xids 
  pa = Vario_res$Ranking_final[[1]]$xsid
 
  
  #Here, if its the no-group partition, Vario refrains from making an inference: 
  if((length(unique(pi))==1 & pi[1]==1)
     |length(unique(pi))==length(pi)) pa = c()
  
  #goal_pi = shape_to_part(goal_shape)
  
  no_groups = (length(unique(goal_pi))==1 & goal_pi[1]==1) | (length(unique(goal_pi))==E_n) #in most cases we do not generate it explicitly as it arises from Y having no parents
  
  # Count TP for Pi and Paremts -------
  # Special case no parents: look for no-group partition -----
  if(no_parent | no_groups){
    goal_pi=rep(1,E_n)
   # goal_shape=c(E_n)
    no_groups_predicted =  (length(unique(pi))==1 & pi[1]==1) | (length(unique(pi))==E_n)
    if(no_groups_predicted) rating= c(1,0,0,0,0,0,0,0)
    else           
      rating = c(0,1,0,0,0,0,0,0)
    
    #In this special case, it is not clear whether it should be all interventions or none.  can thus count an exact match to the partition instead (to show in the plot)-either 1tp or 1fn here.
    intervention_rating = c(0,0,0,0) #tp,fp,fn,tn
    if(no_groups_predicted) intervention_rating = c(1,0,0,0)
    else intervention_rating = c(0,0,1,0)
     }
  else{
    
    pi_correct= !(FALSE %in% sapply(1:E_n, function(i) return(goal_pi[i]==pi[i])))
    if(pi_correct)
      rating=  c(1,0,0,0,0,0,0,0)
    else{            
      # Evaluate Pi-----     
      rating = c(0,1,0,0,0,0,0,0)
      
      pi_consistent =0 #TODO  check_consistent_shape_pi(goal_shape, pi)
      
      #If Pi is no exact match, check whether groups are less specific but correct: for each group in pi*, contexts in that group are also in pi. though pi* could break up groups further. also check the other way around.
      # (An alternative measure of "soft" match between pi and pistar is the intervention count later.)
      if(pi_consistent) 
        rating = rating + c(0,0,1,0,0,0,0,0)      
      else    {
        contig = !(FALSE %in% sapply(1:length(pi), function(i) sort(pi)[i]==pi[i]))
        pi_shape = rep(0,max(pi)) 
        for(id in pi) pi_shape[id]=pi_shape[id]+1
        pi_shape=pi_shape[-which(pi_shape==0)] 
        
        if(contig) pi_finegrained = check_consistent_shape_pi(pi_shape, goal_pi)
        else pi_finegrained = FALSE
        if(pi_finegrained) rating = rating + c(0,0,0,1,0,0,0,0)
        else rating = rating + c(0,0,0,0,1,0,0,0)
      }
    }  
  # Evaluate interventions-----
  # in this setting, the first context is observational and we have context variables C for the others, so that JCI can return C->Y in the graph. correct in case the group that C is in is different from observational group. 
  intervention_rating = c(0,0,0,0)
  for (context in 2:E_n){ #evaluate each non-interventional context
    interventional = (goal_pi[1]!=goal_pi[context])
    guess_interv = (pi[1]!=pi[context])
    if(interventional){
      if(guess_interv) intervention_rating = intervention_rating + c(1,0,0,0) #tp
      else intervention_rating = intervention_rating +  c(0,0,1,0) #fn, missed
    } else 
      if(guess_interv) intervention_rating = intervention_rating +  c(0,1,0,0) #fp
    else intervention_rating = intervention_rating +  c(0,0,0,1) 
    
  }
  }
  
  # Check causal parents 
  for (parent in pa) {
    if(parent %in% true_pa_i) rating = rating + c(0,0,0,0,0, 1,0,0)         
    else           
      rating = rating + c(0,0,0,0,0, 0,1,0)
  }
  #Check for FN also
  for (parent in true_pa_i) 
    if(!(parent %in% pa)) rating = rating + c(0,0,0,0,0, 0,0,1)   
  
  #Not only FP+FN matter, but children are especially bad
  if(length(pa))
    n_children_retrieved =  sum(sapply(pa, function(i) if(i %in% markov_blanket$ch_ind) return(1) else return(0)))
  else n_children_retrieved = 0
  n_all_retrieved =  length(pa)
  n_all_covariates =  length(markov_blanket)
  #could also find TN but doesnt matter to us much.
  
  #TODO special case that there are groups, Vario predicts no groups: count interventions as true or dont?
  # TODO show only nonzero conf.
  
  #For printing, TODO verbose
  Vario_pa = sapply(pa, function(i) if(i %in% markov_blanket$ch_ind) 
    return(paste("[",paste(paste("x",i,sep=""),"]",sep=""),sep="")) else return(paste("x",i, sep="")))
  
intervention_print =   paste0(intervention_rating[1], "/",(intervention_rating[1]+intervention_rating[3]) )
causal_print =  paste(paste("x",true_pa_i,sep=""),collapse="")
if(!length(true_pa_i)) causal_print = "--"
if(no_parent) intervention_print = "--"
  
#to not confuse 11111/12345 resulting from no-parent and 12345 specifically generated:
if(length(unique(goal_pi))==1 & goal_pi[1]==1)
goal_pi_print="nogrp"
else goal_pi_print = paste(goal_pi,collapse="")
if(length(unique(pi))==1 & pi[1]==1 |
   length(unique(pi))==length(pi))
  pi_print="nogrp"
else  pi_print = paste(pi,collapse="")

if(length(Vario_pa)>0) variopa_print = paste(Vario_pa,collapse="")
else variopa_print = "--"

 if(vb) cat("Pi:", goal_pi_print, ">", pi_print,  "\tSCORE",fmtd(pi_score,d=2), "\t CONF ", fmtd(pi_conf,d=2), "\t Interv:", 
      paste0(intervention_print, ", fp.",   intervention_rating[2]),  "\tParents:", paste0(rating[6], "/", rating[6]+rating[8], ", fp.",rating[7], ", ch.", n_children_retrieved),
      "\tCausal:",causal_print,
    ">" ,variopa_print,
    "\n")
  cat(paste0(
    #arguments read after multiple runs by decision_rate_pi_causal:
    rating[1],"\t", rating[6], "\t",rating[7], "\t", rating[8], "\t",
    #MDL: gain, EMP: conf (results are later sorted by these to obtain dec rate plots)
    fmtd(pi_conf,5), 
    "\t", 
             intervention_rating[1], "\t",intervention_rating[2], "\t",intervention_rating[3], "\t",intervention_rating[4],  
          "\t", n_children_retrieved, "\t", n_all_retrieved,"\t", n_all_covariates,
             #The rest is just for reference:
             "\t", pi_score,"\t", paste(goal_pi , collapse=""), "\t", paste(pi , collapse=""),   "\t", paste(true_pa_i , collapse=","), "\t", paste(pa , collapse=","), "\t", paste(rating , collapse=""),  "\n"), file=out_nm_full, append=TRUE)
  
  
  
   # Create adjacency matrix, augmented by context vars
    mb =markov_blanket$mb
    node_n_i = length(mb) + 1
    aug_node_n_i = node_n_i + E_n-1
    context_nodes_i = (node_n_i+1:aug_node_n_i)
    
    aug_adj_i = matrix(0,aug_node_n_i,aug_node_n_i)

  
    for (parent in pa) 
      aug_adj_i[pa,1] = 1 
    
    # Evaluate interventions:
    for (context in 2:(E_n)) {
      index = node_n_i + context -1
      guess_interv = (pi[1]!=pi[context])
      if(guess_interv)
        aug_adj_i[index] = 1
    } 
    
    
#    out_createdir("~/Vario/out/graphs_vario")
#read from adj later.   
    
    write.csv(aug_adj_i, paste0(out_nm, seed, "-y", node_i, "-graphvario.csv"), row.names = FALSE)
 
    
 #graph:   dg2graphviz(filename=paste(out_nm_graph),p=node_n_i,contextVars=c(),labels=1:node_n_i,dg=aug_adj_i)
   # out_nm_graph =paste0("~/jci/data_vario/graphs/", seed, "-y", node_i, "_variograph.dot") 
   # p=aug_node_n,contextVars=context_nodes,labels=1:aug_node_n,dg=aug_adj)
    
  
   
  return((list(goal_pi=goal_pi,goal_pi=goal_pi, goal_pa=true_pa_i,
               Vario_pi=pi,Vario_pa=pa,Vario_res=Vario_res,Vario_conf=pi_conf,
               pi_and_parents=rating,interventions=intervention_rating,adj=aug_adj_i)))
}


cmp_Vario_conf = function(pi, confints, pi_score){
  k = length(unique(pi))
  if (k==1) pi_conf = 0 
  else {
    B =  abs(mean(confints$conf_best))
    # W =  abs(as.numeric(Vario_res$confints$conf_pione[1,k-1]))
    W =  abs(mean(confints$conf_nogroups[,k-1]))
    # cat("Best", B, "Worst", W, " ")
    S = abs(pi_score)  
    if(S>B | S <W){
      if(S>B) pi_conf=1
      else pi_conf=0
    }
    else{ 
      B = B-W
      S = S-W
      pi_conf= S/B
    }
  }
  return(pi_conf)
}