
#TODO update

#' Check whether Vario can find the causal features, case: parameters change across groups, \code{Y=f^{Pi}(X) + N = alpha^{Pi}X + N
#' @details soft intervention at Y in the groups of Pi
#' Generate a random DAG, select nodes Y, generate data for Y using pa_G(Y) and group weights in each context, generate remaining nodes and run Vario
#' @param E_n num contexts
#' @param D_n num datasets
#' @export
synth_DAG_domainadapt = function(
  E_n=5,
  D_n=1000, 
  X_max_n=4,    
  node_n=7,
  deg_p=0.3,
  it_pre= 50,
  it_shape=5,
  confints=NULL,
  version_mdl =TRUE, 
  version_simp = TRUE
){
  sses_shift=c()
  sses_lm_shift=c()
  sses_lm_iid=c()
  sses_lmall_shift=c()
  sses_lmall_iid=c()
        sses_iid=c()
  out_dir="~/Vario/out/check_domainadapt/"
  out_createdir(out_dir)
  
  #shapes = sample_shapes(E_n, 50, incl_one_group = FALSE, incl_no_group = FALSE)
  shapes =list(c(6,1), c(5,2), c(5,1,1), c(4,1,1,1)) #minus the first  2 contexts, the first grp should have a majority
  it=0

  if(!length(confints )) 
    confints = list(conf_pione=sample_conf_pi_one(E_n, it_pre, FALSE),
                    conf_nogroups= sample_conf_nogroups(E_n, it_pre, FALSE),
                    conf_best=sample_conf_pi_best(E_n, it_pre, FALSE))
  config = init_config_analysis(confints, greedy_k=FALSE, version_mdl =version_mdl, version_simp = version_simp)  


  
  # Test each Pi
  for(shape in shapes){
     
    cat("(",paste(shape, collapse=""),")\n")


    for(sub_it in 1:it_shape){
      seed= sub_it
      g = generate_DAG_datasets(E_n+2, D_n,
                                shape,
                                shape_ch = c(1,1,1,1,1,1,1), #?
                                interv_future = TRUE,
                                one_intervention_per_context = FALSE,
                                interv_X_n = c(7,7), 
                                node_n=node_n, deg_p=deg_p,
                                show_context_coefficients = FALSE,
                                perfect_interventions = FALSE,
                                seed = seed)
      nodes = 1:length(g$node_MB)


      for(node_i in nodes){
          if(length(g$node_MB[[node_i]]$pa_ind)<1) next #Consider nodes with at least one parent and child

        data_obs = g$node_data[[node_i]][c(3,4,5,6,7)]
        names(data_obs) = paste("D", 1:5, sep="")
        DOBS <<- data_obs
        DNODE <<- g$node_data[[node_i]]
        data_new_shift = g$node_data[[node_i]][[2]]
        data_new_iid = g$node_data[[node_i]][[1]]
        
        part = shape_to_part(shape)

          result = synth_check_subset_search(data=data_obs,
                                             X_max_n=X_max_n,
                                             part[3:length(part)],
                                             markov_blanket=g$node_MB[[node_i]],
                                             confints=confints, out_nm=out_dir, vb=TRUE)
          
            if(result$Vario_conf<0.4) next
          
         # cat("Avg lm: ", paste0(result$Vario_res$pred_cfs, collapse=""))
          
          lm_obs = lm(y ~ ., data= data_obs[[1]])
          data_all=rbind( data_obs[[1]], rbind(data_obs[[2]], rbind(data_obs[[3]], rbind(data_obs[[4]], rbind(data_obs[[5]])))))
          lm_all = lm(y ~ ., data= data_all)
       #   lm_vario = lm(y ~ ., data= data_obs[[1]])
          
          pred_shift = predict(result$Vario_res$pred_lm,
                               data_new_shift)
          pred_iid = predict(result$Vario_res$pred_lm, 
                             data_new_iid)

          sse_iid = (pred_iid-data_new_iid[,length(data_new_iid)])^2
          sse_lm_iid = (predict(lm_obs, data_new_iid)-data_new_iid[,length(data_new_iid)])^2
          sse_shift = (pred_shift-data_new_shift[,length(data_new_shift)])^2
          sse_lm_shift = (predict(lm_obs, data_new_shift)-data_new_shift[,length(data_new_shift)])^2
          
          
          sse_lmall_iid = (predict(lm_all, data_new_iid)-data_new_iid[,length(data_new_iid)])^2 
          sse_lmall_shift = (predict(lm_all, data_new_shift)-data_new_shift[,length(data_new_shift)])^2
          
          sses_iid = c(sses_iid, sse_iid)
          sses_shift = c(sses_shift, sse_shift)
          sses_lm_iid = c(sses_lm_iid, sse_lm_iid)
          sses_lm_shift = c(sses_lm_shift, sse_lm_shift)
          sses_lmall_iid = c(sses_lmall_iid, sse_lmall_iid)
          sses_lmall_shift = c(sses_lmall_shift, sse_lmall_shift)
          
        
       #   box_shift = boxplot((pred_shift-data_new_shift[,length(data_new_shift)])^2)

          #stop()
          #lm1  = lm(y ~ ., data= DAG_DATA$node_data$y5$D2 )
          #rf = randomForest(y ~ ., data= DAG_DATA$node_data$y5$D2, mtry = 3, importance=TRUE, na.action=na.omit)
          #lm2  = lm(y ~ x1+x2, data= DAG_DATA$node_data$y5$D2 )

         # pred1 = predict (lm1, newdata)
          # pred2 = predict (lm2, newdata)
          # pred3 = predict (rf, newdata)
          # mean((pred3-DAG_DATA$node_data$y5$D5[,length(DAG_DATA$node_data$y5$D5)])^2)

          #boxplot((pred1-DAG_DATA$node_data$y5$D5[,length(DAG_DATA$node_data$y5$D5)])^2)
          # boxplot((pred2-DAG_DATA$node_data$y5$D5[,length(DAG_DATA$node_data$y5$D5)])^2)
          # boxplot((pred3-DAG_DATA$node_data$y5$D5[,length(DAG_DATA$node_data$y5$D5)])^2)

        it = it+1
      }
      it = it+1
    }
  }
  return(list(sses_iid=sses_iid,
              sses_shift=sses_shift,
              sses_lm_iid=sses_lm_iid,
              sses_lm_shift=sses_lm_shift,
              sses_lmall_iid=sses_lmall_iid,
              sses_lmall_shift=sses_lmall_shift))
}


simulate_domainadapt = function(){


}
