
# Partition Discovery----

show_decision_rates_mdl = function(E_n = 5, noise = 0.1, subdir_nm=""){
  cat( "\nCut\tAcc\t\tConsistent\tFinegrained\tReject\tNogroup\n")
  
    fnm = paste0("out/check_pi/mdl/",subdir_nm,"D", E_n, "_N", noise,"_all.txt")
    decision_rate_pi(fnm)

}
show_decision_rates_basic = function(E_n = 5, noise = 0.1, subdir_nm=""){
  cat( "\nCut\tAcc\t\tConsistent\tFinegrained\tReject\tNogroup\n")
 
  
    fnm = paste0("out/check_pi/basic/",subdir_nm,"D", E_n, "_N", noise,"_all.txt")
    decision_rate_pi(fnm)

}
show_decision_rates = function(E_n = 5, noise = 0.1, subdir_nm=""){
  cat( "\n|Pi|\tCut\tAcc\t\tConsistent\tFinegrained\tReject\tNogroup\n")
  for(k in 2:E_n){
    cat(k, "\t")
    fnm = paste0("out/check_pi/basic/",subdir_nm,"D", E_n, "_N", noise,"_k", k, ".txt")
    cat("- basic:")
    decision_rate_pi(fnm, 1)
    
    fnm = paste0("out/check_pi/mdl/",subdir_nm,"D", E_n, "_N", noise,"_k", k, ".txt")
    cat("- MDL:")
    decision_rate_pi(fnm, 1)
  }
}
# Decision rate per K-----

show_decision_rates_mdl_k = function(E_n = 5, noise = 0.1, subdir_nm=""){
  cat( "\n|Pi|\tCut\tAcc\t\tConsistent\tFinegrained\tReject\tNogroup\n")
  for(k in 2:E_n){
    cat(k, "\t")
    fnm = paste0("out/check_pi/mdl/",subdir_nm,"D", E_n, "_N", noise,"_k", k, ".txt")
    decision_rate_pi(fnm, 1)
  }
}
show_decision_rates_basic_k = function(E_n = 5, noise = 0.1, subdir_nm=""){
  cat( "\n|Pi|\tCut\tAcc\t\tConsistent\tFinegrained\tReject\tNogroup\n")
  for(k in 2:E_n){
    cat(k, "\t")
    fnm = paste0("out/check_pi/basic/",subdir_nm,"D", E_n, "_N", noise,"_k", k, ".txt")
    decision_rate_pi(fnm, 1)
  }
}
show_decision_rates_k = function(E_n = 5, noise = 0.1, subdir_nm=""){
  cat( "\n|Pi|\tCut\tAcc\t\tConsistent\tFinegrained\tReject\tNogroup\n")
  for(k in 2:E_n){
    cat(k, "\t")
    fnm = paste0("out/check_pi/basic/",subdir_nm,"D", E_n, "_N", noise,"_k", k, ".txt")
    cat("- basic:")
    decision_rate_pi(fnm, 1)
    
    fnm = paste0("out/check_pi/mdl/",subdir_nm,"D", E_n, "_N", noise,"_k", k, ".txt")
    cat("- MDL:")
    decision_rate_pi(fnm, 1)
  }
}

# For the pi-with-known-causal-parents plots; when synth_check_pi is called (from synth_DAG_param(subset_search=FALSE)), which writes output to "~Vario/out/check_pi/", in files "pi_5_2.txt" for 5 context and 2 groups (call on list("..pi_5_2.txt", "pi_5_0.txt","pi_5_3.txt","pi_5_4.txt","pi_5_5.txt"   )) 
decision_rate_pi= function(outfile_syth_check_pi,
                           cuts = 100){ 
  f=read.csv(  outfile_syth_check_pi, sep="\t")
  dec=sapply(f[,1], function(x) return(as.numeric(x)))
  dec2=sapply(f[,10], function(x) return(as.numeric(x)))
  dec3=sapply(f[,11], function(x) return(as.numeric(x)))
  dec4=sapply(f[,12], function(x) return(as.numeric(x)))
  dec5=sapply(f[,13], function(x) return(as.numeric(x)))
  
  
  conf=sapply(f[,2], function(x) return(as.double(x)))
  CF<<-conf
  ord =order(conf, decreasing=TRUE)
  dec=dec[ord]
  for(i in 1:cuts){
    cutoff=i*(100/cuts)
    cut=ceiling(cutoff*length(dec)/100)
    rel_dec=dec[1:cut]
    rel_dec2=dec2[1:cut]
    rel_dec3=dec3[1:cut]
    rel_dec4=dec4[1:cut]
    rel_dec5=dec5[1:cut]
    acc=length(which(rel_dec==1))/length(rel_dec)
    acc2=length(which(rel_dec2==1))/length(rel_dec)
    acc3=length(which(rel_dec3==1))/length(rel_dec)
    acc4=length(which(rel_dec4==1))/length(rel_dec)
    acc5=length(which(rel_dec5==1))/length(rel_dec)
   # avg_conf = sum(conf[1:cut])/length(dec[1:cut])
    #cat("acc at", cutoff, ":", acc, "\n")
    cat( cutoff, "\t",  acc, "\t\t", acc2, "\t\t", acc3, "\t\t", acc4, "\t", acc5,  "\t\t",# avg_conf,
         "\n") # The plot
  }
  
}


# to be called on outputs of synth_check_subsets (called from synth_DAG_param(subset_search=TRUE), outputs to "~Vario/out/check_causal/")
decision_rate_pi_causal = function(infiles, cutoff=0.3, breaks=100,
                                   version_mdl= TRUE, show_rates = FALSE){ #breaks: no larger than the max. number examples we have
  # F1 counts regarding causal parent retrieval: 
  true_pos=0
  true_pos_i=0
  f_pos=0
  f_pos_i=0
  
  # F1 counts regarding intervention retrieval:  (ie. is the partition correct)
  fn_pos=0
  fn_pos_i=0
  tn_pos=0
  tn_pos_i=0
  
  decision_rates = list()
  conf_decision_rates = list()
  accuracies = list()
  conf_accuracies = list()
 # avg_confs = list()
  
  fraction_children=list()
  
  intervention_f1 = list() #not "exact accuracy" on partitions, instead weaker: each context (except the first one, always observational) is a possible intervention location, that way compute FP,TP etc
  
  ct = 1 
  for(fle in infiles){
    
    #f="out_checkpa_vario/run1pi_5_0.txt")
    f=read.csv(  fle, sep="\t", row.names=NULL)
    
    #decisions on pi, counting exact partition matches (which is harder to achieve than to e.g. get one intervention right)
    dec_pi=sapply(f[,1], function(x) return(as.numeric(x)))
    
    if(breaks>length(dec_pi)) {
      cat("Not enough decisions, <", breaks, " in ", fle)
      breaks = length(dec_pi)
          if(breaks<2) stop()
      cat("\nSetting breaks to", length(dec_pi), "\n")
    }
     #retrieving causal parents:
    dec_tp=sapply(f[,2], function(x) return(as.numeric(x)))
    dec_fp=sapply(f[,3], function(x) return(as.numeric(x)))
    dec_fn=sapply(f[,4], function(x) return(as.numeric(x)))
    
    
    #confidence to order by:
    conf=sapply(f[,5], function(x) return(as.numeric(x)))
    # -> in case of version_mdl, this should be the gain!

    
    # intervention counts: 
    itp=sapply(f[,6], function(x) return(as.numeric(x)))
    ifp=sapply(f[,7], function(x) return(as.numeric(x)))
    ifn=sapply(f[,8], function(x) return(as.numeric(x)))
    itn=sapply(f[,9], function(x) return(as.numeric(x)))
    
    #children marked as parents by Vario:
    children_found=sapply(f[,10], function(x) return(as.numeric(x)))
    all_found=sapply(f[,11], function(x) return(as.numeric(x)))
    all_covariates=sapply(f[,12], function(x) return(as.numeric(x)))
    #The columns in the above are as in "cat" in synth_check_subset_search. 
    
    ord =order(conf, decreasing=TRUE)
    if(version_mdl) ord = order(conf, decreasing=FALSE)
    conf_cutoff=length(which(conf[ord]>=cutoff))
    if(version_mdl )conf_cutoff = conf[ord]
    
    dec_tp=dec_tp[ord]
    dec_pi = dec_pi[ord]
    dec_fp=dec_fp[ord]
    dec_fn=dec_fn[ord] 
    confs = conf[ord]
    itp = itp[ord]
    ifp = ifp[ord]
    ifn = ifn[ord]
    itn = itn[ord]
    
    
    
    true_pos =true_pos+ sum(dec_tp) #length(which(dec_tp==1))
    true_pos_i = true_pos_i +  sum(itp) #length(which(itp==1))
    f_pos =f_pos+ sum(dec_fp) #length(which(dec_fp==1))
    f_pos_i = f_pos_i + sum(ifp) #length(which(ifp==1))
    fn_pos =fn_pos+  sum(dec_fn) #length(which(dec_fn==1))
    fn_pos_i = fn_pos_i + sum(ifn) #length(which(ifn==1)) 
    
    children_found = children_found[ord]
    all_found = all_found[ord]
    all_covariates = all_covariates[ord]
    
    #cat(dec_tp)
    for(i in 1:breaks){
      cutoff = i
      cut=ceiling((cutoff*length(dec_tp))/breaks)
      #rel =length(dec[1:cut])
      #cat(cut, "\n")
      #cat(dec_pi[1:cut], "\n")
      
      rel_tp=sum(dec_tp[1:cut])
      rel_fp=sum(dec_fp[1:cut])
      rel_fn=sum(dec_fn[1:cut])
      rel_dec = length(which(dec_pi[1:cut]==1))   
      acc=rel_dec/length(dec_pi[1:cut])
      
      
  #    avg_conf = sum(conf[1:cut])/length(conf[1:cut])
      
      #avg_confs[[ct]] = avg_conf
      confident = which(conf[1:cut]>0)
      conf_tp=sum(dec_tp[confident]) 
      conf_fp=sum(dec_fp[confident]) 
      conf_dec= length(which(dec_pi[confident]==1))
      conf_acc=conf_dec/length(dec_pi[1:cut]) #will be worse as we only count confident ones - consider sth other than acc. to reflect mistakes
      #FNs stay the same, =missed
      
      
      rel_itp=sum(dec_tp[1:cut])
      rel_ifp=sum(dec_fp[1:cut])
      rel_ifn=sum(dec_fn[1:cut])
      
      
      rel_children=sum(children_found[1:cut])
      rel_allfound=sum(all_found[1:cut])
      frac_children = rel_children/rel_allfound
      
      
      interv_f1 = rel_itp/(rel_itp + (1/2)* (rel_ifp + rel_ifn))
      causal_f1 = rel_tp/(rel_tp + (1/2)* (rel_fp + rel_fn))
      conf_causal_f1 = conf_tp/(conf_tp + (1/2)* (conf_fp + rel_fn))
      #cat("\n tp: ", rel_tp, "   , fp:", rel_fp, "   , fn:", rel_fn, "   , f1:", f1)
      # acc=length(which(rel_dec==1))/length(rel_dec)
      if(length(fraction_children)>=ct)
        fraction_children[[ct]] = c( fraction_children[[ct]] , frac_children)
      else fraction_children[[ct]] = frac_children
      
      if(length(decision_rates)>=ct)
        decision_rates[[ct]] = c( decision_rates[[ct]] , causal_f1)
      else decision_rates[[ct]] = causal_f1
      
      
      if(length(conf_decision_rates)>=ct)
        conf_decision_rates[[ct]] = c( conf_decision_rates[[ct]] , conf_causal_f1)
      else conf_decision_rates[[ct]] = conf_causal_f1
      
      if(length(intervention_f1)>=ct)
        intervention_f1[[ct]] = c( intervention_f1[[ct]] , interv_f1)
      else intervention_f1[[ct]] = interv_f1
      
      
      
      if(length(accuracies)>=ct)
        accuracies[[ct]] = c( accuracies[[ct]] , acc)
      else accuracies[[ct]] = acc
      
      if(length(conf_accuracies)>=ct)
        conf_accuracies[[ct]] = c( conf_accuracies[[ct]] , conf_acc)
      else conf_accuracies[[ct]] = conf_acc
    }
    ct = ct + 1
    
  } 
  #Print for pgfplots
  # - cols: x y1 .. yk for each decision rate x and group number k of Pistar
  
  if(show_rates){
  ks = length(decision_rates)
  cat( "\nF1 Parents: \n\nx\t")
  for (j in 1:ks) cat("y", j, "\t", sep="")
  cat( "\n0\t")
  for (j in 1:ks) cat("1", "\t")
  cat("\n")
  
  for(i in 1:breaks){
    
    cat( i, "\t")
    for (j in 1:length(decision_rates))
      cat(decision_rates[[j]][i], "\t")
    cat("\n")
  } 
  
  cat( "\nF1 Confident Parents: \n\nx\t")
  for (j in 1:ks) cat("y", j, "\t", sep="")
  cat( "\n0\t")
  for (j in 1:ks) cat("1", "\t")
  cat("\n")
  
  for(i in 1:breaks){
    
    cat( i, "\t")
    for (j in 1:length(conf_decision_rates))
      cat(conf_decision_rates[[j]][i], "\t")
    cat("\n")
  }
  
  cat( "\nAccuracy Pi: \n\nx\t")
  for (j in 1:ks) cat("y", j, "\t", sep="")
  cat( "\n0\t")
  for (j in 1:ks) cat("1", "\t")
  cat("\n")
  for(i in 1:breaks){
    
    cat( i, "\t")
    for (j in 1:length(decision_rates))
      cat(accuracies[[j]][i], "\t")
    cat("\n")
  }
  
  cat( "\nAccuracy Conf Pi: \n\nx\t")
  for (j in 1:ks) cat("y", j, "\t", sep="")
  cat( "\n0\t")
  for (j in 1:ks) cat("1", "\t")
  cat("\n")
  for(i in 1:breaks){
    
    cat( i, "\t")
    for (j in 1:length(decision_rates))
      cat(conf_accuracies[[j]][i], "\t")
    cat("\n")
  }
  
  
  cat( "\n F1 Interventions on Y (in one context aat, for JCI each edge C_i -> Y): \n\nx\t")
  for (j in 1:ks) cat("y", j, "\t", sep="")
  cat( "\n0\t")
  for (j in 1:ks) cat("1", "\t")
  cat("\n")
  for(i in 1:breaks){
    
    cat( i, "\t")
    for (j in 1:length(intervention_f1))
      cat(intervention_f1[[j]][i], "\t")
    cat("\n")
  }
  }
  cat("\nTP Parents: ", true_pos)
  cat("\nFP Parents: ", f_pos)
  cat("\nFN Parents: ", fn_pos)
  cat("\nF1 Parents: ", true_pos/(true_pos + 1/2*(f_pos+ fn_pos)))
  
  cat("\n\nTP Interv: ", true_pos_i)
  
  cat("\nFP Interv: ", f_pos_i)
  cat("\nFN Interv: ", fn_pos_i)
  cat("\nF1 Interv: ", true_pos_i/(true_pos_i + 1/2*(f_pos_i+ fn_pos_i))) 
  
}


# read_JCI_fci123_results = function(method="fci", mode="jci123", dir ="~/Vario/out_relatedwork/"){ #also works for icp mc
#   
#   files <- list.files(path=dir, pattern="*.Rdata", full.names=FALSE, recursive=FALSE)
#   
#   #SIDs: (only for Y, the rest of the DAG set to true edges="best case")
#   sids_jci= c()
#   sids_jci_all= c()
#   sids_jci_aug= c()
#   
#   #TP FP FN TN, interv. TP FP FN TN: (only on Y)
#   counter_all = c(0,0,0,0,   0,0,0,0)
# 
#   for(file in files){
#     f = strsplit(file, "-")[[1]]
#     yi = f[2]
#     seed = f[1]
#     if (!(f[3]==method  & f[4]==mode )) next
#     load(paste0(dir,file))
#    if(method == "fci") adj_jci =  pag2edge(result$pag)
#    else {
#      if (method=="icp") adj_jci = result$edge[,-ncol(result$edge)]
#      else stop()
#    }
#   #  adj_true = read.csv(paste0("~/Vario/out/graphs_true/", seed, "-", yi, "-auggraph.csv")) 
#     adj_true = read.csv(paste0(dir, seed, "-", yi, "-truegraph.csv"))
#     
#     if(method == "fci"){
#      # tryCatch( 
#         metadatafile=paste("~/Vario/data_synthetic/", seed, "-", yi,'.json',sep='')#, error=next)    
#       metadata<-rjson::fromJSON(file=metadatafile) 
#       system_vars<-metadata$SystemVars
#       context_vars<-metadata$ContextVars 
#     } else{
#  system_vars=c(1:(ncol(adj_true)-4))
#  context_vars=c((ncol(adj_true)-3):(ncol(adj_true)))
#     }
#     
#     assert(length(system_vars)+length(context_vars)==ncol(adj_true)) 
#       
#     
#     #sid_overall = structIntervDist(as.matrix(adj_true), as.matrix(result$pag))$sid 
#     #sid_overall2 = structIntervDist(as.matrix(adj_true), as.matrix(result$edge))$sid 
#     
#     #sids_jci_all = c(sids_jci_all, sid_overall)
#     #not sure the above is meaningful when we only consider Y specifically
#     
#     
#     
#     
#     # instead, SIDs on graph where all edges not ingoing to Y are the true edges, and edges that would truly go to Y  removed and replaced by the method's predictions.
#   #  aug_adj_vario = adj_true# + adj_vario[system_vars,][,system_vars]  
#    # aug_adj_vario[,1] = adj_vario[,1]
# ###    aug_adj_jci = adj_true 
# ###    aug_adj_jci[,1] =  adj_jci[,1]  
#   ###  for (i in 1:length(aug_adj_jci[,1])) if(aug_adj_jci[i,1]==-1) aug_adj_jci[i,1]=0 
#     
#    part_true =  adj_true[1:length(system_vars),1:length(system_vars), drop=FALSE]
#    part_adj_jci = part_true
#     part_adj_jci[,1] =  adj_jci[1:length(system_vars),][,1]  
#     for (i in 1:length(part_adj_jci[,1])) if( part_adj_jci[i,1]==-1) part_adj_jci[i,1]=0 
#    # for (i in 1:nrow(part_adj_jci)) 
#     #  for (j in 1:length(part_adj_jci[i,])) 
#      #   if( i>length(system_vars) | j>length(system_vars)) part_adj_jci[i,j]=0 
#     counter = c(0,0,0,0,   0,0,0,0)
# for (i in 1:length(system_vars)){
#   is_pa = (adj_true[i,][1]==1)
#   is_pa_jci = (adj_jci[i,][1]==1)
#   
#   if(is_pa){
#     if(is_pa_jci) counter = counter + c(1,0,0,0, 0,0,0,0)
#     else counter = counter + c(0,0,1, 0, 0,0,0,0) 
#   }
#   else {
#     if(is_pa_jci) counter = counter + c(0,1,0,0, 0,0,0,0)
#   else counter = counter + c(0,0,0,1, 0,0,0,0) 
# }}
#     
#     
#     for (i in 1:length(context_vars)){
#       is_pa = (adj_true[system_vars+i,][1]==1)
#       is_pa_jci = (adj_jci[system_vars+i,][1]==1)
#       
#       if(is_pa){
#         if(is_pa_jci) counter = counter + c(0,0,0,0, 1,0,0,0)
#         else counter = counter + c(0,0,0,0, 0,0,1,0) 
#       }
#       else {
#         if(is_pa_jci) counter = counter + c(0,0,0,0, 0,1,0,0)
#       else counter = counter + c(0,0,0,0, 0,0,0,1) 
#     }}
#   
#     
#  #   sids_jci_aug = c(sids_jci,  structIntervDist(as.matrix(adj_true), as.matrix(aug_adj_jci))$sid )
#     part_sid =structIntervDist(as.matrix(part_true), as.matrix(part_adj_jci))$sid
#     
#  sids_jci = c(sids_jci,  part_sid )
#  
# ## if(part_sid==0) cat("Good: ", length(which(adj_true[system_vars,][1]==1)), length(which(adj_jci[system_vars,][1]==1)),"\n" )
#  
#  counter_all = counter_all+counter
#   }
#   
#   
# return(list(counter=counter_all,
#             sids_jci=sids_jci))
# }


# 
# SIDs_results=  function(method="vario", mode="", subdir_nm = "Example_diagonal/"){
#   if(method=="vario")
#     files = list.files(path=paste0("~/Vario/out/rdata_vario/",subdir_nm), pattern="*.RData", full.names=FALSE, recursive=FALSE)
#   else
#     files = list.files(path=paste0("~/Vario/out_relatedwork/", subdir_nm), pattern="*.Rdata", full.names=FALSE, recursive=FALSE)
#    # files = list.files(path=paste0("~/Vario/data_jci/", subdir_nm), pattern="*.Rdata", full.names=FALSE, recursive=FALSE)
#   
#   #TODO rename
#   #SIDs: (only for Y, the rest of the DAG set to true edges="best case")
#   sids_jci= c() 
#   #TP FP FN TN, interv. TP FP FN TN: (only on Y)
#   counter_all = c(0,0,0,0,   0,0,0,0)
#   counter_group = c(0,0,0,0,   0,0,0,0)
#   edges =0
#   edges_true =0
#   
#   for(file in files){
#     f = strsplit(file, "-")[[1]]
#     yi1 = f[2] 
#     seed = f[1]
#     if (method!="vario") 
#       if(!(f[3]==method  & f[4]==mode )) next
#       f2 = strsplit(yi1, "\\.")[[1]]
#     yi = f2[1]
#     #cat(file)
#      
# if(method=="vario"){
#     load(paste0("~/Vario/out/rdata_vario/", subdir_nm, file))
#   
#      nogroup = ((length(unique(result$goal_pi))==1 & result$goal_pi[1]==1)
#      | length(unique(result$goal_pi))==length(result$goal_pi))
#      group = !nogroup
#      
#      adj_jci = Vario_res_to_adj(result)
#      
#      adj_true = read.csv(#paste0("~/Vario/out_relatedwork/", #OR
#                                 paste0("~/Vario/out/graphs_true/", subdir_nm, "5-",
#                                 seed, "-", yi, "-truegraph.csv"))
#      
# }
#     else {
#       load(paste0("~/Vario/out_relatedwork/",subdir_nm, file))
#       group=TRUE #todo
#     
#       #TODO if data is by vario:
#     #adj_true = read.csv(paste0("~/Vario/out/graphs_true/", subdir_nm, "5-", #OR paste0("~/Vario/out/graphs_true/", subdir_nm), 
#      #                          seed, "-", yi1, "-truegraph.csv"))
#       adj_true = read.csv(paste0("~/Vario/data_jci/",  #OR paste0("~/Vario/out/graphs_true/", subdir_nm), 
#                                                          seed, "-", "-graphaug.csv"))
#      system_vars=c(1:(ncol(adj_true)-4))
#     context_vars=c((ncol(adj_true)-3):(ncol(adj_true)))            
#     
#        if(method == "fci"){ 
#          adj_jci =  pag2edge(result$pag)
#          metadatafile=paste("~/Vario/data_synthetic/", subdir_nm, seed, "-", yi1,'.json',sep='')#, error=next)    
#          metadata<-rjson::fromJSON(file=metadatafile) 
#          system_vars<-metadata$SystemVars
#          context_vars<-metadata$ContextVars 
#        } else{
#          system_vars=c(1:(ncol(adj_true)-4))
#          context_vars=c((ncol(adj_true)-3):(ncol(adj_true)))
#         adj_jci =  (result$edge) #(result$edge) 
#          # adj_jci= adj_jci[,-ncol(adj_jci)]
#        }}
#     
#     ATRUE <<- adj_true
#     AV <<- adj_jci
#     assert(length(context_vars)==4)
#     
#     
#     
#     for (i in 1:length(system_vars)){
#       for(j in 1:length(system_vars)){
#         if(adj_jci[i,j]==1) edges = edges +1 
#         if(adj_true[i,j]==1) edges_true = edges_true +1 
#       }
#     }
#     #  metadata<-rjson::fromJSON(file=metadatafile) 
#     #  system_vars<-metadata$SystemVars
#     #  context_vars<-metadata$ContextVars 
#     
#     assert(length(system_vars)+length(context_vars)==ncol(adj_true)) 
#     
#     part_adj_jci = adj_jci
#     for(i in 1:nrow(adj_jci))
#       for(j in 1:ncol(adj_jci)) 
#         part_adj_jci[i,j]  = adj_true[i,j]
#     part_adj_jci[,1] =  adj_jci[,1] 
#     for(i in 1:length( part_adj_jci[,1] )) if( part_adj_jci[i,1] ==-1)  part_adj_jci[i,1] =0
#     
#     part_true = matrix(0,ncol=ncol(adj_jci),nrow=nrow(adj_jci))
#     for(i in 1:nrow(part_true))
#       for(j in 1:ncol(part_true))
#         part_true[i,j]  =  adj_true[i,j] 
# 
#     AVp <<- part_adj_jci
#     
#     counter = c(0,0,0,0,   0,0,0,0)
#     for (i in 1:length(system_vars)){
#       is_pa = (adj_true[i,][1]==1)
#       is_pa_jci = (adj_jci[i,][1]==1)
#       
#       if(is_pa){
#         if(is_pa_jci) counter = counter + c(1,0,0,0, 0,0,0,0)
#         else counter = counter + c(0,0,1, 0, 0,0,0,0) 
#       }
#       else {
#         if(is_pa_jci) counter = counter + c(0,1,0,0, 0,0,0,0)
#         else counter = counter + c(0,0,0,1, 0,0,0,0) 
#       }}
#     if(method!="icp"){ #ow. only 1 regime!
#     for(i in context_vars){
#       is_pa = (adj_true[i,][1]==1)
#       is_pa_jci = (adj_jci[i,][1]==1)
#       
#       if(is_pa){
#         if(is_pa_jci) counter = counter + c(0,0,0,0, 1,0,0,0)
#         else counter = counter + c(0,0,0, 0, 0,0,1,0) 
#       }
#       else {
#         if(is_pa_jci) counter = counter + c(0,0,0,0, 0,1,0,0)
#         else counter = counter + c(0,0,0,0, 0,0,0,1) 
#       }}
#     
#     }
#     #   sids_jci_aug = c(sids_jci,  structIntervDist(as.matrix(adj_true), as.matrix(aug_adj_jci))$sid )
#     part_sid =structIntervDist(as.matrix(part_true), as.matrix(part_adj_jci))$sid
#     
#     sids_jci = c(sids_jci,  part_sid )
#     
# ####    if(part_sid==0) cat("Good: ", length(which(adj_true[system_vars,][1]==1)), length(which(adj_jci[system_vars,][1]==1)),"\n" )
#     
#     counter_all = counter_all+counter
#     if(group) counter_group = counter_group + counter
#   }
#   
#   
#   return(list(counter=counter_all,
#               counter_ifgroup = counter_group,
#               sids_jci=sids_jci,
#               edges = edges,
#               edges_true = edges_true ))
# }



#needs:in ~Vario/data_jci, the synth.data generated by JCI (simul script), e.g. "1.json", "1-data.csv", "1-graphaug.csv" for seed 1
#needs: in ~Vario/out_relatedwork, outputs of fci on this data, e.g. "1-y-fci-jci123-result.Rdata" for seed 1

# -> after script run_jcis_data.sh

# Causal discovery -----------------

read_results_synthdata =  function(#method = "jci", 
                                  #method="vario",
                                  method = "utigsp",
                                  mode="", # For JCI, mode = "fci123" or "obs" or "pooled"
                                  out_jci_nm="~/Vario/out/synthetic_out_jci_icp/", 
                                  out_vario_nm= "~/Vario/out/synthetic_out_vario/", 
                                  out_utigsp_nm= "~/Vario/out/synthetic_out_utigsp/", 
                                  out_data_nm="~/Vario/out/synthetic_graphs_jci/",  
                                  version_nm = "MDL/", #For Vario, ""Emp/",  or "MDL/"
                                  subdir_nm = "A_diagonal_shift/",  
                                  target_columns = c(1) , #hacky: have to match subdir_nm = "A_diagonal_shift/" 
                                  # -> which columns of files are relevant depends on data generation
                                  no_orphans = TRUE #to not include nodes that do not have any causal parents
                                  ){
 
  
  files = list.files(path=paste0(out_jci_nm, subdir_nm),
                       pattern="*.Rdata", full.names=FALSE, recursive=FALSE)
   
  system_vars<- c(1,2,3,4,5) 
  context_vars<- c(6,7,8,9)  
  
  counter_all = c(0,0,0,0,   0,0,0,0)
  counter_group = c(0,0,0,0,   0,0,0,0)
  edges =0
  edges_true=0
  it = 0
  sids_jci= c()  
  
  for(file in files){   
    it = it+1
    f = strsplit(file, "-")[[1]]
    seed = f[1] 
    f = strsplit(file, "-")[[1]] 
    has_mode =(method!= "vario" & method !="utigsp")
    #Find matching result files-----
    if (has_mode) {
      if (!(f[2]==method  & f[3]==mode )) next 
      }
    else if (!(f[2]=="fci"  & f[3]=="jci123" )) next  #to only read each file (i.e., DAG for one seed) once
    
    #Get adjacency mat ------------
    if(method=="vario"){
      adj_jci = matrix(0,length(system_vars)+length(context_vars),length(system_vars)+length(context_vars) )
      for(node_i in 1:length(system_vars)){
      res = read.csv(paste0(out_vario_nm, subdir_nm,version_nm, seed, "-y",node_i, "-graphvario.csv"))
      adj_jci[,node_i] = res[,1]
      }
   }
    else { 
      if(method =="utigsp"){
        adj_jci = matrix(0,length(system_vars)+length(context_vars),length(system_vars)+length(context_vars) )
        edge_list = read.csv(paste0(out_utigsp_nm,    subdir_nm,  seed, "-out.txt"))
        if(length(ncol(edge_list)))
        for (i in  1:nrow(edge_list)) 
          adj_jci[edge_list[i,2], edge_list[i,1]] = 1 
      }
    else{  load(paste0(out_jci_nm, subdir_nm, file))
      adj_jci = pag2edge(result$pag)
       
      if(method != "fci")
        adj_jci = (result$edge)
    }}  
       
      file_true = paste0(seed, "-graphaug.csv")
       files_true = list.files(path=paste0(out_data_nm, #"~/Vario/out/synthetic_graphs_jci/", 
                                           subdir_nm),
                              pattern="*-graphaug.csv", full.names=FALSE, recursive=FALSE)
      
      if(!file_true %in% files_true) {
        cat("SKIP") 
        next
      }
       #True adjacency matrix ------
       adj_true = read.csv(paste0(out_data_nm,  subdir_nm, seed, "-graphaug.csv"))
       
      # Extract Interventions -------
       #-> only contains C->Y if shift  intervention, thus do no use for mechanism changes.
      targets = read.csv(paste0(out_data_nm,  subdir_nm, seed, "-context_parents_yi.csv"))
      
      targets = targets[,target_columns]
      if(length(target_columns)==1)targets = t(t(targets))

      #Meaning: targets [yi,]  contains all indices of regimes (i.e. ith corresp to i+1th context) where y is different from obs context.
  
    for (i in 1:length(system_vars)){
      for(j in 1:length(system_vars))
        if(adj_jci[i,j]==1) {
          edges = edges +1
          edges_true = edges_true +1 
        }
    }
    
    assert(length(system_vars)+length(context_vars)==ncol(adj_true)) 
    
    
    counter = c(0,0,0,0,   0,0,0,0)
    
    for(node_i in system_vars){
      
      is_orphan =
       !( 1 %in% adj_true[,node_i][system_vars])
 
       
      
      if(is_orphan & no_orphans) next
      # part_adj_jci = adj_jci
      # for(i in 1:nrow(adj_jci))
      #   for(j in 1:ncol(adj_jci)) 
      #     part_adj_jci[i,j]  = adj_true[i,j]
      #   part_adj_jci[,node_i] =  adj_jci[,node_i]
      #   
      #   
      #   for(i in 1:length( part_adj_jci[,node_i] )) if( part_adj_jci[i,node_i] ==-1)  part_adj_jci[i,node_i] =0
      #   
      #   part_true = matrix(0,ncol=ncol(adj_jci),nrow=nrow(adj_jci))
      #   for(i in 1:nrow(part_true))
      #     for(j in 1:ncol(part_true))
      #       part_true[i,j]  =  adj_true[i,j] 
      #   
      #   AVp <<- part_adj_jci
        
        for (i in 1:length(system_vars)){
          is_pa = (adj_true[i,node_i]==1)
          is_pa_jci = (adj_jci[i,node_i]==1)
          
          if(is_pa){
            if(is_pa_jci) counter = counter + c(1,0,0,0, 0,0,0,0)
            else counter = counter + c(0,0,1, 0, 0,0,0,0) 
          }
          else {
            if(is_pa_jci) counter = counter + c(0,1,0,0, 0,0,0,0)
            else counter = counter + c(0,0,0,1, 0,0,0,0) 
          }}
        if(method!="icp"){ #ow. only 1 regime!
          
          
          for(i in 1:length(context_vars)){
            is_pa = (i %in% targets[node_i,] )##(adj_true[i,][node_i]==1)
            is_pa_jci = (adj_jci[(i+length(system_vars)),][node_i]==1)
            
            if(is_pa){
              if(is_pa_jci) counter = counter + c(0,0,0,0, 1,0,0,0)
              else counter = counter + c(0,0,0, 0, 0,0,1,0) 
            }
            else {
              if(is_pa_jci) counter = counter + c(0,0,0,0, 0,1,0,0)
              else counter = counter + c(0,0,0,0, 0,0,0,1) 
            }}
        }
        #   sids_jci_aug = c(sids_jci,  structIntervDist(as.matrix(adj_true), as.matrix(aug_adj_jci))$sid )
       # part_sid =structIntervDist(as.matrix(part_true), as.matrix(part_adj_jci))$sid
        
        #target specific sid:
        sids_jci = c(sids_jci,  0)#part_sid)
        
        ####    if(part_sid==0) cat("Good: ", length(which(adj_true[system_vars,][1]==1)), length(which(adj_jci[system_vars,][1]==1)),"\n" )
    }
    counter_all = counter_all+counter
    #  cat(counter_all, "\n")
     counter_group = counter_group + counter
   #if(seed >27) break
    # break
  
  }
  cat("\nTP Parents: ", counter_group[1])
  cat("\nFP Parents: ", counter_group[2])
  cat("\nFN Parents: ", counter_group[3])
  cat("\nF1 Parents: ", counter_group[1]/( counter_group[1] + 1/2*( counter_group[2]+ counter_group[3])))
  
  cat("\n\nTP Interv: ",  counter_group[5])
  
  cat("\nFP Interv: ",  counter_group[6])
  cat("\nFN Interv: ",  counter_group[7])
  cat("\nF1 Parents: ", counter_group[5]/( counter_group[5] + 1/2*( counter_group[6]+ counter_group[7])))
  
  
  return(list(counter=counter_all,
              counter_ifgroup = counter_group,
              sids_jci=sids_jci,
              edges = edges ,
              edges_true = edges_true ))
}



# 
# #Also merges icps files for each context variable
# SIDs_results_icp_jcidata =  function(method="icp", mode="mcstar", subdir_nm = "strictly_diag/"){
#   if(method=="vario"|method=="fci") stop()
#   # if(mode!="mcstar" & mode!="scstar" &
#   #   mode!="mc" & mode!="sc" ) stop() 
#   
#   files = list.files(path=paste0("~/Vario/out_relatedwork/" , subdir_results),
#                      pattern="*-1-result.Rdata", full.names=FALSE, recursive=FALSE)
#   # pattern="*.edge", full.names=FALSE, recursive=FALSE)
#   #files = list.files(path=paste0("~/Vario/data_jci/", subdir_nm), pattern="*.Rdata", full.names=FALSE, recursive=FALSE)
#   
#   if(mode %in% list("sc", "mc"))  files = list.files(path=paste0("~/Vario/out_relatedwork/" , subdir_results),
#                                                      pattern="*-result.Rdata", full.names=FALSE, recursive=FALSE)
#   sids_jci= c()  
#   counter_all = c(0,0,0,0,   0,0,0,0)
#   counter_group = c(0,0,0,0,   0,0,0,0)
#   edges =0
#   edges_true=0
#   it = 0
#   
#   for(file in files){
#     it = it+1
#     f = strsplit(file, "-")[[1]]
#     seed = f[1]
#     
#     f = strsplit(file, "-")[[1]]
#     
#     if(!(f[3]==method & f[4]==mode)) next
#     #paste(f[4], f[5], 1, sep="-")==mode )) next
#     
#     
#     cat(paste0(seed, ", "))
#     
#     file_true = paste0(seed, "-graphaug.csv")
#     files_true = list.files(path=paste0("~/Vario/data_jci/", subdir_nm),
#                             pattern="*-graphaug.csv", full.names=FALSE, recursive=FALSE)
#     
#     if(!file_true %in% files_true) {
#       cat("skip")
#       next
#     }
#     adj_true = read.csv(paste0("~/Vario/data_jci/", subdir_nm,
#                                seed, "-graphaug.csv"))
#     system_vars=c(1:(ncol(adj_true)-4))
#     context_vars=c((ncol(adj_true)-3):(ncol(adj_true)))            
#     
#     ATRUE <<- adj_true
#     assert(length(context_vars)==4)
#     
#     if(mode == "mcstar" |mode=="scstar"){
#       adj_jci = matrix(0,length(system_vars)+1,length(system_vars)+1)
#       icp_iter = f[5]
#       cat("ICP with obs. context and interv. context ", icp_iter, "\n")
#       
#       for(it in 1:4){
#         file_it = paste0("~/Vario/out_relatedwork/",
#                          subdir_results, f[1], "-", f[2],"-",f[3],"-",f[4], "-", it, "-result.Rdata")
#         load(file_it)
#         adj_it = result$arel # or edge
#         adj_jci = adj_jci + adj_it
#         
#       } 
#       file_allit = paste0("~/Vario/out_relatedwork/",
#                           subdir_results, f[1], "-", f[2],"-",f[3],"-",f[4], "additive-result.Rdata")
#       write.csv(adj_jci, file=file_allit )
#     }
#     else  {
#       file = paste0("~/Vario/out_relatedwork/",
#                     subdir_results, f[1], "-", f[2],"-",f[3],"-",mode,#f[4], 
#                     "-result.Rdata")
#       load(file)
#       adj_jci = result$arel
#     }
#     ##
#     for (i in 1:length(system_vars)){
#       for(j in 1:length(system_vars))
#         if(adj_jci[i,j]==1) {
#           edges = edges +1
#           edges_true = edges_true +1 
#         }
#     }
#     
#     assert(length(system_vars)+length(context_vars)==ncol(adj_true)) 
#     
#     
#     for(node_i in system_vars){
#       
#       part_adj_jci = adj_jci
#       for(i in 1:nrow(adj_jci))
#         for(j in 1:ncol(adj_jci)) 
#           part_adj_jci[i,j]  = adj_true[i,j]
#         part_adj_jci[,node_i] =  adj_jci[,node_i]
#         
#         # replace numbers by 1:
#         for(i in 1:length( part_adj_jci[,node_i] )) if( part_adj_jci[i,node_i] >1)  part_adj_jci[i,node_i] =1
#         
#         part_true = matrix(0,ncol=ncol(adj_jci),nrow=nrow(adj_jci))
#         for(i in 1:nrow(part_true))
#           for(j in 1:ncol(part_true))
#             part_true[i,j]  =  adj_true[i,j] 
#         
#         AVp <<- part_adj_jci
#         
#         
#         counter = c(0,0,0,0,   0,0,0,0)
#         for (i in 1:length(system_vars)){
#           is_pa = (adj_true[i,][node_i]==1)
#           is_pa_jci = (adj_jci[i,][node_i]>=1)
#           
#           if(is_pa){
#             if(is_pa_jci) counter = counter + c(1,0,0,0, 0,0,0,0)
#             else counter = counter + c(0,0,1, 0, 0,0,0,0) 
#           }
#           else {
#             if(is_pa_jci) counter = counter + c(0,1,0,0, 0,0,0,0)
#             else counter = counter + c(0,0,0,1, 0,0,0,0) 
#           }}
#         if(method!="icp"){ #ow. only 1 regime!
#           for(i in context_vars){
#             is_pa = (adj_true[i,][node_i]==1)
#             is_pa_jci = (adj_jci[i,][node_i]==1)
#             
#             if(is_pa){
#               if(is_pa_jci) counter = counter + c(0,0,0,0, 1,0,0,0)
#               else counter = counter + c(0,0,0, 0, 0,0,1,0) 
#             }
#             else {
#               if(is_pa_jci) counter = counter + c(0,0,0,0, 0,1,0,0)
#               else counter = counter + c(0,0,0,0, 0,0,0,1) 
#             }}
#         }
#         #   sids_jci_aug = c(sids_jci,  structIntervDist(as.matrix(adj_true), as.matrix(aug_adj_jci))$sid )
#         part_sid =structIntervDist(as.matrix(part_true), as.matrix(part_adj_jci))$sid
#         
#         #target specific sid:
#         sids_jci = c(sids_jci,  part_sid)
#         
#         ####    if(part_sid==0) cat("Good: ", length(which(adj_true[system_vars,][1]==1)), length(which(adj_jci[system_vars,][1]==1)),"\n" )
#     }
#     counter_all = counter_all+counter
#     #  cat(counter_all, "\n")
#     # if(group) 
#     counter_group = counter_group + counter
#     
#   }
#   cat("\nTP Parents: ", counter_group[1])
#   cat("\nFP Parents: ", counter_group[2])
#   cat("\nFN Parents: ", counter_group[3])
#   cat("\nF1 Parents: ", counter_group[1]/( counter_group[1] + 1/2*( counter_group[2]+ counter_group[3])))
#   
#   cat("\n\nTP Interv: ",  counter_group[5])
#   
#   cat("\nFP Interv: ",  counter_group[6])
#   cat("\nFN Interv: ",  counter_group[7])
#   cat("\nF1 Interv: ", counter_group[5]/( counter_group[5] + 1/2*( counter_group[6]+ counter_group[7])))
#   
#   
#   return(list(counter=counter_all,
#               counter_ifgroup = counter_group,
#               sids_jci=sids_jci,
#               edges = edges ,
#               edges_true = edges_true ))
# }
# 
# 
# 


Vario_res_to_adj=function(result){
  adj = matrix(0, length( result$Vario_res$covariates_nm)+1+length(result$goal_pi)-1, 
               length( result$Vario_res$covariates_nm)+1+length(result$goal_pi)-1)
  ingoing = sapply(1:(length(result$Vario_res$covariates_nm)+1), function(i) if ((i-1) %in% result$Vario_pa) return(1) else return(0))
  interv = sapply(2:length(result$goal_pi), function(i) if(result$Vario_pi[1]==result$Vario_pi[i]) return(0) else return(1))
  adj[,1] = c(ingoing, interv)
  return(adj)
}

random_guess = function(){
  if(sample(52,1)==1) return(1) else return (0)
}

show_confints_decisionrate_random_pi5 = function(){
  vals = sapply(1:100000, function(i) return(random_guess()))
  vals = vals[order(vals, decreasing = TRUE)]
  upper = c()
  lower = c()
  for (b in 1:100){
    brk = ceiling(b*length(vals)/100)
    vals_sub = vals[1:brk]
    upper = c(upper, cint(vals_sub)[1])
    lower = c(lower, cint(vals_sub)[2])
  }
  
  ks = 2
  cat( "\nConfint Random Guessing of a 5-group partition: \n\nx\t")
  for (j in 1:ks) cat("y", j, "\t", sep="")
  cat( "\n0\t")
  for (j in 1:ks) cat("1", "\t")
  cat("\n")
  
  for(i in 1:100){
    if(i==2 | i%%10==0){
      cat( i, "\t") 
      cat(upper[i], "\t", lower[i], "\n")
    }
  } 
  
}
#
