# utilities
source("~/Vario/R/utils/utils_data.R")
source("~/Vario/R/utils/utils_new.R")
source("~/Vario/R/utils/utils_graph_Vario.R")
source("~/Vario/R/utils/utils_gen_dataset.R")
source("~/Vario/R/utils/utils_gen_datasets.R")
source("~/Vario/R/utils/utils_hash.R")
source("~/Vario/R/utils/utils_k.R")
source("~/Vario/R/utils/utils_lm_formula.R") 
source("~/Vario/R/utils/utils_invariance_htests.R") 
source("~/Vario/R/utils/utils_out.R")
source("~/Vario/R/utils/utils_permute.R") 
source("~/Vario/R/utils/utils_pi.R")
source("~/Vario/R/utils/utils_pi_shapes.R") 
source("~/Vario/R/utils/utils_plot_ranking.R") 
source("~/Vario/R/utils/utils_regression.R")
source("~/Vario/R/utils/utils_regression_piecewise.R")
source("~/Vario/R/utils/utils_reproduce.R")
source("~/Vario/R/utils/utils_roc.R")
source("~/Vario/R/utils/utils_rw_transforms.R") 
source("~/Vario/R/utils/utils_synth_match.R")
source("~/Vario/R/utils/utils_synth_version.R")
source("~/Vario/R/utils/utils_sample.R")
source("~/Vario/R/utils/utils_sample_pi_one.R")
source("~/Vario/R/utils/utils_sample_pi_zero.R")
source("~/Vario/R/utils/utils_slice.R")

# simulations
source("~/Vario/R/exp_synthetic/check_DAG_linear.R")
source("~/Vario/R/exp_synthetic/generate_DAG_linear.R")
source("~/Vario/R/exp_synthetic/generate_DAG_linear_local.R")
source("~/Vario/R/exp_synthetic/check_pi_search.R") 
source("~/Vario/R/exp_synthetic/check_subset_search.R") 
source("~/Vario/R/exp_synthetic/read_results.R") 

#Sachs
source("~/Vario/R/exp_sachs/experiments_sachs.R") 
source("~/Vario/R/exp_sachs/experiments_sachs_truths.R")
source("~/Vario/R/exp_sachs/experiments_sachs_other.R")
source("~/Vario/R/exp_sachs/experiments_sachs_help.R")
source("~/Vario/R/exp_sachs/experiments_sachs_reproduce.R")

#REGED
source("~/Vario/R/exp_reged/experiments_reged.R") 
source("~/Vario/R/exp_reged/experiments_reged_truths.R")

# libraries
suppressMessages(library(combinat)) # permn()
suppressMessages(library(rlist))
suppressMessages(library(dplyr))


# Metrics and DAGS
suppressMessages(library(SID))
suppressMessages(library(igraph))  
#library(pcalg) 
#library(gmat) #rgraph() 

# Optional
suppressMessages(library(tictoc)) 
#suppressMessages(library(car)) # hypothesis testing for invariance 
suppressMessages(library(readxl)) # for Sachs data
#suppressMessages(library(jsonlite)) # json graph metadata for  JCI
#library(DiagrammeR) # jci graphviz
 