vario_elbow = function(cfs, C_part){
       C_history = init_history_C(1,1, as_mat(cfs),as_mat(cfs),as_mat(cfs))
       cls_Pi = new("cls_Pi")
       cls_Pi$init(C_part, 1, 1, 
                   version_mdl=TRUE,
                   version_simp=FALSE)
       cls_Pi$edit(C_history, C_part)
       cat("score:", cls_Pi$score_sum, "\n")
       return(cls_Pi)
   }

vario_mdl_loglik = function (mse_k, k, N=5, sig = 1){
            return( -(-(N/2)*logg(2*pi*sig^2) - 1/(2*sig^2) * mse_k))
       }

vario_mdl_model = function(cfs, C_part, p=5, sig=1){
  cls_Pi = vario_elbow(cfs, C_part) #to get MSE
  k = length(unique(C_part))
  L_loglik = vario_mdl_loglik(cls_Pi$mse_1_1, k, N=length(cfs), sig=sig)
  L_alpha = logg(p) * max((length(unique(C_part))-2),0)
  L_Pi = logg(choose(length(cfs)-1, length(cfs)-1-k))
  L_const = 0 #TODO maybe incl
  score = (L_alpha + L_loglik + L_const)
  cat("mdl:", score)
  return(score)
}



gen_pi_k_n = function(E_n = 5, noise=0){
  # if(!length(noise))
  #  noise = maxnoise(E_n) - 0.05
  #assert(E_n >= 3)
  k = E_n - 1
  # noise is intra-group distance of the first group wrt [0,1] interval
  cfs = rep (0, E_n)
  cfs[1] = -1/2 * noise
  #cfs[2] = 0 + noise 
  #Remaining coefficients: equispaced 
  ##rest = 1-cfs[2]
  ##step = rest/(E_n-2)
  rest = 1-cfs[1]
  step = 1#rest/(E_n-1)
  # The partition c((1,1),2,3,4..)
  C_part  = rep(1, E_n)
  cfs[2] = cfs[1]+1/2 * noise
  C_part[2]  = 1
  nextg = 2
  #if(E_n == 3){ 
  #  C_part[3] = 2
  #  cfs[3] = 1
  #}
  #else 
  for (g in 3:E_n) {
    C_part[g] = nextg
    cfs[g] = cfs[(g-1)] + step 
    if(g %% 2==0)cfs[g] =cfs[g]+1/2 * noise
    else  cfs[g] =cfs[g]-1/2 *noise
    nextg = nextg+1 
  }
 
  
  
  #cat(cfs, "\n")
  #cat(C_part, "\n")
  
  # Calc 
  C_history = init_history_C(1,1, as_mat(cfs),as_mat(cfs),as_mat(cfs), 
                             precomputing_mdl = TRUE)
  cls_Pi = new("cls_Pi")
  cls_Pi$init(C_part, 1, 1, version_mdl = TRUE, version_simp = TRUE,
              precomputing_mdl = TRUE) #st no loop
  
  cfs2 = rep (0, E_n)
  cfs[1] = 0-1/2 *noise
  for(i in 2:E_n){
    cfs2[i] = cfs2[(i-1)]
    if(g %% 2==0)cfs2[i] =cfs2[i]+1/2 * noise
    else  cfs2[i] =cfs2[i]-1/2 *noise
  }
  cfs2[E_n] = cfs2[E_n]  + 1
  C_history2 = init_history_C(1,1, as_mat(cfs2),as_mat(cfs2),as_mat(cfs2), 
                              precomputing_mdl = TRUE)
  
  C_part2 = rep(1,E_n)
  C_part2[E_n] = 2
  cls_Pi2 = new("cls_Pi")
  cls_Pi2$init(C_part2, 1, 1, version_mdl = TRUE, version_simp = TRUE,
               precomputing_mdl = TRUE) #st no loop
  cls_Pi2$edit(C_history2, C_part2) 
  cls_Pi2$edit(C_history2, C_part) 
  cls_Pi$edit(C_history, C_part) 
  cls_Pi$edit(C_history, C_part2) 
  
  p = -(cls_Pi$slopes_1_1_each_k[k]-cls_Pi$slopes_1_1_each_k[1])/(k-1)
  pp = -(cls_Pi$slopes_1_1_each_k[2]-cls_Pi$slopes_1_1_each_k[1])/1
  
  q = -(cls_Pi2$slopes_1_1_each_k[2]-cls_Pi2$slopes_1_1_each_k[1])/1
  qq = -(cls_Pi2$slopes_1_1_each_k[k]-cls_Pi2$slopes_1_1_each_k[1])/(k-1)
  
  
  return(list(p=p,pp=pp,qq=qq,q=q))
}

maxnoise = function(E_n){
  n = 0
  min = Inf 
  noises  = seq(500)/500
  for (noise in noises){
    res = gen_pi_k_n(E_n, noise)
    curr = abs(res$pp-res$qq) + abs(res$p-res$q)
    # if(curr<min) { 
    #  min = curr
    # 
    n = noise
    #}
    #cat("\np:", pq$p,", q:", pq$q)
   # if((res$p<=res$q) | (res$pp >= res$qq)) 
    if((res$pp>=res$qq))break
    else n=noise
  }
  return(n)
}

gen_pi_k_n_old = function(E_n = 5, noise=0){
 # if(!length(noise))
  #  noise = maxnoise(E_n) - 0.05
  #assert(E_n >= 3)
  k = E_n - 1
  # noise is intra-group distance of the first group wrt [0,1] interval
  cfs = rep (0, E_n)
  cfs[1] = 0
  cfs[2] = 0 + noise 
  #Remaining coefficients: equispaced 
  rest = 1-cfs[2]
  step = rest/(E_n-2)

  # The partition c((1,1),2,3,4..)
  C_part  = rep(1, E_n)
  nextg = 2
  if(E_n == 3){ 
    C_part[3] = 2
    cfs[3] = 1
  }
  else 
    for (g in 3:E_n) {
      C_part[g] = nextg
      cfs[g] = cfs[(g-1)] + step 
      nextg = nextg+1 
    }
  
  #cat(cfs, "\n")
  #cat(C_part, "\n")
  
  # Calc 
  C_history = init_history_C(1,1, as_mat(cfs),as_mat(cfs),as_mat(cfs), 
                             precomputing_mdl = TRUE)
  cls_Pi = new("cls_Pi")
  cls_Pi$init(C_part, 1, 1, version_mdl = TRUE, version_simp = TRUE,
              precomputing_mdl = TRUE) #st no loop
  cls_Pi$edit(C_history, C_part)
  psub = cls_Pi$slopes_1_1_each_k[(k-1)]
  p = -(cls_Pi$slopes_1_1_each_k[(k)] - cls_Pi$slopes_1_1_each_k[1] )/(k-1)
  

  return(p)
}

#maxnoise = function(E_n){
#  k = E_n - 1
#  steps = 1/k
#  return(steps)
#}

#D = generate_Collection(5,1000,1, 0, list(1),sample_group_cfs(c(2,3),list(1),c(5,5),c(0,1),config=list(bad_cfs = 0, bad_envs = 0)))



