#TODO make more readable

#usg one Xi, cub: d = gen_dataset_mv(1, list(2), 1000, coefs=list(c(1,0.5)), er_mean = 0, er_sig = 2)
gen_dataset_mv = function (I, degs, N, coefs, er_mean, er_sig, step = .1, offset = 0) {
  Xseq = seq (0, N*step, step)
  
  Xi_nms = c()
  for (i in 1:I){
    Xi = sample (Xseq, N, replace = FALSE)
    coef_Xi = as.numeric(coefs[[i]])
    deg_Xi = degs[[i]]
    
    term_Xi = getXiterm (Xi, coef_Xi, deg_Xi)
    
    Xi_nm = sc("x", i)
    Xi_nms = c(Xi_nms, Xi_nm)
    
    if (i==1) {
      e = rnorm(length(term_Xi), er_mean, er_sig)# TODO errors for all?? 
      Y = term_Xi + offset + e
      d_Xi = data.frame(Xi)
      d = d_Xi
    }
    else {
      Y = Y + term_Xi
      d_Xi = data.frame(Xi)
      d = cbind(d, d_Xi)
    }
  }
  d = cbind (d, Y)
  names(d) = c(Xi_nms, "y")
  return(d)
}



gen_dataset_null = function (I, Y_range, N, er_mean=0, er_sig=1, step = .1) {
  Xseq = seq (0, N*step, step)
  
  Xi_nms = c()
  for (i in 1:I){
    Xi = sample (Xseq, N, replace = FALSE)
    #Y_range_Xi =Y_ranges[[i]]
    Y_range_Xi = Y_range #TODO
    
    Xi_nm = sc("x", i)
    Xi_nms = c(Xi_nms, Xi_nm)
    
    if (i==1) {
      term_Xi = sample_real(Y_range_Xi, N)
      e = rnorm(length(term_Xi), er_mean, er_sig)# TODO need errors? 
      Y = term_Xi +  e
      d_Xi = data.frame(Xi)
      d = d_Xi
    }
    else {
      Y = Y + sample_real(Y_range_Xi, N)
      d_Xi = data.frame(Xi)
      d = cbind(d, d_Xi)
    }
  }
  d = cbind (d, Y)
  names(d) = c(Xi_nms, "y")
  return(d)
}



#TODO used ?
gen_dataset_some_Xis_mv = function (NXi, NXizero, degs, N, coefs, er_mean, er_sig, step = .1, offset = 0) {
  Xseq = seq (0, N*step, step)
  Xi_nms = c()
  if(NXi==0) stop()
  
  for (i in 1:(NXi + NXizero)){
    Xi = sample (Xseq, N, replace = FALSE)
    Xi_nm = sc("x", i)
    Xi_nms = c(Xi_nms, Xi_nm)
    
    if(i<=NXi) term_Xi = getXiterm (Xi, coefs[[i]], degs[[i]])
    
    if (i==1) {
      e = rnorm(length(term_Xi), er_mean, er_sig)# TODO errors for all?? 
      Y = term_Xi + offset + e
      d_Xi = data.frame(Xi)
      d = d_Xi#cbind (d, d_Xi )
    }
    else {
      if(i<=NXi) Y = Y + term_Xi
      d_Xi = data.frame(Xi)
      d = cbind(d, d_Xi)
    }
  }
  
  
  d = cbind (d, Y)
  names(d) = c(Xi_nms, "y")
  return(d)
}


# X=(X_i), Y
# Ncoll: environments
# Nxi: Xis
# Ndata: datapoints per env; Ndata_l: if varying numbers
# coef_ll: {env1:{X1: c(..), X2: c(...)}}
# deg_l: {degX1, degX2,..}

gen_datasets_mv = function (Ncoll, Nxi, Ndata, deg_l, coef_ll, 
                            error_mn=0, error_sig=20, # the max, can sample it for every collection.. but control that over hyperparams
                            step=.1, offset=0, Ndata_l=NULL, error_sigs=NULL, out_f=NULL, plot_f=NULL,
                            NXizero = 0, debug=FALSE,
                            
                            add_reference_datasets =TRUE){
  
  if(length(coef_ll)!= Ncoll | length(deg_l) != Nxi
     | (length(Ndata_l) & length(Ndata_l)!= Ncoll)
     | (length(error_sigs) & length(error_sigs)!=Ncoll)) {
    stop("(gen_datasets_mv) Inconsistent Lengths")}
  
  Ndata_l = rep(Ndata, Ncoll)
  error_sigs =  rep(error_sig, Ncoll) 
    #sample.int(error_sig, Ncoll, replace = TRUE)  
  namesD = list()
  lstD = list()
  listD_null = list()
  
  D = create_h()
  xinamesD = NULL
  
  for (set_i in 1:length(coef_ll)){ #TODO seq_along(coef_ll)){#
    coef_l = coef_ll[[set_i]]
    if(length(coef_l)!=Nxi) stop("(gen_datasets_mv) Inconsistent Lengths") 
    
    
    if(NXizero==0)
      d_i = gen_dataset_mv(Nxi, deg_l, Ndata_l[set_i], coef_l, error_mn, error_sigs[set_i])
    else
      d_i = gen_dataset_some_Xis_mv(Nxi, NXizero, deg_l, Ndata_l[set_i], coef_l, error_mn, error_sigs[set_i])
    
    #TODO ok for univariate, if mv,take Y's range over all Xi for each I guess? f now no distinction for Xi
    if(add_reference_datasets){
      d_i_range = c(min(d_i[,"y"]), max(d_i[,"y"]))
      #num datapoints and Xis? test one-one cmp first (one Di, no groups/pooling)
      d_i_null = gen_dataset_null(Nxi+NXizero, d_i_range,  Ndata_l[set_i])
      listD_null[[set_i]]= d_i_null
    }
    
    if(!length(xinamesD)){
      xinamesD = list()
      for(x_i in 1:(Nxi + NXizero)){
        xinamesD = lc(xinamesD, sc("x", x_i))
      }
    }
    namesD = lc(namesD, paste("D", set_i, sep=""))
    lstD[[set_i]]= d_i 
    add_h(paste("D", set_i, sep=""), d_i, D)
  }
  
  names(lstD) = namesD
  listD = lstD
  #namesD = namesD
  xinamesD = xinamesD
  
  if(debug) if(length(out_f)) print_truecoef_mv(Ncoll, Nxi, NXizero, Ndata_l, deg_l, coef_ll, error_mn, error_sigs, out_f, namesD)  
  
  return(list("D_data"=listD, 
              "D_null"=listD_null, 
              #"D_names"=namesD, 
              "X_names"=xinamesD))
}




# print---- 

#test = formatEq (list("lin", "q", "cub"), list(c(0.5), c(0.4,0.3), c(0.2,0.1,0)))


print_truecoef_mv = function (Ncoll, Nxi, NXizero, Ndata_l, deg_l, coef_ll, 
                              error_mn, error_sigs, fname, namesD) {
  
  out("\n\nData Generation:", f=fname)
  out(formatEq(deg_l, coef_ll[[1]]), sep ="", ln="",  f=fname)
  
  for (set_i in 1:length(coef_ll)) {
    out("\n\n",namesD[[set_i]], "\tN = " , formatC(Ndata_l[[set_i]], digits = 0, format = "f"),sep="", f=fname)
    out("\terr = " , formatC(error_sigs[[set_i]], digits = 0, format = "f"), sep="", f=fname)
    
    coef_l = coef_ll [[set_i]]
    for (x_i in 1:length(coef_l)){
      out("\n\t" , "X", formatC(x_i, digits = 0, format = "f"), " ", sep="", f=fname)
      coefs = coef_l[[x_i]]
      #summ(coefs, f=fname)
      c_i = 1
      for (c in coefs){
        nm = i_to_coefnm(c_i)
        if(c_i < length(coefs)) sep="," 
        else sep=""
        if(c_i>3) th = "th" else th =""
        out("\t",nm, th, " = ", formatC(c, digits = 3, format = "f"), sep, ln="", f=fname)
        c_i = c_i + 1
      }
    }
    for (x_i in 1: NXizero) out("\n\t" , "X", formatC(x_i+Nxi, digits = 0, format = "f"), " no influence", sep="", ln="", f=fname)
    
  }
  outln(f=fname)
}  


#show regression coefficients
#not used currently
print_regcoefinfo = function (out, DataTable, groupsDetailed = FALSE, mini=TRUE) {
  
  if(mini) fname = out
  else  fname = paste(out, "coefficients.txt", sep = "")
  summn("\n--------------------\nRegression estimates:", f = fname)
  
  gi = 1
  for (G in DataTable) {
    if(gi==1) NGof1 = length(G) 
    
    si = 1
    out("\n\n", names(DataTable)[gi], sep = "", f = fname)
    sumentgausse = 0
    
    for (Set in G) {
      out("\n(", names(G)[si], ")", sep = "", f = fname)
      
      modelcoefs = unname(Set$model$coefficients) #standard regression coefs
      isLin = ifelse(length(Set$coefficients) == 1, TRUE, FALSE)
      
      ci = 1 #coef count
      for (c in Set$coefficients) {
        if(groupsDetailed || gi == 1){#alw detailed info for single datasets, sometimes also for groups
          #if (!isLin) 
          out("\t(", names(Set$coefficients)[ci], ")", f = fname) #print coefname
          
          # summln(f=fname)
          sigmae = getErrSigma(Set)
          if (!length(c$mean_estimate) || !length(c$mean_bayes) || !length(c$sd_bayes)
              || !length(c$CFI) || !length(c$CI) || !length(sigmae) ) stop("(generate_datainfo) entry not found")
          
          
          out("\t\tFreq.\t\tmu", c$mean_estimate, "\t\tcfi ", c$CFI, f = fname)
          out("\t\tBayes\t\tmu", c$mean_bayes, "\t\tci", c$CI,
              "\t\tsigma ", c$sd_bayes, "\t\tsigmaerr ",sigmae, f = fname)
        }
        else{
          if (!length(c$mean_estimate) || !length(c$mean_bayes)) stop("(generate_datainfo) entry not found for a group")
          #summn(list("F\t\tmu ", c$mean_estimate), f = fname)
          out("\tmu", c$mean_bayes, f = fname)
        }
        ci = ci + 1
        
        if(gi ==1){
          if(!length(Set$model_bayes)) stop("(generate_datainfo) bayesmodel entry not found")
          sse = getSSEbm(Set) #TODO 
          sz = getsize(Set)
          # entgauss = error_enc(NGof1, sigmae) #change
          entgausse = gaussian_score_sse(sigmae, sse,sz)
          sumentgausse =  sumentgausse + entgausse
          # summn(list("D\t\tent-gauss-sse", entgausse), f = fname)
        }
      }
      si = si + 1
    }
    if (gi == 1) {
      #entmvgauss = error_enc_mv(NGof1, k=, errsigs=)#TODO
      out("\nL(Data | Regression Coefs) = ", sumentgausse, f=fname)
    }
    gi = gi + 1
  }
  outln( f=fname)
}




#show regression coefficients
print_regcoefinfo_mv = function (out, DataTable, showGroups=FALSE, mini=TRUE) { #mini: put all in one resultfile. 
  
  if(mini) fname = out
  else  fname = paste(out, "coefficients.txt", sep = "")
  out(delim, "Regression estimates:", f = fname)
  
  gi = 1
  for (G in DataTable) {
    if(gi==1) NGof1 = length(G) 
    if(gi>1&!showGroups) break
    
    si = 1
    out("\n\n", names(DataTable)[gi], sep = "", f = fname)
    sumentgausse = 0
    
    for (Set in G) {
      out("\n(", names(G)[si], ")", sep = "", f = fname)
      
      mi = 1
      for (Model in Set$models){
        if(length(Set$models)>1) out("\nModel", formatC(mi, digits=0, format = "f"), sep = "", f = fname)
        xi = 1
        for (Xi in Model$xis) {
          modelcoefs = unname(Xi$coefficients) #standard regression coefs
          # isLin = ifelse(== 1, TRUE, FALSE)
          out("\n\t(", names(Model$xis)[xi], ")",sep="", f = fname) #print coefname
          
          ci = 1 #coef count
          for (c in modelcoefs) {
            if(gi == 1){
              
              out("\t-", names(Xi$coefficients)[ci], " ", Xi$coefficients[[ci]],sep="", f = fname) #print coefname
              # If bayesian also for multivariate: can show some addt info here. Info in Model$model!
              # Prev sigmae = getErrSigma(Set)
              # if (!length(c$mean_estimate) || !length(c$mean_bayes) || !length(c$sd_bayes)
              #  || !length(c$CFI) || !length(c$CI) || !length(sigmae) ) summn("(generate_datainfo) entry not found", f = "errors.txt")
              
              
              #summn(list("\t\tFreq.\t\tmu", Xi$coefficients[[ci]], "\t\tci ", confint(Model$model)[ci+1,], #+1 to skip intercept 
              #       "\t\tSSE ", sum(Model$model$residuals^2)), f = fname)
              
              #Prev
              #summn(list("\t\tBayes\t\tmu", c$mean_bayes, "\t\tci", c$CI,
              #          "\t\tsigma ", c$sd_bayes, "\t\tsigmaerr ",sigmae ), f = fname)
            }
            else{
              if (!length(Xi$coefficients[[ci]])) summn("(generate_datainfo) entry not found for a group", f = "errors.txt")
              
              out("\t-", names(Xi$coefficients)[ci], " ", Xi$coefficients[[ci]],sep="", f = fname)
            }
            ci = ci + 1
            
            # if(gi ==1){
            #if(!length(Set$model_bayes)) summn("(generate_datainfo) bayesmodel entry not found", f = "errors.txt")
            #sse = getSSEbm(Set) #TODO 
            #sz = getsize(Set)
            #entgausse = gaussian_score_sse(sigmae, sse,sz)
            #sumentgausse =  sumentgausse + entgausse
            ## summn(list("D\t\tent-gauss-sse", entgausse), f = fname)
            # }
          }
          mi = mi+1
        }
        xi = xi+1
      }
      si = si+1
    }
    #if (gi == 1) {
    # summn(list("\nL(Data | Regression Coefs) = ", sumentgausse), f=fname)
    #}
    gi = gi + 1
  }
  outln(f=fname)
}



# --util------
formatEq  = function(deg_l, coef_l, shownumbers = FALSE){
  s = "Y = "
  for (i in 1:length(deg_l)){
    deg = deg_l[[i]]
    nm = sc("X", i)
    s = sc(s,ifelse(i==1, "", " + "))
    coefs = coef_l[[i]]
    
    for (j in 1: length(coefs)){
      times = ifelse (j==1, "", sc("^", j))
      plus =  ifelse (j==1, "", " + ")
      coef = ifelse (shownumbers, coefs[j], i_to_coefnm(j))
      s = sc(s, plus, coef," * ", nm, times)
    }
    
  }
  return(s)
}


getXiterm = function (Xi, coefs, deg){ 
  if(deg > 10 | length(coefs) != deg) stop(sc(deg,":", clld(coefs, 2)))
  cur_deg = 1 
  tm = 0
  while(cur_deg<=deg){
    tm = tm + coefs[cur_deg] * Xi^cur_deg
    cur_deg = cur_deg + 1
  }
  return(tm)
}


getXiterm_uptocub = function (Xi, coefs, deg){ 
  switch(deg, 
         lin={ tm = coefs[1]* Xi },
         q={ if(length(coefs)<2) stop ("(termXi) degree" )
           tm = coefs[1] * Xi + coefs[2] * Xi^2},
         cub={ if(length(coefs)<3) stop ("(termXi) degree" )
           tm = coefs[1] * Xi + coefs[2] * Xi^2 + coefs[3] * Xi^3  },
         stop("degree?")
  )
  return(tm)
}

