logg = function(x){
  if(x == 0){
    return(0)
  }else{
    return(log2(x))
  }
}

logN = function(z){
  z = ceiling(z)
  if(z < 1){
    return(0)
  }else{
    logstar = logg(z)
    sum = logstar
    while(logstar > 0){
      logstar = logg(logstar)
      sum = sum + logstar
    }
    return(sum + logg(2.865064))
  }
}


logg = function(x){
  if(x == 0){
    return(0)
  }else{
    return(log2(x))
  }
}
log2fac = function(n){
  sum = 0
  for(i in 2:n){
    sum = sum + logg(i)
  }
  return(sum)
}
log2nChoosek = function(n, k){
  if(k > n | k == 0){
    return(0)
  }else{
    return(log2fac(n) - log2fac(k) - log2fac(n-k))
  }
} 
logZ  = function(cfs, prec = 3){
  sum = 0 
  for(c in cfs){
    if(c != 0){
      ca = abs(c)
      cdummy = ca
      prec = 1
      while(cdummy < 1000){
        cdummy = cdummy * 10
        prec = prec + 1
      }
      sum = sum + logN(cdummy) + logN(prec) + 1
    }
  }
  return(sum)
}


mses_part = function( cfs, part){
  return(sum(sapply(unique(part), function(cls){
    mem = which(part==cls)
    mn = mean(cfs[mem])
    mse_cls= sum(sapply(cfs[mem], function(cf) return((cf-mn)^2)))
    return(mse_cls)  }))/length(cfs))
}


#TODO clean up ------
# Reference distribution -------- 

#' Exp means for cf_null_equi
means_null_equi = function(cfs, G)
  quantile(cfs, probs=sapply(1:G, function(g) g/length(cfs)))

#' Expected value of G means w reference distribution=uniform(no signal): equi spaced
cf_null_equi = function(cfs, times){ 
  start = min(cfs)
  #times = length(cfs)
  slice_len = abs(max(cfs)-start)/(times-1)
  return(sapply (0:(times-1), function(t) 
  {return(start + t * slice_len)}))
}





# usg
# cf_c: 1.0 1.2 3.0 3.2 8.0 8.1
# cmp_obj = cmp_L_M(cf_c)
# (not cmpl working )use equi means for data, too (as fst test):  infer_K_means(cmp_obj$cf_ord, 6)
# p1 = c(1,1,1,1,1,1)
# > p2 = c(1,1,1,1,2,2)
# > p3 = c(1,1,2,2,3,3)
# > p4 = c(1,1,2,3,4,4)
# > p5 = c(1,2,3,4,5,5)
# > p6 = c(1,2,3,4,5,6)

#mns = lapply(list(p1,p2,p3,p4,p5,p6), function(p) infer_means(p, cmp_obj$cf_ord))
#cmp_L_means(cmp_obj, mns)
#incr version:
#hist_obj_1 = init_L_partition(cmp_obj) (uses p1)
#hist_obj_2 = next_L_partition(part =p2, hist_obj_1) etc.

# Model distribution Q -----

#specify desired group w arg "part"
infer_means = function (part, cfs){
  return(sapply(unique(part), function(cls){
    mem = which(part==cls)
    mn = mean(cfs[mem])
    return(mn)
    
  }))
  
}
infer_sds = function (part, cfs){
  
  return(sapply(unique(part), function(cls){
    mem = which(part==cls)
    sds =ifelse(length(mem)==1, 1, sd(cfs[mem]))
    return(sds)
    
  }))
}

infer_splits = function (part, cfs){ #TODO: (sclaed) groups need to be at least one apart.
  
  groups = unique(part)
  left_groups = length(groups)-1
  
  return(sapply(1:left_groups, function(left_i){
    left_cls = groups[left_i]
    right_cls = groups[left_i + 1]
    
    left_mem = cfs[max(which(part==left_cls))]
    right_mem = cfs[min(which(part==right_cls))]
    assert(left_mem<=right_mem)
    
    return(ceiling(left_mem + 1/2 * abs(right_mem-left_mem)))
    
  }))
}

histogram_prbs_classes = function(part, cfs, prec = 100){
  N = length(cfs)
  classes = unique(part)
  assert(prec > 1)
  sapply(cfs, function(cf) assert(cf>=0.9  & cf<=prec+2, cf))
  
  if(length(classes) ==1) return (N/(N*prec))
  
  splits = infer_splits(part, cfs)
  splits[length(splits)+1] = prec
  assert(length(splits)==length(classes))
  
  sapply(1:length(classes), function(cls_i){
    cls = classes[cls_i]
    mem = which(part==cls)
    
    # sapply(cfs[mem], function(cf) 
    #  if(cls_i < length(classes)) assert(cf<=splits[cls_i])
    # else  assert(cf>=splits[cls_i-1], cf)) #sanity
    
    if(cls_i==1)
      split_len = splits[1]-1
    else 
      split_len = splits[cls_i]-splits[cls_i-1]
    
    # if(split_len==0)split_len=1
    
    
    #  if(length(mem)>1)split_len = max(cfs[max(mem)] - cfs[min(mem)], 1)
    
    return(length(mem) / (N*split_len))
    #sum splitlen-i * prb integr to 1
    
  })
}

histogram_prbs_samples = function(part, cfs){
  
  class_prbs = histogram_prbs_classes(part,cfs)
  dataset_prbs = sapply(1:length(cfs), function(cf_i) {
    cls= part[cf_i]
    return(class_prbs[cls])
    
  })
  return(dataset_prbs)
}

# use the null partitions for testing (not optimal)
infer_K_means = function(cf_ord, K){
  lapply(1:K, function(k){
    part = part_null(cf_ord, k)
    return(infer_means(part, cf_ord))
  })
}


# Loss (Pemp, Q): MSEs ------- 
#' L(D|G) for all datasets/cfs and all G means, or L(M) for samples from null distr
#' @return \code{mat(D_n x num_comp), row i: c( dist(G1, Di), .. dist(G_num_comp, Di) )}
#' @export
 dispersion = function (num_components, 
                       means_g, samples){
  g = num_components
  D_n = length(samples) 
  #means_g = means[[g]]
  assert(length(means_g)==g, length(means_g))
  
  each_D = 1:D_n
  dist_mat = sapply (each_D, function (D_i) 
    dispersion_Di (D_i, g,  means_g, samples)) 
  
  if(is.null(nrow(dist_mat))) assert(length(dist_mat)==D_n)
  else assert(nrow(dist_mat)==g & ncol(dist_mat)==D_n)
  return(dist_mat) 
  
}


likelihood = function (g, means_g, samples)
{ return(sapply ( 1:length(samples) , function (D_i) 
  likelihood_Di (D_i, g,  means_g, samples))) }



#'  L(D|G) one dataset to all G means
#' @return \code{c( L(G1, currD), .. L(G_num_comp, currD) )} 
#' @export
dispersion_Di = function(D_i, g, means_g, samples,
                         squared_err = TRUE) {
  val_i = samples[D_i]
  
  to_groups = 1:g
  sapply(to_groups, function(g_j){ 
    mean_j = means_g[g_j]
    if(squared_err) dist = (mean_j - val_i)^2
    else  dist = abs(mean_j - val_i)
    return(dist)
  })
}


likelihood_Di = function(D_i, g, means_g, samples) {
  sapply( 1:g, function(g_j)
    -logg(dnorm(samples[D_i], mean=means_g[g_j], sd=1))) #sd 1?
}



#Extract the best(min) assignments of each D to k groups from mat -> normalized sum (ow like eval)
sum_assignment_mat = function (num_components, mat,
                               #TODO 
                               normalize= TRUE,
                               ceil = TRUE){
  # mat: MSEs (row:group up to g many, col:Di)
  # f each dataset, add to best group = one row-path through mat -> complete W
  
  if(is.null(nrow(mat)))
    return(sum(mat)/length(mat))
  
  g = num_components
  for_g = 1:g
  for_Di = 1:ncol(mat)
  
  assert(g==nrow(mat))
  n_mem = rep(0, g)
  sum_mem = rep(0, g)
  
  for(i in for_Di){
    dists_f_Di = mat[,i]
    best_g = which(dists_f_Di==min(dists_f_Di))
    
    n_mem[best_g] = n_mem[best_g] + 1
    sum_mem[best_g] = sum_mem[best_g] + min(dists_f_Di)
  }
  
  min_assignment_Di_g = sum(sapply(for_g, function(g) 
    if(n_mem[g]==0) return(0)
    else if(normalize) {
      if(ceil) return(ceiling(sum_mem[g] / n_mem[g])) #ceil f log
     else  return((sum_mem[g] / n_mem[g]))
    }
    else  {
      if(ceil) return(ceiling(sum_mem[g]))
  else return(sum_mem[g])
}))
  
  return(min_assignment_Di_g)
}






#given e.g.  dispersion(2, c(1.5 80.0), c(1,3,60,80,100))=
#[,1]    [,2]    [,3]    [,4]    [,5]
#[1,]    2.25    2.25 3422.25 6162.25 9702.25
#[2,] 6400.00 5929.00  400.00    0.00  400.00
#grp   1st, 1st, 2nd,2nd, 2nd (col wise min).

#For the best(min) assignments of each D to k groups, get the intra-group-mse instead

#Problem: overlapping groups.->simplification: do it on group means.
#Problem: need intra as well if want to cmp to Gaussian ref!
interdist = function( means_g, 
                     squared_err = TRUE) {
  g = length(means_g)
  if(g==1) return(0)
  to_groups = 2:g
  return(ceiling(sum(sapply(to_groups, function(g_j){ 
    mean_i = means_g[g_j-1]
    mean_j = means_g[g_j]
    if(squared_err) dist = (mean_j - mean_i)^2
    else  dist = abs(mean_j - mean_i)
    return(dist)
  })))/(g-1))
}


# 
# #TODO do this f intra  too!
# #need samples in same order as dispersion mat, but not necessarily ordered groups.
# sum_inter = function (samples,part){
# 
#   g = length(unique(part))
#   if(g==1) return(0)
#   assert(length(samples)==length(part))
# 
#   for_g = 1:g
#   for_Di = 1:length(samples)
#   
#   n_mem = rep(0, g)
#   rng_mem = lapply(for_g, function(g) return(c(Inf, -Inf)))
#   
#   for(i in for_Di){
#     best_g = part[i]
#     if(length(best_g)>1) best_g = best_g[1]
#     
#     n_mem[best_g] = n_mem[best_g] + 1
#     if(samples[i]<rng_mem[[best_g]][1]) rng_mem[[best_g]][1] =samples[i] 
#     if(samples[i]>rng_mem[[best_g]][2]) rng_mem[[best_g]][2] =samples[i] 
#   #  print(sc(c("Cf value", samples[i], "to", best_g)))
#   }
#   
#   
#   
#   min_assignment_Di_g = sum(sapply(2:length(n_mem), function(gright) {
#     gleft = gright-1
#     if((rng_mem[[gleft]][2])>(rng_mem[[gright]][1])) gd= 0
#     else gd= (rng_mem[[gleft]][2]-rng_mem[[gright]][1])^2
#   #  print(sc(c("Groups", clld(c(gleft,gright),d=0),  "=", gd)))
#     return(gd)
#   }))
#   
#   gdsum = ceiling(min_assignment_Di_g) / (length(n_mem)-1) #ceil f log
#   #print("-----------")
#  # print(sc(c("Sum", gdsum)))
#   return(gdsum)
# }


# 
# # with assignment mat-> based on best assignment!!
# #need intra AND inter. group overlap: count inter zero (bad)
# #need samples in same order as dispersion mat, but not necessarily ordered groups.
# sum_inter_assignment_mat = function (num_components, 
#                                      samples,
#                                      mat){
#                                
#   if(is.null(nrow(mat)))
#     return(0)
#   assert(length(samples)==ncol(mat))
#   g = num_components
#   for_g = 1:g
#   for_Di = 1:ncol(mat)
#   
#   assert(g==nrow(mat))
#   n_mem = rep(0, g)
#   sum_mem = rep(0, g)
#   rng_mem = lapply(for_g, function(g) return(c(Inf, -Inf)))
#   
#   for(i in for_Di){
#     dists_f_Di = mat[,i]
#     best_g = which(dists_f_Di==min(dists_f_Di))
#     if(length(best_g)>1) best_g = best_g[1]
#     
#     n_mem[best_g] = n_mem[best_g] + 1
#     sum_mem[best_g] = sum_mem[best_g] + min(dists_f_Di)
#     if(samples[i]<rng_mem[[best_g]][1]) rng_mem[[best_g]][1] =samples[i] 
#     if(samples[i]>rng_mem[[best_g]][2]) rng_mem[[best_g]][2] =samples[i] 
#     print(sc(c("Cf value", samples[i], "to", best_g)))
#   }
#  
#  
#   
#   min_assignment_Di_g = sum(sapply(2:length(n_mem), function(gright) {
#     gleft = gright-1
#  #   print(paste("Grps", paste(gleft, gright)))
#   #  print(paste("range left:", clld(rng_mem[[gleft]],d=2)))
#   #  print(paste("range right:", clld(rng_mem[[gright]],d=2)))
#     if((rng_mem[[gleft]][2])>(rng_mem[[gright]][1])) gd= 0
#     else gd= (rng_mem[[gleft]][2]-rng_mem[[gright]][1])^2
#     print(sc(c("Groups", clld(c(gleft,gright),d=0),  "=", gd)))
#   return(gd)
#   }))
#   
#     gdsum = ceiling(min_assignment_Di_g) / (length(n_mem)-1) #ceil f log
#     print("-----------")
#     print(sc(c("Sum", gdsum)))
#   
# }
# 
# 




# old/debug -----
part_null= function(cfs,times) {
  len = length(cfs)
  part= rep(1,len)
  groups = times
  mem = len/groups
  mem_ = floor(len/groups) #TODO %
  group_cts = rep(mem_, groups)
  if(mem!=mem_)group_cts[groups] = len-sum(group_cts[1:(groups-1)]) #as many as still fit -> biased
  
  assert(sum(group_cts)==len)
  
  
  found=TRUE
  for(c_i in 1:len){
    assert(found)
    found = FALSE
    for(j in 1:length(group_cts))
      if(group_cts[j]!=0){
        part[c_i] = j
        group_cts[j] = group_cts[j]-1
        found=TRUE
        break
      }
  }
  
  
  assert(length(unique(part))==times &
           length(part)==length(cfs))
  return(part)
}
22




# f each component g,
#worst horiz. path through dist mat = most costly assignmt of each dataset to one of g groups = domain of probabilities st sum to <= 1
#best path through dist mat= hypoth best assignment = dispersion measure in score 

min_assignment = function(dist_mat_list, min_or_max)
  min_or_max(sapply(dist_mat_list, function(g) eval_assignment_g(g, min_or_max))) #min or max over components


min_assignment_g = function(dist_g_mat, min_or_max){
  #print(paste("COMPONENT: ", ifelse(is.null(nrow(dist_g_mat)), 1, nrow(dist_g_mat)) ))
  if(is.null(nrow(dist_g_mat))) return(sum(dist_g_mat))
  else return(sum(apply(dist_g_mat, 2, 
                        function(dists_f_Di) 
                          return(min_or_max(dists_f_Di))))) # sum one path=assign each Di to one group (of g many)
}



means_null_equi_alternative = function(cfs, times){ #too overfit i guess
  part = part_null(cfs, times)
  return(infer_means(part,cfs))
}
#ragged curve?
means_null_equi2 = function(cfs, times){
  # because of interval borders: times = length(cfs) to get reference samples xi, 1..k to get means in k grouping
  start = min(cfs)
  if(times==1) return(c(start + abs(max(cfs)-start)/2))
  slice_len = abs(max(cfs)-min(cfs))/(times+1)
  return(sapply (1:times, function(t) {return(start+t * slice_len)}))
}



##TODO update this, f debug

#' The same simultaneously: show result for all g, given g means (or g partitions plugged into infer_means.)
#' no kernel/gmm probabilities yet 
cmp_L_means = function (hist_obj, g_means,
                        do_plt=TRUE){
  assert(hist_obj$ty == "cmp_L_M")
  sample = hist_obj$cf_ord
  G = length(sample)
  
  #MSE_one = sum_assignment_mat(1, dispersion(1, g_means, sample))
  MSE_G_null = hist_obj$var_null
  
  MSE_G_sample = sapply(1:G, function(g) { 
    disp_mat = dispersion(g, g_means[[g]], sample)
    disp_k = sum_assignment_mat(g, disp_mat)
    logg(disp_k)
  })
  GAP = sapply(1:G, function(g)
  { MSE_G_null[g] - MSE_G_sample[g]})
  
  L = sapply(1:G, function(g)
  { if(g==1) return(0) else return (-GAP[g]+GAP[g-1]) }) #negated st minimiz probl
  
  #plot components of : (log Wk*/Wk-1*) + log(Wk-1/Wk): v curves.
  #LM2 = sapply(1:K, function(k)
  #{ if(k==1) return(0) else return (hist_obj$L_M[k]-hist_obj$L_M[k-1]) })
  
  #LDM2 = sapply(1:K, function(k)
  #{ if(k==1) return(0) else return (L_D_M[k]-L_D_M[k-1]) }) 
  
  if(do_plt) plt = plot_ly(x=1:6, y=MSE_G_sample, type="scatter", mode="lines", name=c("L_D_M")) %>% 
    add_trace(y=MSE_G_null, name=c("L_M")) %>% 
    add_trace(y=L, name=c("L")) %>% 
    add_trace(y=GAP, name=c("gap"))
  else plt = list()
  
  return(list(#"pre_cmp"=hist_obj, #TODO debug rmv
    "ty"="cmp_L",
    "L" = L,
    "var" = MSE_G_sample, 
    "var_null" = MSE_G_null,
    "plot"=plt,
    "k"= which(L==min(L))))
}

