
#string concat
sc = function(..., sep=""){
  lst = list(...)
  s = ""
  for(l in lst) s = paste(s, l, sep=sep)
  return(s)
}
#list concat -- like c(.,.) for lists
lc = function(l, el){
  l[[length(l)+1]] =el
  return(l)
}


# rep for lists
lrep = function (el, no) {
  lst = list()
  for (i in 1:no){
    lst = lc(lst, el)
  }
  return(lst)
}

test = lrep (5, 5)

#linear
as_mat = function (mat_or_vec){
  if(is.null(nrow(mat_or_vec)))  #linear: want 1-col mat
    mat_or_vec = t(as.matrix(mat_or_vec)) 
  return (mat_or_vec)
}


# assert ------

assert = function (x, funnm = NULL){
  if (!length(funnm)) funnm="(assert) false"
  if (!x) stop(funnm)
}


assertlen = function (x, funnm = NULL){
  if (!length(funnm)) funnm="(assert) empty"
  if (!length(x)) stop(funnm)
  
}

iflen = function (list, index_or_name) {
  if(is.numeric(index_or_name)) {
    if(length(list)<index_or_name) assertlen(NULL)
  }
  else assertlen(list[[index_or_name]])
  return(list[[index_or_name]])
}

# timing ---------


time = function(fun, args) {
  tm = proc.time()
  fun(args)
  return(proc.time() - tm)
}


# print & save to file ----------------------------

out_createdir = function (dirname) {
  ifelse(!dir.exists(dirname), dir.create(dirname), FALSE)
}


out = function (...,  sep= "", ln="\n",  f="out/results.txt", prec = FALSE) {
  list = list(...)
  
  if(is.null(f)) return() #to not produce all the files..
  sink(f, append=TRUE)
  
  for (i in 1:length(list)) {
    x = list[[i]]
    if (is.numeric(x)) {cat(sprintf("%.3f", x, append=TRUE))}
    else cat(x,append=TRUE)
    if (i<length(list)) cat(sep,append=TRUE)
  }
  cat(ln,  append=TRUE)
  sink()
}
# 
# 
# out = function(..., sep = "", f="out/results.txt") {  
#   x=list(x)
#   if(f=="rubbish") return()
#   out(x, sep=sep, f=f) 
#   sink(f, append=TRUE)
#   cat("\n",  append=TRUE)
#   sink()
# }


outln = function(f="out/results.txt") {  
  if(f=="rubbish") return()
  sink(f, append=TRUE)
  cat("\n", append=TRUE)
  sink()
}





#some shortcuts
out_delim = "\n--------------------------------------------------\n"
out_n = "\n"
out_lbr= "("
out_rbr= ")"
out_lb= "["
out_rb= "]"



out_br = function (x, type="()", sep="", d=-1, commas = TRUE) {
  comma =ifelse(commas, ", ", " ")
  if(d>0) x = clld(x, d=d, sep=comma)
  else x=cll(x, sep=comma)
  paste(paste(strsplit(type, split="")[[1]][1], x, sep=sep), 
       strsplit(type, split="")[[1]][2],   sep=sep)
  
}
out_b = function (x,  s="", d=-1, commas=FALSE) out_br(x, "[]", s, d, commas)

fmt = function(x) formatC(x, digits = 0, format="f")
fmtd = function(x, d) formatC(x, digits = d, format="f")


cll = function(x, sep=" ") paste(x, collapse=sep)
clld = function(x, d, sep=" ") {
  s = ""
  for(xi in x) s = paste(s, fmtd(xi, d), sep=ifelse(s=="", "", sep))
return(s)}

sink.reset <- function(){
  for(i in seq_len(sink.number())){
    sink(NULL)
  }
}



#orca: Sys.setenv("PATH" = paste(Sys.getenv("PATH"), "/anaconda3/bin", sep = .Platform$path.sep))


