# partitons-greedy.R (mostly) ----


# Given - datasetIDs c(1,2,3,4), 
# - resp coefs c(7, 6, 10, 8), doesnt need to be ordered here
# - pairs = combn(IDs, 2)
# Return for each pair, datasets with coef inside interval of pair's coefs 

# sets_between_pairs = function (datasetIDs, coefs, pairs) { #TODO can simplify to id2-id1 if coefs always ordered. 
#   insides = apply(pairs, 2, function(p){
#     c1 = coefs[which(datasetIDs==p[1])]
#     c2 = coefs[which(datasetIDs==p[2])]
#     minc = min(c1,c2)
#     maxc = max(c1,c2)
#     datasetIDs[which(coefs>minc & coefs<maxc)]
#   })
#   return(insides)
# } 

shape_to_part = function(shape){
part = rep(0, sum(shape))
index = 1
offset = 0
for (s in shape){
  for (i in 1:s){
    part[(offset+i)] = index
  }
  index = index+1
  offset = offset+s
}
assert(sum(shape)==length(part))
assert(length(shape))==length(unique(part))

upart = sort(unique(part))
sequ = 1:length(unique(part))
sapply(1:length(sequ), function(i) assert(upart[i]==sequ[i]))
return(part)
}

# Return those pairs st. no other datasets have coefs in between
adjacent_pairs = function (IDs, cfs, pairs) {

  adj = apply(pairs, 2, function(p){
    c1 = cfs[which(IDs==p[1])]
    c2 = cfs[which(IDs==p[2])]
    
    assertlen(c1)
    assertlen(c2)
    minc = min(c1,c2)
    maxc = max(c1,c2)
    length(which(cfs>minc & cfs<maxc))==0
  })
  neighb = which(adj == TRUE) 
  return(neighb)
}
# 
# # Return sets in between one pair D1,D2 (in between wrt. coefficient values)
# sets_in_between = function(D1, D2, IDtoInsides, pairs) {
#   pair_index = which(pairs[1,]==D1 & pairs[2,]==D2)
#   datasets_inside = IDtoInsides[[pair_index]]
#   return(datasets_inside)
# }


# Return id of pair that borders a group (=min max member wrt coef values)
G_border = function (class, part, cfs) {
  elem_G = which(part==class)
  cfs_G = cfs[elem_G]
  assertlen(cfs_G)
  
  min_G = which(coefs == min(cfs_G))[1] #[1] in case of ties
  max_G = which(coefs == max(cfs_G))[1]
  return(list("left"=min_G, "right"=max_G))
}


pair_index = function (D1,D2, pairIDs) {
  result = c(intersect(which(pairIDs[1,] == D1), which(pairIDs[2,] == D2)), 
            intersect(which(pairIDs[2,] == D1), which(pairIDs[1,] == D2)))
  if(length(result)>1) stop()
  return(result)
}

in_a_group_of = function (partition, D1){
  c1 = partition[D1]
  group = partition[which(partition==c1)]
  return(length(group)>1)
}



in_same_group_of = function (partition, D1, D2) {
  return(partition[D1]==partition[D2])
}




# Do: put datasets w IDs d1,d2 (+fellow group members) in the same group
# class: first(smallest-index) group that members belong to 
put_in_same_group_of = function (partition, d1, d2){
  
  c1 = partition[d1]
  c2 = partition[d2]
  class = min(c1,c2)
  
  change = c(which (partition==c1), which (partition==c2))
  #for (i in seq_along(partition)) 
   # if(i %in% change) partition[i] = class
  partition[change] = class
  
  m = max(partition) 
  i = 1
  while (i<m) {#no "gaps" in partition
    if(length(which(partition==i))==0) { #gap
      for (p in seq_along(partition)) if (partition[p] > i) partition[p] = partition[p]-1
      m = m-1
    } else i = i+1
  }
  return(partition)
}

# Input: - new dataset IDs (1:n) = sorting datasets for a coefficient
# - previous dataset IDs, when scores were computed
# - pairs_before: pair scores to be sorted, are in the order that comb(IDs_before, 2)/comb(coefs_before,2) create, want them in order that corresp to new IDs (1:n)
order_pairs = function(IDs, IDs_before, pairs_before) {
  
  # order by coef = mapping (IDs before -> IDs)
  # compare what combn(,2) does on IDs-bef vs. on IDs
  pair_IDs_before = combn(IDs_before, 2) 
  pair_IDs = combn(IDs, 2)
  #-> mapping (pair IDs before -> pair IDs) is what we need to apply on pairscores_before
  # pairscores= column-wise-pairscore(combn(coefs-bef, 2)) -> with mapping, get column-wise-pairscore(combn(coefs-ordered, 2)) (wo having to recompute)
  
  find_pair_occurence = function(of, inside) 
    c(intersect(which(inside[1,]==of[1]), which(inside[2,]==of[2])),
      intersect(which(inside[1,]==of[2]), which(inside[2,]==of[1]))) 
  
  pair_mapping = unlist(apply(pair_IDs, 2, function(pair) { find_pair_occurence (of=pair, inside = pair_IDs_before)}))
  
  return(pairs_before[pair_mapping])
}


