
enumerate_pi_k = function(E_n, k, mx1, mx2){
  ##if(config$E_n<=10) 
  shapes = sample_shapes_ineff(E_n, mx1, 
                               perm = TRUE, flatten = TRUE)
  shapes = shapes[which(sapply(shapes, function(i) return(length(i))) == k)] 
  if(length(shapes)>mx2)
    shapes =shapes[sample.int(length(shapes), config$Pi_max_per_k)]
  
  return(shapes)
}

enumerate_pi = function (config) {
  if(config$verbose) tic(paste("(check) Enumerate Pi, k =", paste(config$Pi_k1, paste("...", config$Pi_K))))
  #All of them +permuted
  #shapes = get_groupshapes(D_n, perm = TRUE, flatten = FALSE) 
 
  #could remove permutations altogether. but alw better to have more runs.
   if(config$E_n<10) perm = TRUE
   else perm = FALSE
  
  
    shapes = sample_shapes_ineff(config$E_n,
                                 1000,#config$max_partitions, -> do that later
                                 perm = perm,  
                                 flatten = TRUE)  
 ##  else shapes = sample_shapes(config$E_n,config$Pi_max_per_k)
    
    # prune partitions w more than Pi_n groups
    shapes = shapes[(which(sapply(shapes, function(i) return(length(i)))<=config$Pi_K))]
    shapes = shapes[(which(sapply(shapes, function(i) return(length(i)))>=config$Pi_k1))]

    # select userdef. many for each group size (st better balanced)
    shapes_sub = list()
    
      for (k in (config$Pi_k1:config$Pi_K)){
        shapes_k =shapes[(which(sapply(shapes, function(i) return(length(i)))==k))]
        if(length(shapes_k)> config$Pi_max_per_k)
          shapes_k = shapes_k[sample.int(length(shapes_k),config$Pi_max_per_k)]
shapes_sub = c(shapes_sub,  shapes_k)
        
    }
    shapes = shapes_sub
    sapply(shapes, function(shape) {
      assert(length(shape)<=config$Pi_K
           & sum(shape)==config$E_n)
    sapply(shape, function(i)
      assert(i<=config$E_n & i>=1))
    
    })
    #print(shapes)
  if(config$bad_envs > 0) {
    shapes = rmv_all_grouped(shapes)
    #if(!config$bad_envs_allaround)
     #shapes = rmv_allgrouped_orpair(shapes)
  }
    
    if(config$verbose) toc()
    
    
    print(paste("Shapes TODO: ", length(shapes)))
    assert(length(shapes) >=1)
  return(shapes)
}
 





# "shapes" = true partitions pi w/o gaps ----------

#no permutations, used for eg sz=20 where we prbly dont want permutations 
#a bit biased tw larger groups first

sample_shapes_K = function(sz,mx_sz=15, k, perm=TRUE){
  sample_shapes_ineff(sz, mx_sz, perm, only_k = k)
  
}


#for large sz, does not make sense to also have that many groups="everything is an outlier". restrict to 15? 
sample_shapes = function(sz, mx_sz, mx_n_groups=15,
                         incl_one_group = TRUE,
                         incl_no_group = FALSE){
  
  
  #all_n_groups = sample.int(sz, replace = FALSE)
  mx_n_groups = min(mx_n_groups, sz)
  if(incl_one_group) mn_n_groups = 1 else mn_n_groups = 2
  if(!incl_no_group & mx_n_groups == sz)  mx_n_groups = mx_n_groups-1
  
  all_n_groups = array(mn_n_groups:mx_n_groups)
  if(length(all_n_groups)>mx_sz){
    whch =  sample.int(mx_n_groups, mx_sz, replace = FALSE)
    n_groups_list = all_n_groups[whch]
  }
  
  else n_groups_list = all_n_groups
  
  n_elems = sz #to be assigned to n_groups many groups, for each n_groups in the list
  
  result = lapply(n_groups_list, function(n_groups){
    assignment=rep(0,n_groups)
    for (grp in (1:n_groups)) {
      if(grp == n_groups) 
        assignment[grp] = n_elems-sum(assignment)
      else{ 
        groups_left = n_groups-grp
        elems_left = n_elems-sum(assignment)
        max_n_elems = elems_left-groups_left#max st there is at least one elem left for all the other groups
        assignment[grp]  = sample.int(max_n_elems, 1)
        
      }
    }
    assert(sum(assignment)==n_elems)
    return(assignment)
  })
  return(result)
  
}

#shape_has_no_groups = function (shape)
#  return(length(unique(shape))==1 
#         & shape[1]==1)



#All 
get_shapes = function (sz, perm,#perm=T: ordered(but unique), perm=F: partitions w largest group first
                       flatten=TRUE, 
                       incl_one_group=TRUE, 
                       incl_no_group=FALSE) { 
  shapes_ordered = get_shapes_h(sz)
  one_group = c(sz)
  no_group = rep(1, sz)
  if (!perm) {
    if(incl_one_group) shapes_ordered[[length(shapes_ordered)+1]] = one_group
    if(incl_no_group) shapes_ordered[[length(shapes_ordered)+1]] = no_group
    return (shapes_ordered) #not nested even if !flatten
  }
  shapes_perm = lapply (shapes_ordered, function (shape){
    unique(combinat:::permn(shape))
  })
  if(incl_one_group) shapes_perm[[length(shapes_perm)+1]] = list(one_group)#not gen by get_shapes, and shouldnt be permuted.
  if(incl_no_group) shapes_perm[[length(shapes_perm)+1]] = list(no_group)
  if(flatten) list.flatten(shapes_perm)
  else shapes_perm
}



# return a sub sample of shapes to avoid going through all partitions
sample_shapes_ineff = function(sz, sz_sample, perm, flatten=TRUE,
                               incl_one_group = TRUE, incl_no_group = FALSE,only_k = NULL){
  shapes = get_shapes_h(sz)
  one_group = c(sz)
  no_group = rep(1, sz)
  
  
  if(length(only_k)){
    if(only_k == 1 ) return(list(one_group))
    if(only_k == sz ) return(list(no_group))
  }
  if (!perm & (length(shapes) <= sz_sample)){ #Case:no perm wanted+size ok
    if(incl_one_group) shapes[[length(shapes)+1]] = one_group   
    if(incl_no_group) shapes[[length(shapes)+1]] = no_group
    
    if(length(only_k)){
      shapes_k = list()
      for(shape in shapes) if(length(shape)==only_k) shapes_k[[length(shapes_k)+1]] =  shape
      return(shapes_k)
    }else return (shapes)
  }
  
  
  if(length(only_k)){
    
    shapes_k = list()
    for(shape in shapes) if(length(shape)==only_k) shapes_k[[length(shapes_k)+1]] =  shape
    rest_k = sz_sample - length(shapes_k)
    
    
    if(rest_k <= 0)
      return(shapes_k[sample(1:length(shapes_k), min(length(shapes_k), sz_sample), replace=FALSE)])
    #else:permute below
    else{
      shapes_perm = list.flatten(lapply (shapes_k, function (shape) unique(combinat:::permn(shape))))
      shapes_perm = shapes_perm[sample(1:length(shapes_perm), min(sz_sample, length(shapes_perm)), replace=FALSE)]
      return(shapes_perm)
    }
    
  }
  assert(!length(only_k))
  
  rest = sz_sample - length(shapes)
  
  
  if(rest <= 0) #Case: no permuts allowed anyway.
    return(shapes[sample(1:length(shapes), min(length(shapes), sz_sample), replace=FALSE)])
  
  
  shapes_perm = lapply (shapes, function (shape){
    permuts = unique(combinat:::permn(shape))
    p_allowed_here = min(rest, length(permuts))
    permuts = permuts[sample(1:length(permuts), p_allowed_here, replace=FALSE)]
  })
  if(incl_one_group) shapes_perm[[length(shapes_perm)+1]] = list(one_group) 
  if(incl_no_group) shapes_perm[[length(shapes_perm)+1]] = list(no_group) 
  
  
  if(flatten) list.flatten(shapes_perm)
  else shapes_perm
}


get_shapes_h = function (sz){ #returns all partitions as seq. where element i means group of i consecutive datasets, eg seq=3 2 -> partition={D1+D2+D3}, {D4+D5}
  #as our partitions will never need gaps, the shapes represent all partitions we need to consider (assuming Di ordered by coefficients)
  res = list()
  biggest = sz-1
  for (cur_biggest in biggest:1){
    start = c(cur_biggest)
    res = extend_shapes(start, cur_biggest, sz, res)
  }
  return(res)
}

extend_shapes = function (start, biggest, sz, res){
  for (cur_biggest in biggest:1){
    groups = c(start, cur_biggest)
    if(sum(groups)==sz) res[[length(res)+1]] = groups    
    if(sum(groups)>sz) next
    if(sum(groups)<sz) res = extend_shapes(groups, cur_biggest, sz, res)
  }
  return(res)
}



# tweak shapes -------

random_different_shape = function(shape) {
  N = sum(shape)
  shape_bef = shape
  shapes = sample_shapes(N, 20)
  shape_id = sample.int(length(shapes), size = 1)
  shape = shapes[[shape_id]]
  
  same_shape = !(FALSE %in% (sapply(1:length(shape), function(i) return(shape[i]==shape_bef[i]))))
  if(same_shape){
    if(shape_id == length(shapes)) shape = shapes[[shape_id-1]]
    else shape = shapes[[shape_id+1]]
  }
  assert(FALSE %in% (sapply(1:length(shape), function(i) return(shape[i]==shape_bef[i]))))
  return(shape)
}



#assumes rmv_all_grouped was used to gen. true partition.
move_env_around_groups = function (shape){
  #shape = what is later used as true partition in the check,
  #shapes returned = put one isolated env (first) into diff groups (simulates a noisy environment.)
  #just use the first env that is isolated, bc go through permuted shapes anyway
  
  isolated_id = -1
  for(i in 1:length(shape)){
    if(shape[i]==1){
      isolated_id = i
      #print(paste("choose D", i))
      break
    }
  }
  
  if(isolated_id==-1) stop() # not pruned
  
  
  shapes = list()
  for(i in 1:length(shape)){
    group_to_grow = shape[i]
    #print(paste("growing G",paste(i,  paste(", elem", group_to_grow), sep="")))
    if(i==isolated_id){
      #print("     skip")
      next
    } 
    
    shape_up = c()
    for(j in 1:length(shape)){    
      
      if(j==isolated_id) next
      if(j==i) shape_up = c(shape_up, group_to_grow+1)
      if(j<i) shape_up = c(shape_up, shape[j])
      if(j>i) shape_up = c(shape_up, shape[j])
    }
    
    #print(paste("     ->", out_br(clld(shape_up, d=0, sep=" "))))
    assert(length(shape_up)==length(shape)-1)
    assert(sum(shape_up)==sum(shape))
    shapes[[length(shapes)+1]] = shape_up
  }
  return(shapes)
}


# only jump to neighboring groups, not to any group
move_env_between_groups = function (shape){
 
  isolated_id = -1
  for(i in 1:length(shape)){
    if(shape[i]==1){
      isolated_id = i
      break
    }
  }
  if(isolated_id==-1) stop() # not pruned
  
  
  shapes = list()
  for(i in 1:length(shape)){
    if(i==isolated_id-1 | i==isolated_id+1){
      group_to_grow = shape[i]
      #print(paste("growing G",paste(i,  paste(", elem", group_to_grow), sep="")))
      shape_up = c()
      for(j in 1:length(shape)){    
        if(j==isolated_id) next
        if(j==i) shape_up = c(shape_up, group_to_grow+1)
        if(j<i) shape_up = c(shape_up, shape[j])
        if(j>i) shape_up = c(shape_up, shape[j])
      }


    #print(paste("     ->", out_br(clld(shape_up, d=0, sep=" "))))
    assert(length(shape_up)==length(shape)-1)
    assert(sum(shape_up)==sum(shape))
    shapes[[length(shapes)+1]] = shape_up
    }
  }  
  return(shapes)
}


#also rmvs one group, one isolated(only one group to move into)

rmv_all_grouped = function (shapes){
  shapes_up = list() 
  for(shape in shapes) 
    if (1 %in% shape) 
      shapes_up[[length(shapes_up)+1]] = shape
  return(shapes_up)
}

rmv_allgrouped_orpair = function (shapes){
  shapes_up = list() #ineff
  for(shape in shapes) 
    if (1 %in% shape & length(shape)>2) 
      shapes_up[[length(shapes_up)+1]] = shape
  return(shapes_up)
}

