# One Dataset, result (F_history$Pi_ranking)

plot_ranking = function(history, 
                        rank_no, 
                        from_rank_no, 
                        title, 
                        x_nms=NULL,
                        plot_nscaled=FALSE, 
                        plot_resid=FALSE){ 
 # if(!plot_resid) {
 #   if(plot_nscaled) ranking= history$Pi_ranking_nscaled
  #  else 
  ranking = history$Pi_ranking_raw
 # }
#  else{
  #  if(plot_nscaled) ranking= history$Pi_restds_fit
 #   else ranking = history$Pi_resids_fit
  #}
  
  if(rank_no>length(ranking)) rank_no = length(ranking)
  lst = list()
  true_nm = title #paste0("true: _unknown_")
  for(i in from_rank_no:rank_no){
    ii =  i-from_rank_no + 1
    lst[[ii]] = c(as.list(ranking)[[i]], 

                  # group number f display
                  k=length(unique(ranking[[ii]]$E_part)))
    print(clld(as.list(ranking)[[i]]$E_part, d=0))
  }

  
  if(!plot_resid) lst_rev = list.sort(lst, (score_sum)) 
  if(!plot_resid & plot_nscaled) lst_rev = list.sort(lst, (scoreE_sum)) 
  if(plot_resid & plot_nscaled) lst_rev = list.sort(lst, (restd_sum))
  if(plot_resid & !plot_nscaled) lst_rev = list.sort(lst, (resid_sum))
  # sort in reverse! 
  
  C_no = length(lst_rev[[1]]$Pi_history$scores_X_C[[1]])
  Xi_no = length(lst_rev[[1]]$Pi_history$scores_X_C)
   
  if(plot_resid) C_no =1
  if(plot_resid) Xi_no =1
  if(plot_resid| !length(x_nms))x_nms = paste0("X",seq(1, Xi_no))


  xmat = outer( x_nms, #paste0("X",seq(1, Xi_no)),
                paste0("c", seq(1, C_no)), FUN = "paste") 

  x =c(xmat[1,])

  if(nrow(xmat)>1) for(i in (2:nrow(xmat)))
    x =c(x, xmat[i,])
  if(C_no == 1) x = x_nms
  
  if(plot_resid) x = paste0( "E" , seq(1,history$E_n))
  
  y =  sapply(lst_rev, function(lst) return(paste0("k=",paste0( lst$k,paste(",", paste(lst$E_part,collapse="")))  )))
  
  data = expand.grid(X=x, Y=y)
  
  z = c()
  for(p in lst_rev) { 
    if(plot_resid){
      for(ei in 1:history$E_n){
        if(plot_nscaled) zi =  p$E_restds[ei]
        else zi =  p$E_resids[ei]
        z = c(z,zi)
      }
    }
    else{
      for(xi in 1:Xi_no)
        for (ci in (1:C_no)){ #important, ow unordered
          if(length(unique(p$E_part))==1) z = c(z,0) # or confint score at k for best best pik ??
          else{
            if (plot_nscaled)  zi = p$Pi_history$scoresE_X_C[[xi]][ci] 
            else zi = p$Pi_history$scores_X_C[[xi]][ci]
          z = c(z,zi)
          }
        }
    }
  } 
  data$Z = z

  if(plot_resid) lst = list.sort(lst, resid_sum)
  else  lst = list.sort(lst, score_sum)
  xx=x


  xxx=c()
  for(xi in 1:Xi_no){
    for(ci in 1:C_no)
      xxx=c(xxx, paste0("$X_", paste0(xi,paste("," ,paste0("\\varphi_",paste0( ci,"$") )))     ) )
  }

  splt = C_no * Xi_no #TODO dif no c over X
  yy =  sapply(lst, function(l) return(paste0("k=",paste0( l$k,paste(",", paste(l$E_part,collapse="")))  )))
  yyy =  sapply(lst, function(l) return( paste(l$E_part,collapse="")))
  dataa = expand.grid(X=xx, Y=yy)

  zz=c()
  for(p in lst){
    for(xi in 1:Xi_no)
      for (ci in (1:C_no)){ #important, ow unordered
        if(length(unique(p$E_part))==1) z = c(z,0) 
        else{
        if(plot_nscaled )
          zi = p$Pi_history$scoresE_X_C[[xi]][ci] 
          else zi = p$Pi_history$scores_X_C[[xi]][ci]
        }
        zz = c(zz, zi)
      }
    }
  dataa$val = zz
  cat("
	\\begin{axis}[
")
  cat("xticklabels={", "\n")
  ct = 1 
  for(label in xxx){
    #cat("   (",  label, "), \n" , sep = "") if cf shown
    cat(paste0("$X_", ct), "$, \n", sep="" )
    ct = ct+ 1
  }
####  cat("$\\sum$,","\n")
  cat("},","\n")
  cat("yticklabels={", "\n")
  ct = 1
  for(label in yyy){
    cat("   ", ct, ". (", label,"), \n", sep = "")
    ct = ct+ 1
  }
  cat("},")
  cat("
    height = 5cm, 
    width = 5cm,
    pretty heatmatrix thesis,
    colorbar style 		= {
      samples=11,
      ylabel        = {Score},  
      yticklabel style= {font=\\footnotesize },     
      ylabel style  = {font=\\scriptsize }, 
      ytick style = {draw=none},},
    title           = {$\\PI^*= (", title, ")$},
    point meta min=0, % z range
    point meta max=", -8,  ", % z range
    pretty labelshift
]")
  cat("	
  \\addplot[matrix plot,
      mesh/cols=", Xi_no, #+1,  ### if sum   shown , Xi_no +1
      ", % y 
      point meta=explicit, ] 
  table [meta=val] { 
        x   y   val", "\n" )
  switch= Xi_no*C_no -1
  yid = 0
  xid = -1
  sm = 0 #f  one cf over X
  for (i in 1:nrow(dataa)){
    if(xid==switch) {
      #if sum should be shown ###########
    ####  cat("       ",xid+1, "   ", yid,"   ",sm,  "\n" )
      sm=0
      xid=0
      yid=yid+1
      } else xid= xid +1
    cat("       ",xid, "   ", yid,"   ",dataa$val[i],  "\n" )
    sm = sm + dataa$val[i]
  }
 #### cat("       ",xid+1, "   ", yid,"   ",sm,  "\n" )
cat("}; 
\\end{axis}")
  brks = c(-10,-5,-2.5,-2,-1.5,-1,-0.5,0,2)
  lims = brks
 if(min(data$Z)<10)  brks[1] = min(data$Z)
  if(max(data$Z)>0) brks[7] = max(data$Z)
  data$score = cut(data$Z,
                 breaks = brks,
                 labels = c("< -5",  "-5,-2.5", "-2.5,-2", "-2,-1.5", "-1.5,-1", "-1,-0.5","-0.5,0", ">0"), include.lowest = T)
  
  cols =  rev(RColorBrewer::brewer.pal(8, "PuBu"))
if(plot_resid)  {
  brks = c(5,7,8,9,10,11,12,15,26)
  lims = brks
  if(min(data$Z)<5)  brks[1] = min(data$Z)
  if(max(data$Z)>17) brks[6] = max(data$Z)
  data$score = cut(data$Z,
                 breaks = brks,
                 labels = c("< 7", "7-8", "8-9", "9-10", "10-11", "10-12", "12-15", ">15"), include.lowest = T)
  cols =    RColorBrewer::brewer.pal(9, "PuBu")
  
}
  #plt =#ggplotly(
   # ggplot(data, aes(X, Y)) + 
  #  geom_raster(aes(fill = Z), interpolate=FALSE) + 
   # scale_fill_gradient2(low="white", mid="#2171B5", high="#023858", 
    #                     midpoint=11, limits=c(7, 15))
  

  
  #A
#  plt =ggplotly( ggplot(data, aes(X, Y, fill= Z)) + 
 #                  ggtitle(true_nm) + 
  #                 geom_tile())
    #B
 # plt =
  #  ggplot(data, aes(X, Y)) + 
   #                geom_raster(aes(fill = Z), interpolate=FALSE) + 
    #               scale_fill_gradient2(low="#023858", mid="#2171B5", high="white", 
     #                                   midpoint=-3, limits=c(-10,1))
 #C
   plt =
    ggplot(data, aes(X, Y)) + 
    geom_tile(aes(fill =score)) +
     ggtitle(true_nm) + 
   # geom_text(aes(label = round(Z, 1))) +
  scale_fill_manual(values = cols)
                   
 
  

  #print_ranked(ranking, rank_no, cf_no)
  
  return(list(plt =plt, prnt=list(data=dataa, splt=splt, id=id, x=xxx, y=yyy)))
  
}



# Simulations: RANKINGS has results for all partitions
plot_ranked_i  = function( rank_no= NULL, part_id=NULL, it= 1, part_nm= NULL,
                           plot_resid_fit = FALSE, plot_resid_reg=FALSE, plot_nscaled=FALSE, confident = FALSE){
  assert(length(part_id) | length(part_nm))
  
  #it = 1
  if(length(part_nm)){
    part = which(names(as.list(RANKINGS))==part_nm)
  }
  else 
    part=part_id
  
  if(plot_nscaled | !confident) cnf = 1
  else cnf =  as.list(RANKINGS)[[part]][[it]]$conf_value
  
  
  if(plot_nscaled) scores = as.list(RANKINGS)[[part]][[it]]$Pi_ranking_nscaled[[1]]$Pi_history$scoresE_X_C
  else scores = as.list(RANKINGS)[[part]][[it]]$Pi_ranking[[1]]$Pi_history$scores_X_C
  
  if(plot_resid_reg)
    ranking = as.list(RANKINGS)[[part]][[it]]$Pi_resids_reg
  else{
    if(plot_resid_fit) ranking = as.list(RANKINGS)[[part]][[it]]$Pi_resids_fit
    else  {
      if(plot_nscaled) ranking = as.list(RANKINGS)[[part]][[it]]$Pi_ranking_nscaled
      else {
        if(confident) ranking = as.list(RANKINGS)[[part]][[it]]$Pi_ranking_conf
        else ranking = as.list(RANKINGS)[[part]][[it]]$Pi_ranking
  }}}
  shape = shape_to_part(sapply(strsplit(names(as.list(RANKINGS)[part]), "")[[1]], as.integer))
  
  if(!length(rank_no))rank_no = length(ranking) 
  if(plot_resid_reg |  plot_resid_fit)
    plot_ranked_resid( ranking, shape, rank_no,
                       plot_resid_fit, plot_resid_reg)
  else  plot_ranked( ranking, shape, rank_no,cnf,scores, plot_nscaled, confident)
}




plot_ranked = function(ranking, shape, rank_no, cnf,cnfs , plot_nscaled, confident){
  id = paste0(paste(shape,collapse=""),paste0("_", rank_no))
  lst = list()
  for(i in 1:rank_no){
    lst[[i]] = c(ranking[[i]],#c(ranking[[i]], confident_score=ranking[[i]]$score_sum * ranking[[i]]$conf_value), 
                 k=length(unique(ranking[[i]]$E_part)))
    
  }
  if(plot_nscaled |!confident) lst_rev = list.sort(lst, (score_sum)) 
  else lst_rev = list.sort(lst, (conf_sum)) # sort in reverse! 
  LST<<- lst_rev
  true_nm = (paste("True Partition:", out_b(clld(shape, d=0))))
  print(true_nm)
  
  C_no = length(lst_rev[[1]]$Pi_history$scores_X_C[[1]])
  Xi_no = length(lst_rev[[1]]$Pi_history$scores_X_C)
  if(plot_nscaled){
    C_no = length(lst_rev[[1]]$Pi_history$scoresE_X_C[[1]])
    Xi_no = length(lst_rev[[1]]$Pi_history$scoresE_X_C)
  }
  
  xmat = outer( paste0("X",seq(1, Xi_no)), paste0("c", seq(1, C_no)), FUN = "paste") 
  x =c(xmat[1,])
  if(nrow(xmat)>1) for(i in (2:nrow(xmat)))
    x =c(x, xmat[i,])
  
  
  y =  sapply(lst_rev, function(lst) return(paste0("k=",paste0( lst$k,paste(",", paste(lst$E_part,collapse="")))  )))
  
  data = expand.grid(X=x, Y=y)
  
  z = c()
  for(p in lst_rev) 
    for(xi in 1:Xi_no)
      for (ci in (1:C_no)){ #important, ow unordered
        if(plot_nscaled)
          zi =  p$Pi_history$scoresE_X_C[[xi]][ci]
          else{
        if(!(length( p$Pi_history$scores_X_C[[xi]][ci]))) zi = cnfs[[xi]][ci] * 0.5 #TODO artificial???
        else zi =  p$Pi_history$scores_X_C[[xi]][ci] * cnf 
          }
        z = c(z,zi)
      }
  data$Z = z
  

if(plot_nscaled |!confident) lst = list.sort(lst, score_sum)
else  lst = list.sort(lst, conf_sum) 
  xx=x
  
  
  xxx=c()
  for(xi in 1:Xi_no){
    for(ci in 1:C_no)
      xxx=c(xxx, paste0("$X_", paste0(xi,paste("," ,paste0("\\varphi_",paste0( ci,"$") )))     ) )
  }
  
  splt = C_no * Xi_no
  yy =  sapply(lst, function(l) return(paste0("k=",paste0( l$k,paste(",", paste(l$E_part,collapse="")))  )))
  yyy =  sapply(lst, function(l) return( paste(l$E_part,collapse="")))  
  dataa = expand.grid(X=xx, Y=yy)
  
  zz=c()
  for(p in lst) 
    for(xi in 1:Xi_no)
      for (ci in (1:C_no)){ #important, ow unordered
        if(plot_nscaled)
          zi =  p$Pi_history$scoresE_X_C[[xi]][ci]
        else{
        if(!(length( p$Pi_history$scores_X_C[[xi]][ci]))) zi = cnfs[[xi]][ci] * 0.5 #TODO artificial???
        else zi =  p$Pi_history$scores_X_C[[xi]][ci] * cnf 
        }
        zz = c(zz,-zi)
      }
  dataa$val = zz
  
  
  
  
  plt = ggplotly( ggplot(data, aes(X, Y, fill= Z)) + 
                    ggtitle(true_nm) + 
                    geom_tile() +
                    scale_fill_gradient(name = "score",# limits =c(-10,0),
                                        low = "#FFFFFF",
                                        high = "#012345"))
  plt =ggplotly( ggplot(data, aes(X, Y, fill= Z)) + 
                   ggtitle(true_nm) + 
                   geom_tile())
  #print_ranked(ranking, rank_no, cf_no)
  
  return(list(plt =plt, prnt=list(data=dataa, splt=splt, id=id, x=xxx, y=yyy)))
  
}
out_data = function(prnt){
  data = prnt$data
  splt = prnt$splt
  id = prnt$id
  
  #f=paste0("plts/",paste0(id, ".txt")
  f= "plts/prnted.txt"
  
  out("\n", f=f)
  
  ct2 = 0
  for (i in 1:length(prnt$y)){
    ct2 =  ct2+1
    out(paste0(fmtd(ct2,d=0), ". "), out_br(clld( prnt$y[i],d=0)), ",",f=f)
    
  }
  
  out("\n", f=f)
  
  
  for (i in 1:length(prnt$x)){
    
    out(out_br(clld( prnt$x[i],d=0)), ",",f=f)
    
    
  }
  out("\n", f=f)
  
  ct_y = 0
  ct_x = -1
  out("x \t y \t val",  f=f)
  for (i in 1:length(data$X)){
    if(ct_x==splt-1){
      ct_x = 0
      ct_y = ct_y + 1
    }
    else 
      ct_x = ct_x+1
    out(fmtd(ct_x,d=0), " \t ", fmtd(ct_y,d=0)," \t ", 
        fmtd(data$val[i],d=2),
        f=f)
    
  }
  
}


plot_ranked_resid = function(ranking, shape, rank_no,
                             plot_resid_fit, plot_resid_reg){
  lst = list()
  for(i in 1:rank_no){
    lst[[i]] = c(ranking[[i]], k=length(unique(ranking[[i]]$E_part)))
    
  }
  if(plot_resid_reg)
    lst_rev = list.sort(lst, (score_sum)) # sort in reverse!
  else lst_rev = list.sort(lst, (resid_sum))
  
  true_nm = (paste("True Partition:", out_b(clld(shape, d=0))))
  print(true_nm)
  LST<<- lst_rev
  E_no = length(lst_rev[[1]]$E_resids)
  
  
  x = c(paste0("E",seq(1, E_no)), "Eall")
  
  
  y =  sapply(lst_rev, function(lst) return(paste0("k=",paste0( lst$k,paste(",", paste(lst$E_part,collapse="")))  )))
  
  data = expand.grid(X=x, Y=y)
  
  z = c()
  for(pi in 1:length(lst_rev) ){
    if(plot_resid_reg){
      for(ei in 1:E_no)
        z = c(z, lst_rev[[pi]]$E_scores[[ei]])
      z = c(z, lst_rev[[pi]]$score_sum)
    }
    
    else{      
      for(ei in 1:E_no)
        z = c(z, lst_rev[[pi]]$E_resids[[ei]])
      z = c(z, lst_rev[[pi]]$resid_sum)
    }
    
  }
  
  
  data$Z = z
  
  #print_ranked(ranking, rank_no, cf_no)
  
  return(list(plt =ggplotly( ggplot(data, aes(X, Y, fill= Z)) + 
                               ggtitle(true_nm) + 
                               geom_tile()), data=data))
  
}


print_ranked = function (ranking, rank_no, cf_no){
  
  lst = list()
  for(i in 1:rank_no){
    lst[[i]] = c(ranking[[i]], k=length(unique(ranking[[i]]$E_part)))
    
  }
  i=2
  #shape =  shape_to_part(sapply(strsplit(names(as.list(RANKINGS)[part]), "")[[1]], as.integer))
  #print(paste("True", out_b(clld(shape, d=0))))
  
  for (lst in list.sort(lst, score_sum)) {
    #print(paste("Coefficient", i))
    print(paste(paste0("Rank ",paste0(i, paste(".", out_b(clld(lst$E_part, d=0)))))))
    
    ## print_cfs(lst)
    i=i+1
  }
  
  return()}
