
#' Stacked xbar for all versions and one group number
#
plotrun_confus_server = function(result,
                           true_group_number,
                           outnm = "confusion_Pi"){
  outf ="" 
  cat("% Runs: ", polyfit:::fmtd(result$runs, d=0) , ", E_n: ", polyfit:::fmtd(result$E_n, d=0),  ", Pi_n: ", polyfit:::fmtd(result$Pi_n, d=0), ", deg", polyfit:::fmtd(result$degree, d=0), f=outf)
  k1 = true_group_number
  
  # Merge confusion mats of interesting versions, using only column for true group no
  k2_n = nrow(result$confusion_pct[[1]])
  v_n = 4
  guesses_v1_vn = matrix(0, nrow = k2_n, ncol = v_n)
  v_todo = 1:v_n
  x_nms = paste0("x", v_todo)
  
  for(vi in v_todo){
    guesses_v1_vn[,vi] = result$confusion_pct[[vi]][,k1]
  }
  
  sofar = rep(0, v_n)
  print(guesses_v1_vn)
  for(it in 1:nrow(guesses_v1_vn)){ #new plot for each guessed k2 = ylevel; x1-x3 are the versions
    # it1: true k, it2: cor k, wrong pi (last row)
    if(it==1) row_n = k1
    if(k1==1 | k1==k2_n-1){
      if(k1==1 & it==k2_n-1) break
      if(k1==1 & it>1) row_n = it
      if(k1==k2_n-1 & it==k2_n) break
      if(k1==k2_n-1 & it>1) row_n = it-1
    } else{
      if(it==2) row_n = k2_n
      if(it>2 & it-2 < k1) row_n = it-2
      if(it>2 & it-2 >= k1) row_n = it-1
    }
   # print(row_n)
    cat("\n")
    cat("\\addplot plot coordinates {", ln="", f=outf)
    guess_k1_for_k = guesses_v1_vn[row_n,]
    
    for(vi in 1:length(guess_k1_for_k)){ 
      cat(" (", guess_k1_for_k[vi],",",  x_nms[vi], ") ", sep="", ln= "", f=outf)
    }      
    cat("};", f=outf)
    
  }

}

#' Stacked xbar for one version and a couple of group numbers
#
plotrun_confus2_server = function(result,
                                  true_group_numbers,
                                  version ,
                                  pct=TRUE){
  outf ="" # outfolder(outnm)
  # outconfig(outf, result)  
  cat("% Runs: ", polyfit:::fmtd(result$runs, d=0) , ", E_n: ", polyfit:::fmtd(result$E_n, d=0),  ", Pi_n: ", polyfit:::fmtd(result$Pi_n, d=0), ", deg", polyfit:::fmtd(result$degree, d=0), f=outf)
  #
  k2_n = nrow(result$confusion_pct[[version]])
  guesses_v1_vn = matrix(0, nrow = k2_n, ncol = length(true_group_numbers))
  #print(guesses_v1_vn)
  id = 0
  
  x_nms = paste0("x", 1:length(true_group_numbers))
  for(k1 in true_group_numbers){
    id = id + 1
  ##k1 = true_group_number[[i]]
  
  # Merge confusion mats of interesting versions, using only column for true group no

    guesses_v1_vn[,id] = result$confusion_pct[[version]][,k1]
    
  }
  print(guesses_v1_vn)
  for(it in 1:nrow(guesses_v1_vn)){ #new plot for each guessed k2 = ylevel; x1-x3 are the versions
    cat("\n")
    cat("\\addplot plot coordinates {", ln="", f=outf)
    
    for(it2 in 1:length(true_group_numbers)){ 
      
    k1 = true_group_numbers[it2]
    # it1: true k, it2: cor k, wrong pi (last row)
    if(it==1) row_n = k1
    if(k1==1 | k1==k2_n-1){
      if(k1==1 & it==k2_n-1) break
      if(k1==1 & it>1) row_n = it
      if(k1==k2_n-1 & it==k2_n) break
      if(k1==k2_n-1 & it>1) row_n = it-1
    } else{
      if(it==2) row_n = k2_n
      if(it>2 & it-2 < k1) row_n = it-2
      if(it>2 & it-2 >= k1) row_n = it-1
    }
      
    #print(row_n)
    
    guess_k1_for_k = guesses_v1_vn[row_n,]
    if(pct) guess = guess_k1_for_k[it2] * 100
    else  guess = guess_k1_for_k[it2] 
      cat(" (", guess,",",  x_nms[it2], ") ", sep="", ln= "", f=outf)
    }      
    cat("};", f=outf)
    
  }
  
}