transform_JCI_data = function(X_mat, y_id,  E_n, Regime_n){ 
  X_n = ncol(X_mat)-Regime_n

  
  X_names=sapply(1:(X_n-1), function(i) 
    return(paste0("x",i)))
  
  D = list(D_data=list(),  
           X_names=as.list(X_names)) 
 
  obs_rows = 1:nrow(X_mat) 
  for (ci in (X_n+1):(X_n+Regime_n)) obs_rows = intersect(obs_rows,   (which(X_mat[,ci]==0)))
  
  for (ei in 1:E_n){
    xcols = 1:X_n
    xcols = xcols[-y_id]
    if(ei == 1)
      X_sub = X_mat[obs_rows,1:X_n]
    else
      X_sub = X_mat[which(X_mat[,X_n+ei-1]==1),1:X_n]
    d = data.frame(cbind(X_sub[,xcols], X_sub[,y_id]))
    
    
    colnames(d) = c(X_names, "y")
    D$D_data[[paste0("D",ei)]] = d
    #D$D_null[[paste0("D",ei)]] = d
  }
  return(D)
} 



transform_ICP_data = function(X,Y, ExpInd,Exp_list=FALSE){
  #ExpInd <- c(rep(1,n/2),rep(2,n/2))
  X_names=sapply(1:ncol(X), function(i) 
    return(paste0("x",i)))
  
  D = list(D_data=list(), 
           D_null=list(), 
           X_names=as.list(X_names))
  
  if(Exp_list) envs = length(ExpInd)
  else 
    envs = unique(ExpInd)
  
    
    for(ei in envs) {
      if(Exp_list)    d = data.frame(cbind(X[ExpInd[[ei]],], Y[ExpInd[[ei]]]))
        else d = data.frame(cbind(X[which(ExpInd==ei),], Y[which(ExpInd==ei)]))

      colnames(d) = c(X_names, "y")
      D$D_data[[paste0("D",ei)]] = d
     # D$D_null[[paste0("D",ei)]] = d
    }



  # for(E in envs) {
  #   d = data.frame(cbind(X[which(ExpInd==E),], Y[which(ExpInd==E)]))
  #   colnames(d) = c(X_names, "y")
  #   D$D_data[[paste0("D",E)]] = d
  #   D$D_null[[paste0("D",E)]] = d
  # }


return(D)
}

transform_CollDist_data = function(X,Y, ExpInd){
  #ExpInd <- c(rep(1,n/2),rep(2,n/2))
  X_names=sapply(1:ncol(X), function(i) 
    return(paste0("x",i)))
  
  D = list(D_data=list(), 
           D_null=list(), 
           X_names=as.list(X_names))
  
  envs = unique(ExpInd)
  
  for(ei in 1:2) {
   # d = data.frame(cbind(X[which(ExpInd==E),], Y[which(ExpInd==E)]))
    d = data.frame(cbind(X[ExpInd[[ei]],], Y[ExpInd[[ei]]]))
    colnames(d) = c(X_names, "y")
    D$D_data[[paste0("D",ei)]] = d
  #  D$D_null[[paste0("D",ei)]] = d
  }
  
  
  return(D)
}



transform_Reged_data = function(E_list, X_relv, Y_relv){ 
  
  if(Y_relv %in% X_relv) X_relv=X_relv[-Y_relv] #st y is named  y
  Y_attr =  colnames(E_list[[1]])[Y_relv]
  X_attrs = colnames(E_list[[1]])[X_relv]
  X_nms= lapply(1:length(X_attrs), function(i) 
    return(paste0("x", i)))
  V_nms = c(X_nms, "y")
  
  names(V_nms)= c(X_attrs, "y")
  
  D = list(D_data = list(), 
           X_names = V_nms)
  for (ei in seq_along(E_list)){
    E_sub = E_list[[ei]] %>% 
      select(X_attrs, Y_attr)
    colnames(E_sub) = V_nms
    D$D_data[[paste0("D", ei)]] = E_sub
  }
  D$X_relv = X_relv
  return(D)
  
  
}

transform_xls_data = function(E_list, X_relv, Y_relv){#TODO xid, yid or name

  if(Y_relv %in% X_relv)X_relv=X_relv[-Y_relv] #st y is named  y
  Y_attr =  colnames(E_list[[1]])[Y_relv]
  X_attrs = colnames(E_list[[1]])[X_relv]
  X_nms= lapply(1:length(X_attrs), function(i) 
    return(paste0("x", i)))
  V_nms = c(X_nms, "y")
  
  names(V_nms)= c(X_attrs, Y_attr)
  
  D = list(D_data = list(), 
           X_names = V_nms)
  for (ei in seq_along(E_list)){
    E_sub = E_list[[ei]]  %>% 
      dplyr:::select(X_attrs, Y_attr)
    E_sub[[ei]]
    colnames(E_sub) = V_nms
    D$D_data[[paste0("D", ei)]] = E_sub
  }
  D$X_relv = X_relv
  return(D)
  
  
}
