

# TODO unclutter

#' Samples collections for Pi_one (invariant coefficients) 
#' -> score confidence interval at each k compared to k=1
#' @param E_n environments
#' @param cfs coefficients (needed?)
#' @param numit runs of Vario
#' @return score confidence intervals for group numbers 2:k
sample_conf_pi_one  = function(E_n, it_n, vb, version_mdl){
  
  scores_k = matrix(ncol = E_n-1,
                    nrow = it_n)
  scores_nscaled_k =scores_k
  #print("------------------")
  #print("Confints Pi one")
  
  if(vb) tic(paste0(paste0(paste0("(vario) ", it_n), " many runs")))
  
  for (it in 1:it_n){
  R_one = simulate_pi_one(E_n, version_mdl)
    for(k in 2:E_n){
      assert(paste(k) %in% ls(R_one$Pi_kbest))
      R_k = R_one$Pi_kbest[[paste(k)]]
      scores_k[it,k-1] = R_k$score_sum
      #TODO need kbest of nscaled f this scores_nscaled_k[it,k-1] = R_k$scoreE_sum
      
    }
      
  }
  
  conf_k = apply(scores_k, 2, cint)
  #conf_nscaled_k = apply(scores_nscaled_k, 2, cint)
  #print(conf_k) 
  if(vb) toc()
  return(conf_k)
}
sample_conf_pi_best  = function(E_n, it_n, vb=FALSE, version_mdl){
  scores_k = matrix(ncol = E_n-1,
                    nrow = it_n)
  scores_nscaled_k =scores_k
  if(vb) tic(paste0(paste0(paste0("(vario) ", it_n), " many runs")))
  for (it in 1:it_n){
    R_one = simulate_pi_best(E_n, version_mdl)
    for(k in 2:E_n){
      assert(paste(k) %in% ls(R_one$Pi_kbest))
      R_k = R_one$Pi_kbest[[paste(k)]]
      scores_k[it,k-1] = R_k$score_sum 
    } 
  } 
  conf_k = apply(scores_k, 2, cint) 
  if(vb) toc()
  return(conf_k[,1]) #exp. score for 2 groups when there are 2 exact groups
}


# One run
simulate_pi_one = function(E_n, version_mdl, SD=1){
  
  # Sample similar coefficients
  one = c(1) #mean(cfs)
  rng = cint(rnorm(1000, one, sd=SD))
  cfs_one = sample_real(rng, E_n)
  deg_one = c(1)
  range_one = sample_pi_one_cfs(E_n, range(cfs_one)) 
  
  # Data collection
  D_one = generate_Collection_null(E_n, range_one)
  
  # Vario result
  R_one = Vario_Pi_search(D_one$D_data, deg_one, init_config_precmp(version_mdl=version_mdl))
  
  # Cfs: print(R_one$C_histories$`1-1`$E_cf)
  return(R_one)
}

simulate_pi_best = function(E_n, version_mdl, SD=1){
 deg  = c(1)
  range_best =   list(list(list(c(ceiling(E_n/2), 1,1), c(floor(E_n/2), 2,2))))
  
  # Data collection
  D_best = generate_Collection_null(E_n, range_best)
  
  # Vario result
  R_best = Vario_Pi_search(D_best$D_data, deg, init_config_precmp(version_mdl=version_mdl))
   
  return(R_best)
}

#' Simple config for precomputing run
init_config_precmp = function(version_mdl=TRUE,version_simp=TRUE){
  return(list(greedy_k=TRUE,
              meta_computing=TRUE,#important, ow not terminating
              verbose=FALSE,
              lasso=FALSE, degs_by_lasso=FALSE, version_mdl=version_mdl,version_simp=version_simp))
}

init_config_analysis = function(confints=NULL, greedy_k=FALSE, version_mdl=TRUE, version_simp=TRUE){
  config=list(greedy_k=TRUE,
       meta_computing=FALSE,#important, ow not terminating
       verbose=FALSE,
       lasso=FALSE, degs_by_lasso=FALSE ,
       greedy_k=greedy_k, version_mdl=version_mdl, version_simp=version_simp)
  if(length(confints))
    config$conf_precomputed = confints
  return(config)
}

generate_Collection_null = function(E_n, cf_range){
  D_n = 1000
  X_n = 1
  NX_n = 0
  X_degs = c(1)
  
  #-> simply E_n many coefficients from range, format list(list(list(c(E_n, range(cfs)))))
  D_one = generate_Collection(E_n, D_n, X_n, NX_n, X_degs, cf_range)
  return(D_one)
}
