
quantile_cut = function(data,  data_pooled ) {#, n_cuts=5){
  # data_pooled = pool_collection(data)
  #Yall = data_pooled$y
  Xsall = data_pooled[-length(data_pooled)]
  cuts_X = matrix(0, ncol=5, nrow=length(Xsall)) #for each X, the cuts to be used
 
  
  for (i in 1:length(Xsall)) 
    {
    #can also do equispaced based on min,max?
    cuts_X[i,]  = quantile(Xsall[[i]])
  }
  #cat(minx, ", ", maxx)
  #sep  = floor((maxx-minx)/n_cuts)
  #cuts = sapply(1:n_cuts, function(i) return(minx + (i-1)* sep))
  #cuts = c(cuts, maxx)
  
 cuts = apply(cuts_X, 2, mean)
  # be sure that contexts contain datapoints in between cuts; TODO shift cuts otherwise 
  
  for (i in 1:length(data)){
    cat("\nDataset ", i)
    Xi = data[[i]]$x1
    for(j in 1:4){
      cat("\n    ", length(intersect(which(Xi <= cuts[(j+1)]), which(Xi > cuts[j]))))
    } 
  } 
  
  
  return(cuts)
}

#TODO multiv X
slice_gp= function (#data, #
  X, y,
                    mu, Sigma, cuts){  
 # N = length(data[[1]]$y)
  N = length(X)
  assert(N==length(mu)) 
  models = list() 
  check = 0
  for (cut_i in 1:(length(cuts)-1)){ #1 is the min 

    select = intersect(which(X <= cuts[(cut_i+1)]), which(X> cuts[cut_i]))
    if(cut_i == 1) select = which(X <= cuts[(cut_i+1)])
    Xp = X[select]
 
    yp = y[select]
    mup = mu[select]
    sigmap = diag(Sigma)[select] 
    
    cat(length(mup), " ")
    check = check + length(mup)
    
    # Fitting the piecewise parametric models 
    m = lm(y ~ ., data=data.frame(x=Xp,y=mup)) # I think we should use this 
    m2 = lm(y ~ ., data=data.frame(x=Xp,y=yp)) #original data
    
    # Also find the residuals for the GP-model:
    resids_gp = yp - mup
    
    models[[cut_i]] = list(alpha = m$coefficients[-1], b = m$coefficients[1], resid =  m$residuals,
                           resids_gp = resids_gp) #sse = sum(m$residuals^2), var = var(m$residuals))

  }
  cat("=", check, "\n")
  return(models) 
}
 

#slice_gps = function (Xs, ys, res, cuts){
#  return(lapply(1:length(Xs), function(i)
#    model_ci = slice_gp(Xs[[i]], ys[[i]], res$self_preds[[i]]$mean, res$self_preds[[i]]$Sigma, cuts =cuts)))
#}


slice_gps = function (data, xi, gps, cuts){
  return(lapply(1:length(data), function(Ei)
    model_ci = slice_gp(data[[Ei]][[xi]], data[[Ei]]$y, gps[[Ei]]$mean, gps[[Ei]]$Sigma, cuts =cuts)))
}

mdl_pi = function(models_C, pi_groups, E_n, verbose =FALSE ){
  assert(sum(sapply(pi_groups, function(i) return(length(i))))==E_n)
  #data error: measure wrt to the cubic pieces. (alternatively wrt the GP mean?) in any case, locally in each context
  resids = c() 
  resids_gp = c() 
  for ( i in 1:E_n ){ 
    for (piece in models_C[[i]]) {
      resids = c(resids, piece$resid)
      resids_gp = c(resids_gp,piece$resids_gp)
    }
  } 
  cost_data = mdl_data(sum(resids^2), sigsq = var(resids), n = length(resids))
  
  if(verbose)  cat("L(D | lm(y ~ alpha X+b) in [i1, i2]) =", cost_data, "\n")
  if(verbose)  cat("L(D | GP (y~X)) =", mdl_data(sum(resids_gp^2), sigsq = var(resids_gp), n = length(resids_gp)))
   
  cost_groups = sapply(pi_groups, function(group) return(mdl_pi_group (models_C, group,verbose )))
  cost_model = sum(cost_groups)
  
  return(list(cost_data=cost_data, cost_model=cost_model, cost_groups=cost_groups, cost = cost_data+cost_model))
}

mdl_pi_group = function (models_C, group, verbose){
  if(verbose) cat("\nGROUP", paste0(group, collapse = ","))
  if(length(group)==1) alpha  =c()
  else
  alpha = matrix(0, nrow = length(group), ncol = length(models_C[[group[1]]]))

  for (i in 1:length(group)){
    mem = group[i]
    for (j in 1:length(models_C[[i]]))
      if(length(group)==1) alpha[j] = models_C[[mem]][[j]]$alpha 
      else alpha[i,j] = models_C[[mem]][[j]]$alpha 
  } 
  #mean per each piece: 
  if(length(group)>1) mus = apply(alpha, 2, mean)
  else mus = alpha
    
    cost_mus = sum(sapply(mus,function(mu) return(mdl_gauss(mu))))
    if(verbose)   cat("\n\nL(M) = L (mu=", paste0(mus,sep=","),") =",cost_mus)
    cost = 0
    for(i in group){
      cost_i = 0
      if(verbose)     cat("\n    + L(D", i, " | mu) = ", sep="")
      for (j in 1:length(models_C[[i]])) {
        alpha_ij = models_C[[i]][[j]]$alpha
        mu = mus[j]
        #Ratio
        frac_ii = max(mu/alpha_ij, alpha_ij/mu)
        cost_ii = mdl_gauss(frac_ii-1)
        #Difference
        diff_ii = abs(alpha_ij - mu)
       # cost_ii = mdl_gauss(diff_ii)
        
        
        if(verbose)    cat(" (", alpha_ij, ") ", cost_ii, sep="")
        cost_i = cost_i + cost_ii
      }
      if(verbose)    cat(" = ", cost_i) 
      cost = cost + cost_i
        
    }
    if(verbose)    cat("\n=", cost_data, "+",  + cost+ cost_mus)
    return(cost + cost_mus)
}




#mdl_gauss = function (sig, n = 1){
#  return(n/2 * (1 / ln0(2) ) * log0(2 * pi* sig))
#}

mdl_gauss = function(x, mu = 0, sig = 1){
  return(-log0(dnorm(x, mu, sig)))
}


mdl_adapt = function(A, b){
  #ignore offset (?)
  adapt = sum(apply(A, 1, sum)) + sum(b)
  return(mdl_gauss(sig = adapt , n = ncol(A)+nrow(A) + length(b)))
  
}
 
mdl_data = function (sse, sigsq, n) {
  return((1/(2*sigsq^2))*sse + n/2 * log0(2* pi * sigsq))
}
log0 = function(x) if(x==0) return(0) else return(log2(x))
ln0 = function(x) if(x==0) return(0) else return(log(x))
