# Versions to generate results for
vsn_name = function(vi){
  if(vi=="v1") return("Vario")
  if(vi=="v2") return("Vario_I")# corrected for invariant case
  if(vi=="v3") return("Vario_confI") #rejects non-conf. guessees, TODO shuffle version
  if(vi=="v4") return("Vario_conf0")
  #if(vi=="v3") return("Vario_n")
  if(vi=="v5") return("Pione")
  if(vi=="v6") return("Pitwo")
  if(vi=="v7") return("PiE")
  if(vi=="v8") return("Random")
  stop()
}
vsn_color_plot = function(vi)
{
  if(vi=="v1") return(" [thesis bll]%")
  if(vi=="v2") return(" [thesis greenl]%")
  if(vi=="v3") return(" [thesis yelll]%")
  if(vi=="v4") return(" [thesis yelll, dashed]%")
  if(vi=="v5") return(" [dotted, gray]%")
  if(vi=="v6") return(" [dashed, gray]%")
  if(vi=="v7") return(" [dashdotted, gray]%")
  if(vi=="v8") return(" [gray]%")
}

vsn_name_plot = function(vi)
{
  if(vi=="v1") return("$\\OM$")
  if(vi=="v2") return("$\\OM_I$")
  if(vi=="v3") return("$\\OM_{CI}$")
  if(vi=="v4") return("$\\OM_{C0}$")
  if(vi=="v5") return("$\\PI_I$")
  if(vi=="v6")return("$\\PI_2$")
  if(vi=="v7") return("$\\PI_0$")
  if(vi=="v8")return("$\\PI_x$")
}
vsns_todo = function(config){
  vsns =  list("v1", "v2", "v3", "v4", "v5", "v6", "v7", "v8")
  if(length(config$Versions)) {
    sapply(config$Versions, function(i) assert(i %in% vsns))
    return (config$Versions)}
  return (vsns)

  #return(lapply(seq_along(vsns), function(vi) 
   # return(list(type=vsns[[vi]], name=vsn_name(vi)))))
}


result_by_version = function(Result, vsn){
  #if(vsn=="v3") print(as.list(Result$C_histories)[[1]]$E_cf) # with confidence based on random sampling (k=1)
  
  # Varios results: best in the rankings
  if(vsn=="v1") return(Result$Pi_ranking_raw[[1]]$E_part)
  if(vsn=="v2") return(Result$Pi_ranking_correctone[[1]]$E_part) # with ftest invariance
  if(vsn=="v3") return(Result$Pi_ranking[[1]]$E_part) # with confidence based on random sampling (k=1)
  if(vsn=="v4") return(Result$Pi_ranking_nogroup[[1]]$E_part) # with confidence based on equidist.sampling (k=5)
  #TODO version shuffling
  #if(vsn=="v5") return(Result$Pi_ranking_conf[[1]]$E_part) 
  #if(vsn=="v3") return(Result$Pi_ranking_nscaled[[1]]$E_part) #Vario_n
  E_n = Result$E_n
  if(vsn=="v5") return(random_pi(E_n, k = 1))# same as return(rep(1,Result$E_n))
  if(vsn=="v6") return(random_pi(E_n, k = 2))
  if(vsn=="v7")  return(random_pi(E_n, k = E_n))# same as return(c(1:Result$E_n))
  if(vsn=="v8") return(random_pi(E_n))
  
  stop()
}

random_pi = function(E_n, k=NULL){
  if(!length(k))
    k = sample.int(  E_n, 1)
 
  if(k>E_n|k<1) stop()
 
  shapes = sample_shapes_ineff(E_n, 100, #max pi 
                               perm = TRUE, flatten = TRUE)
  shapes = shapes[which(sapply(shapes, function(i) return(length(i))) ==k )]
  return(shape_to_part(shapes[[sample.int(length(shapes), 1)]]))
}



ranking_by_version = function(Result, vsn){
  # Varios results: best in the rankings
  if(vsn=="v1") return(Result$Pi_ranking_raw)
  if(vsn=="v2") return(Result$Pi_ranking_correctone) # with ftest invariance
  if(vsn=="v3") return(Result$Pi_ranking) # with confidence
  #if(vsn=="v3") return(Result$Pi_ranking_nscaled[[1]]$E_part) #Vario_n
  
  stop("TODO")
}

# ------

# vsns_todo = function(config)
#   
#   return(lapply(list("v1", "v2", "v3", "v4", "v5", "v6"), function(v) 
#                   return(list(type=v, name=vsn_name(v)))))
# 
# 
# vsn_name = function(vsn, deg=NULL){ #TODO put in deg
#   v4_nm = "clust_Kmns_gap"
#   if(length(deg) && deg==1) 
#       v4_nm = "Kmeans_1D"
# 
#   return(ifelse(vsn=="v1", "clust_GMM_Bic", 
#                 ifelse(vsn=="v2", "score_MDL_equi",
#                        ifelse(vsn=="v3", "clust_GMM_MDL",
#                               ifelse(vsn=="v4", v4_nm, 
#                                     #main scores: 
#                                      ifelse(vsn=="v5", "score", ifelse(vsn=="v6" , "score_confused", stop())))))))
# }



# update counter ------
init_counter = function (vsns = 2) {
  return(matrix(0, nrow = vsns, ncol = 6))  
}

init_counter_row = function() {
  rep(0, 6)
}

up_partition_counter = function() {
  
} #TODO

up_model_counter = function() {
  
} #TODO


# update csv table ------
initial_frame = function (D_n,
                          Xi_n,
                          NXi_n,
                          inter_rng,
                          intra_rng,
                          cf_min,
                          cf_max) {
  return(data.frame(
    D = c(D_n),
    Xi = c(Xi_n),
    Xi_noise = c(NXi_n),
    G_gap = clld(inter_rng, d = 0),
    G_err = clld(intra_rng, d = 0),
    degree = ifelse(cf_min == cf_max, clld(cf_min, d = 0), clld(c(cf_min, cf_max), d = 0))
  ))
}


accuracy_frame = function(counter, 
                          shape_nm, 
                          group_n, linear, 
                          V_n = 2) {
  
  Versions = list()#sapply(1:V_n, function(vi) return(vsn_name(vi)))
 
  # Accuracy matrix
  mat = apply(counter, 1, function(v) {
    
    # Accuracies Partitions exactly matched
    pct_P = ifelse((v[1] + v[2]) == 0, 0,
                   v[1] / (v[1] + v[2]) * 100)
    
    # Accuracies Environment to Group 
    pct_D = ifelse((v[5] + v[6]) == 0, 0, 
                   v[5] / (v[5] + v[6]) * 100)
    
    return (c(paste(v[1], paste("/", (v[2] + v[1]), sep = ""), sep = ""),
      fmtd(pct_P, 1),
      paste(v[5], paste("/", (v[5] + v[6]), sep = ""), sep = ""),
      fmtd(pct_D, 1)
    ))
  })
  results = data.frame(
    Version = Versions,
    Group_N = rep(paste(group_n, collapse = ""), V_n),
    Groups_len = rep(shape_nm, V_n),
    Part_cor = mat[1, ],
    Part_pct = mat[2, ],
    Env_cor = mat[3, ],
    Env_pct = mat[4, ]
  )
  return(results)
  
}







# out -----


out_which_vsn = function (greedy, vsn, all) {
  ifelse(vsn == "v1",
         ifelse(greedy, "V1.G",  "V1.S"),
         ifelse(
           vsn == "v2",
           ifelse (greedy, "V2.G", "V2.S"),
           ifelse(
             vsn == "v3",
             ifelse (greedy, "V3.G", "V3.S"),
             ifelse(
               vsn == "v4",
               ifelse (greedy, "V4.G", "V4.S"),
               ifelse (
                 vsn == "v5",
                 ifelse(greedy, "V5.G", "V5.S"),
                 ifelse(vsn ==
                          "v6", ifelse(greedy, "V6.G", "V6.S"), stop(vsn))
               )
             )
           )
         ))
}



# not used ----
out_mat = function (which1, corr_missed, f, result_f, debug) {
  sapply(1:nrow(corr_missed), function (i) {
    which = ifelse(i == 1, "V1.G", ifelse(i == 2, "V1.S",
                                          ifelse(
                                            i == 3, "V2.G", ifelse(i == 4, "V2.S",
                                                                   ifelse(
                                                                     i == 5, "V3.G", ifelse(i == 6, "V3.S",
                                                                                            ifelse(
                                                                                              i == 7, "V4.G", ifelse(i == 8, "V4.S", stop())
                                                                                            ))
                                                                   ))
                                          )))
    
    which = paste(paste(which, out_br(which1)), ": ", sep = "")
    out_corr_missed (which, corr_missed[i, ], f, result_f, debug)
  })
}

out_corr_missed = function (which, corr_missed, f, result_f, debug) {
  corr = corr_missed[1]
  missed = corr_missed[2]
  corr_Di = corr_missed[3]
  missed_Di = corr_missed[4]
  all = corr + missed
  all_Di =  corr_Di + missed_Di
  
  pct = corr / all * 100
  pct_Di = corr_Di / all_Di * 100
  
  if (debug)
    out(
      which,
      "\tCorrect G",
      fmtd(corr, 0),
      "\tMissed G" ,
      fmtd(missed, 0),
      "\t%",
      fmtd(pct, 2),
      "\tCorrect D",
      fmtd(corr_Di, 0),
      "\tMissed D" ,
      fmtd(missed_Di, 0),
      "\t%",
      fmtd(pct_Di, 2),
      f = f
    )
  
  
  #out( which, "\n\tCorrect G: ", fmtd(corr, 0), "/", fmtd(all, 0), #"\tMissed: ", fmtd(missed,0), "/", fmtd(all, 0),
  #    "\tFraction: ", fmtd(pct,2), "%",
  #   "\n\tCorrect D: ", fmtd(corr_Di, 0), "/", fmtd(all_Di, 0), #"\tMissed: ", fmtd(missed_Di,0), "/", fmtd(all_Di, 0),
  #  "\tFraction: ", fmtd(pct_Di,2), "%", ln = "", f=result_f)
  out(
    which,
    "\tCorrect G",
    fmtd(corr, 0),
    "\tMissed G" ,
    fmtd(missed, 0),
    "\t%",
    fmtd(pct, 2),
    "\tCorrect D",
    fmtd(corr_Di, 0),
    "\tMissed D" ,
    fmtd(missed_Di, 0),
    "\t%",
    fmtd(pct_Di, 2),
    f = result_f
  )
}
