
setwd("~/Vario/R")
library(devtools) 
load_all() 


runs = 20

version_mdl=TRUE
tp = 0
fp = 0
fn = 0
variables_considered =  0

# precompute
confints = list(conf_pione=sample_conf_pi_one(5, 50, vb=FALSE, version_mdl=TRUE),
                conf_nogroups= sample_conf_nogroups(5, 50, vb=FALSE, version_mdl=TRUE),
                conf_best=sample_conf_pi_best(5, 50, vb=FALSE, version_mdl=TRUE))


for (seed in 1:runs){
  # Generate example DAG with data over C_n contexts--------------------
  DAG = gen_rand_dag(interv_type=interv_type,
                     out_p=0.3,seed = seed, vb =FALSE)
  
  # Run Vario on each Variable--------------------
  res = run_vario_rand_dag(DAG$D1_Dn, DAG$dag, DAG$targets_node_to_context, confints)
  
  tp = tp + res$counts[1]
  fp = fp + res$counts[2]
  fn = fn + res$counts[3]
  variables_considered  = variables_considered +  res$counts[4]
}


