% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vario_G.R
\name{Vario_G_search}
\alias{Vario_G_search}
\title{VarioG for causal DAG discovery
Given data \code{\{X_e\}}, in each context, 
find causal parents and partition for each target Y, \code{Y = f_{PI}(pa(Y))+N}  
then find a DAG, removing ancestral paths}
\usage{
Vario_G_search(
  D,
  X_names,
  X_max_n = 4,
  it_n = 500,
  it_pre = 50,
  greedy_k = FALSE,
  vb = TRUE,
  target_nm = "y",
  confints = NULL,
  version_mdl = TRUE,
  version_simp = TRUE
)
}
\arguments{
\item{D}{list: \code{C -> \{X_e\}} for each context C}

\item{X_names}{(for display) covariates X names}

\item{X_max_n}{max. length of subsets of X to consider. default is 4.}

\item{it_n}{alt. to max. number of subsets, restrict iterations}

\item{it_pre}{rounds of precomputing to find confidence intervals}

\item{greedy_k}{greedy pi search}

\item{vb}{verbose}

\item{target_nm}{(for display) target Y name}

\item{confints}{(opt.) if precomputed already}
}
\value{
\code{resultVario} class summarizing results
}
\description{
VarioG for causal DAG discovery
Given data \code{\{X_e\}}, in each context, 
find causal parents and partition for each target Y, \code{Y = f_{PI}(pa(Y))+N}  
then find a DAG, removing ancestral paths
}
