% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vario_causal.R
\name{Vario_subset_search}
\alias{Vario_subset_search}
\title{Main Algorithm:
Given data \code{\{X_e, Y_e\}},  in each context, 
find causal parents and partition in \code{Y = f_{PI}(pa(Y))+N}}
\usage{
Vario_subset_search(
  D_E1_En,
  X_names,
  X_max_n = 4,
  it_pre = 50,
  it_n = NULL,
  greedy_k = FALSE,
  vb = TRUE,
  target_nm = "y",
  confints = NULL,
  version_mdl = TRUE,
  version_simp = TRUE
)
}
\arguments{
\item{X_names}{(for display) covariates X names}

\item{X_max_n}{max. length of subsets of X to consider. default is 4.}

\item{it_pre}{rounds of precomputing to find confidence intervals}

\item{it_n}{alt. to max. number of subsets, restrict iterations}

\item{greedy_k}{greedy pi search}

\item{vb}{verbose}

\item{target_nm}{(for display) target Y name}

\item{confints}{(opt.) if precomputed already}

\item{data_E1_En}{list: \code{E -> \{X_e, Y_e\}}}
}
\value{
\code{resultVario} class summarizing results
}
\description{
Main Algorithm:
Given data \code{\{X_e, Y_e\}},  in each context, 
find causal parents and partition in \code{Y = f_{PI}(pa(Y))+N}
}
\details{
calls \code{Vario_Pi_search}; creates & updates \code{cls_subset_search}
}
