% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cls_pi_search.R
\docType{class}
\name{cls_pi_search-class}
\alias{cls_pi_search-class}
\alias{cls_pi_search}
\title{Class for \code{Vario_Pi_search}.}
\description{
Class for \code{Vario_Pi_search}.
}
\details{
Records results for one subset \code{\{X1,...Xm\}} and one functional form \code{Y=f(X1,...Xm; varphi_1,...varphi_m)}. 
Search goes over all varphi_i to find them a partition Pi. Result is a Ranking of candidates Pi.
}
\section{Fields}{

\describe{
\item{\code{Data_E1_En,Dstd_E1_En}}{Data,Data standardized; list: \code{E -> (X1,..Xm, Y)}}

\item{\code{Cf_X_E1_En}}{regression coefficients; list: \code{X_i ->} mat: \code{E_j, varphi_ik} at ik}

\item{\code{lconf,rconf,pval}}{as Cf_X_E1_En with resp. conf.interval,pval.}

\item{\code{Pi_histories,C_histories}}{subclasses, information about a single partition/coefficient}

\item{\code{Pi_ranking}}{main result}

\item{\code{Pi_ranking_raw,Pi_ranking_nogroup,Pi_ranking_nscaled,Pi_ranking_correctone}}{test versions}

\item{\code{htest_invariant}}{different hypothesis tests on whether varphi are invariant}
}}


\examples{
Classes overview:
cls_subset_search (one target Y, all subsets X), cls_result
> cls_pi_search (one subset, all partitions) 
> cls_pi (one partition, all coefficients) 
> cls_varphi (one coefficient) 
}
