% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gen_DAG_Y.R
\name{generate_DAG_datasets}
\alias{generate_DAG_datasets}
\title{Generates DAG and for each target variable Y in it: a dataset with samples in all contexts, where Y=f^{Pi}(X) and X are Gaussian noise variables}
\usage{
generate_DAG_datasets(
  E_n = 5,
  D_n = 1000,
  shape = c(4, 1),
  shape_ch = c(1, 1, 1, 1, 1),
  interv_X_n = c(3, 5),
  perfect_interventions = TRUE,
  interv_future = FALSE,
  inter = c(1, 2),
  noise = c(0, 0.1),
  node_n = 10,
  deg_p = 0.3,
  seed = 100,
  subdir_nm = "Example",
  show_context_coefficients = FALSE,
  one_intervention_per_context = TRUE,
  skip_no_parent_nodes = FALSE,
  vb = TRUE,
  write_data = FALSE
)
}
\arguments{
\item{E_n}{num contexts}

\item{D_n}{num samples/context}

\item{shape}{partition pi (no gaps) for f^{pi}: pa(Y)->Y. length = num groups, entry=size groups.}

\item{interv_X_n}{interval: how many interventions on X over contexts}

\item{node_n}{DAG num nodes}

\item{deg_p}{DAG out prb}

\item{interv_Y_ty}{intervention type in all but the first group (observational). 1 means parameter changes, 2 means shift intervention.}
}
\description{
Generates DAG and for each target variable Y in it: a dataset with samples in all contexts, where Y=f^{Pi}(X) and X are Gaussian noise variables
}
