# This script is based on the simple example of UT-IGSP by Squires et al.

from causaldag import unknown_target_igsp
import causaldag as cd
import numpy as np
import random
from causaldag import partial_correlation_suffstat, partial_correlation_test
from causaldag import gauss_invariance_suffstat, gauss_invariance_test, MemoizedInvarianceTester, MemoizedCI_Tester
import os
from numpy import genfromtxt

print("Make sure that Data is in out/synthetic_graphs_utigsp/ by running generate_DAG_linear.R first." )
## RUN AFTER generating data with run_vario_DAG_linear.R
# so that can read from:
#  Vario/out/synthetic_graphs_utigsp/A_diagonal_shift/'
#  Vario/out/synthetic_graphs_utigsp/B_groups_shift/'
#  Vario/out/synthetic_graphs_utigsp/E_mgroups_changes/'
#  Vario/out/synthetic_graphs_utigsp/G_2hard_interventions/'

## SPECIFY DIRECTORIES
# customize

directory = os.fsencode('Vario/out/synthetic_graphs_utigsp/A_diagonal_shift/')
indirectory = 'Vario/out/synthetic_graphs_utigsp/A_diagonal_shift/' 
outdirectory ='Vario/out/synthetic_out_utigsp/A_diagonal_shift/'


for i in range(51):
     if i==0:
          continue
     print(i)
     for file in os.listdir(directory):
          filename = os.fsdecode(file)
          if filename.startswith(str(i)):  
               if filename.endswith("c1.csv"): 
                    fullname =  os.path.join(indirectory,filename)
                    obs = genfromtxt(fullname, delimiter = ",")
                    c1 = obs[1:,] 
 
     for file in os.listdir(directory):
          filename = os.fsdecode(file)
          if filename.startswith(str(i)):  
               if filename.endswith("c2.csv"): 
                    fullname =  os.path.join(indirectory,filename)
                    obs = genfromtxt(fullname, delimiter = ",")
                    c2 = obs[1:,] 
 
     for file in os.listdir(directory):
          filename = os.fsdecode(file)
          if filename.startswith(str(i)):  
               if filename.endswith("c3.csv"): 
                    fullname =  os.path.join(indirectory,filename)
                    obs = genfromtxt(fullname, delimiter = ",")
                    c3 = obs[1:,] 
 
     for file in os.listdir(directory):
          filename = os.fsdecode(file)
          if filename.startswith(str(i)):  
               if filename.endswith("c4.csv"): 
                    fullname =  os.path.join(indirectory,filename)
                    obs = genfromtxt(fullname, delimiter = ",")
                    c4 = obs[1:,]  
 
     for file in os.listdir(directory):
          filename = os.fsdecode(file)
          if filename.startswith(str(i)):  
               if filename.endswith("c5.csv"): 
                    fullname =  os.path.join(indirectory,filename)
                    obs = genfromtxt(fullname, delimiter = ",")
                    c5 = obs[1:,]  
 
     nnodes = obs.shape[1]
     nodes = set(range(nnodes))
     obs_samples = c1
     iv_samples_list = [c2,c3,c4,c5]
     obs_suffstat = partial_correlation_suffstat(obs_samples)
     invariance_suffstat = gauss_invariance_suffstat(obs_samples, iv_samples_list)
# Create conditional independence tester and invariance tester
     alpha = 1e-3
     alpha_inv = 1e-3
     ci_tester = MemoizedCI_Tester(partial_correlation_test, obs_suffstat, alpha=alpha)
     invariance_tester = MemoizedInvarianceTester(gauss_invariance_test, invariance_suffstat, alpha=alpha_inv)
# Run UT-IGSP
     num_targets = 5
     num_settings = 4
     targets_list = [random.sample(nodes, num_targets) for _ in range(num_settings)]
     print(targets_list)
     setting_list = [dict(known_interventions=[]) for _ in targets_list]
     est_dag, est_targets_list = unknown_target_igsp(setting_list, nodes, ci_tester, invariance_tester)
     import ipdb;ipdb.set_trace()
     print(est_targets_list)  
 
     with open(outdirectory+str(i)+'-out.txt','w') as f:
          for val in est_dag.arcs:
               print(str(val[0])+","+str(val[1]),file = f)

