
test_that("test_gen_DAG_weights_Pi",{ #test for one or no group/exact inter (no ) / values scaled into [0.25,1]
    for (E_n in 2:5){ 
      for (X_n in 1:3){
      shapes = sample_shapes(E_n, 50, incl_one_group = TRUE, incl_no_group = TRUE, mx_n_groups=E_n)
      for(shape in shapes){
        g = gen_DAG_weights_Pi(X_n,shape,c(0,0.1),c(1,1.2)) 
        expect_equal(ncol(g),X_n )
        expect_equal( nrow(g),E_n)
        apply(g,1:2, function(i) {
          expect_false(is.na(i))
          expect_true(i>=0.25 & i<=1)
          })
        
        g = gen_DAG_weights_Pi(X_n,shape,c(0,0),c(1,1)) 
        expect_equal(ncol(g),X_n )
        expect_equal( nrow(g),E_n)
        apply(g,1:2, function(i){ expect_false(is.na(i)) 
          expect_true(i>=0.25 & i<=1) 
          })
      }
    }}
})


test_that("get_MB",{ 
  for (node_n in 2:5){   
      adj = generate_DAG(node_n, 0.6)
      for (node_j in 1:ncol(adj)){
        
        mb = get_MB(adj, node_j)
        for (i in 1:length(mb$mb)){ #ordered indices
          node_i = mb$mb[i] #original index in graph 
          if(i %in%  mb$pa_ind) expect_true(node_i %in% which(adj[,node_j]==1)) #pa ind: end point of parents
          if(i %in%  mb$ch_ind) expect_true(node_i %in% which(adj[node_j,]==1)) 
          if(i %in%  mb$non_h_ind) expect_false(node_i %in% which(adj[node_j,]==1))  
        }
      }
  }     
       
})




